ASMB,R,L,B,T,C   ***  BCS  RELOCATING  LOADER  ***
      HED ***  BCS  RELOCATING  LOADER  *** 
      NAM LOADR 
*   THIS VERSION LOADS OBJECT PROGRAMS PRODUCED 
*    BY THE ALGOL COMPILER. 
      SPC 1 
*   THIS VERSION IS NOT INTENDED FOR 4K 
*    SYSTEMS BECAUSE OF THE ADDITIONAL CODE 
*    TO HANDLE ALGOL PROGRAMS AND LIBRARY 
*    LOADING FROM MAGNETIC TAPE.
      SPC 1 
*   THIS VERSION OF THE LOADER TAKES SPECIAL
*    ADVANTAGE OF A MAGNETIC TAPE UNIT FOR
*    LOADING FROM THE PROGRAM LIBRARY. THE
*    RELOCATABLE BINARY RECORDS OF THE LIBRARY
*    PROGRAMS ARE ASSUMED TO BE FULLY CONTAINED 
*    IN THE SECOND FILE OF THE MAGNETIC TAPE. 
      SPC 1 
*     --- THE LIBRARY IS NOT REQUIRED TO
*         BE ON MAGNETIC TAPE.
      SPC 2 
* THIS IS A MODULE OF THE HP-2116  BASIC CONTROL
*  SYSTEM  (BCS)  SOFTWARE PACKAGE. 
      SPC 1 
* THE FUNCTION OF THE LOADER IS TO LOAD AND LINK
*  RELOCATABLE OBJECT PROGRAMS PRODUCED BY THE
*  ASSEMBLER AND FORTRAN COMPILER SYSTEMS.
      SPC 1 
* OBJECT (BINARY-FORMAT) PROGRAMS ARE LOADED IN 
*  A -PAGE FREE- MANNER  IN THAT A PROGRAM MAY CROSS
*  A PAGE OR MODULE BOUNDARY AT ANY POINT. REFERENCES 
*  TO OPERANDS LOCATED IN A PAGE OTHER THAN THE 
*  INSTRUCTION PAGE ARE COMPLETED BY ESTABLISHING 
*  A WORD IN BASE PAGE TO CONTAIN THE FULL 15-BIT 
*  ADDRESS OF THE OPERAND. THE INSTRUCTION WORD IS
*  ALTERED TO INDIRECTLY REFERENCE THE WORD IN
*  BASE PAGE TO ADDRESS THE OPERAND.
      SPC 1 
* REFER TO THE BCS LOADER -EXTERNAL DESIGN SPEC-
*  IFICATIONS FOR DESCRIPTIONS OF RECORD FORMATS, 
*  MEMORY ALLOCATION, DIAGNOSTICS, ETC. 
      SPC 2 
      ENT .LDR.,HALT,.MEM.,LST
      SKP 
*****  LST  -  LOADER SYMBOL TABLE  ******* 
      SPC 1 
* THE FIXED (OR SYSTEM) SEGMENT OF THE LST
*  MUST APPEAR IN THIS SECTION. THE TABLE IS
*  CONSTRUCTED IN REVERSE ORDER, I.E. EXTENDING 
*  TOWARDS LOW MEMORY.
      SPC 1 
* A FIXED ENTRY IS CONSTRUCTED AS:
      SPC 1 
*                 EXT SYMBL 
*      WORD 5 -   OCT 0   (HOLDS LINK ADDRESS)
*           4 -   DEF SYMBL  (HOLDS ENT ABSOLUTE ADDR)
*           3 -   OCT XX000  CHAR 5 FOLLOWED BY ZER0S 
*           2 -   ASC 1,  CHARS 3,4 OF NAME 
*           1 -   ASC 1,  CHARS 1,2 OF NAME 
      SPC 1 
* WORDS 4 AND 5 ARE SET BY "PCS" DURING SYSTEM CONSTRUCTION.
      SPC 1 
* NEW ENTRIES MAY BE ADDED AT THIS POINT. 
      SPC 1 
.LWA. OCT 000000
      DEF HALT
      OCT 020000
      ASC 1,LT
      ASC 1,HA
      SPC 1 
      EXT .BUFR 
      OCT 0        DEFINE 
      DEF .BUFR     FOR  I O C
      OCT 51000      ENTRY POINT
      ASC 1,UF       -.BUFR-
      ASC 1,.B
      SPC 1 
* NO EXT FOR .MEM.  (LOADER ENTRY POINT)
      OCT 0 
      DEF .MEM.    DEFINE 
      OCT 27000     FOR LDR ENTRY POINT 
      ASC 1,EM     - .MEM. -
      ASC 1,.M
      SPC 1 
      EXT .SQT. 
      OCT 0         DEFINE
      DEF .SQT.     FOR 
      OCT 27000     -.SQT.- 
      ASC 1,QT       FOR IOC SYSTEM 
      ASC 1,.S        EQUIPMENT TABLE.
      SPC 1 
      EXT .IOC. 
      OCT 0       DEFINES ENTRY 
      DEF .IOC.     POINT TO
      OCT 27000     INPUT/OUTPUT CONTROL
      ASC 1,OC
      ASC 1,.I     .IOC.
      SPC 1 
LST   DEC 5         HOLDS NUMBER OF FIXED ENTRIES.
      SPC 1 
*****  END     L S T   *******
      SKP 
****  ABSOLUTE  RECORD OUTPUT SECTION ****
      SPC 1 
* THIS IS THE MAIN SECTION OF THE ABSOLUTE RECORD 
*  OUTPUT  OPTION.  THIS OPTION PROVIDES FOR
*  SIMULATED LOADING AND PRODUCING A BINARY TAPE
*  OF ALL LOADED PROGRAMS AND LINKAGE AREA. THE 
*  TAPE IS THEN LOADED BY THE BASIC BINARY
*  LOADER. THE PURPOSE OF THIS OPTION IS TO 
*  ALLOW FOR LOADING PROGRAMS INTO THE MEMORY 
*  OCCUPIED BY THE RELOCATABLE LOADER. THIS 
*  OPTION IS USEFUL IN A  4K MEMORY CONFIGURATION 
*  OR IN A LARGER CONFIGURATION WHERE MEMORY
*  OVERFLOW ABORTS LARGE PROGRAM LOADING. 
      SPC 1 
* IF THIS OPTION IS NOT SELECTED, THE MEMORY
*  OCCUPIED BY THE SECTION IS RELEASED DURING 
*  LOADER INITIALIZATION... THE FIXED PORTION 
*  OF THE LOADER-SYMBOL-TABLE IS MOVED UP TO
*  START AT  THE LOCATION   LDRIN-1.
      SPC 1 
ABREC OCT 0 
      BSS 48   BUFFER FOR ABSOLUTE RECORD 
      SPC 1 
* SUBROUTINE   PACK 
      SPC 1 
* CALLING SEQUENCE: 
      SPC 1 
*         (A) = RELOCATED DATA/INSTRUCTION WORD 
*           (P)     JSB PACK
*           (P+1)   -SKIPPED
*           (P+2)  -RETURN--- 
      SPC 1 
PACK  NOP 
      STA ABL1,I    STORE WORD AT NEXT LOCATION 
      ISZ ABL1       IN BUFFER, INCREASE ADDRESS. 
      ADA CKS       ADD WORD TO CHECKSUM
      STA CKS        AND RESTORE WORD 
      ISZ ABREC     COUNT WORD
      ISZ PACK      ADJUST RETURN TO P+2
      JMP PACK,I    AND EXIT. 
      SPC 1 
* SUBROUTINE:  PUNCH
      SPC 1 
* CALLING SEQUENCE: (P)    JSB PUNCH
*                   (P+1)  -RETURN- A,B DESTROYED 
      SPC 2 
PUNCH NOP          ENTRY/EXIT 
      LDA CKS       ADD LOAD ADDRESS TO CHECK-SUM 
      ADA ABREC+1    AND SET RECORD SUM 
      STA ABL1,I      IN LAST WORD OF RECORD. 
      LDA ABREC     ADD 2 TO RECORD WORDCOUNT 
      ALF,ALF         POSITION AS FIRST CHAR. AND 
      STA ABREC        SET. 
      ALF,ALF      REPOSITION, ADD 3 FOR TOTAL
      ADA C.03      LENGTH AND SET FOR
      STA PABL1+4   LENGTH OF OUTPUT. 
PABL1 JSB .IOC.     CALL  IOC TO PUNCH
      OCT 21104     ABSOLUTE BINARY 
      JMP PABL1       RECORD ON 
      DEF ABREC        SYSTEM PUNCH DEVICE
      OCT 0         (HOLDS RECORD LENGTH) 
PABL2 JSB .IOC.     CALL  IOC FOR 
      OCT 40004      DEVICE 
      SSA             STATUS- 
      JMP PABL2       WAIT UNTIL READY
      AND M.40     CHECK FOR POSSIBLE 
      SZA,RSS       TAPE-SUPPLY-LOW CONDITION 
      JMP PCH2     NO.
      JSB LTG      TAPE-SUPPLY-LOW. GENERATE TRAILER
      HLT 66B         HALT.  ON RESTART,
      JSB LTG      GENERATE LEADER. 
PCH2  STA ABREC     INITIALIZE FOR
      STA CKS        NEXT 
      LDA ABL2        RECORD
      STA ABL1         OUTPUT 
      JMP PUNCH,I  EXIT-
      SPC 2 
* SUBROUTINE:  LTG (LEADER/TRAILER GENERATOR) 
      SPC 1 
LTG   NOP 
      LDA CM.46 
      STA ABREC+1 
      CLA 
      STA ABREC    CLEAR ABREC
.LTG. JSB .IOC.    PUNCH  47
      OCT 21104     WORDS 
      JMP *-2        OF 
      DEF ABREC       ZEROS 
      DEC 1         FOR LEADER/TRAILER. 
      JSB .IOC.     WAIT
PLK6  OCT 40004      FOR
      SSA             OUTPUT
      JMP *-3          TO BE COMPLETED, 
      ISZ ABREC+1 
      JMP .LTG. 
      CLA           ENTER: A=0. 
      JMP LTG,I         EXIT. 
      SPC 1 
CKS   OCT 0         HOLDS COMPUTED CHECKSUM 
ABL1  DEF ABREC+2   HOLDS CURRENT BUFFER ADDRESS
ABL2  DEF ABREC+2 
CM.46 DEC -46 
      SKP 
**  ROUTINE :   PLINK 
      SPC 1 
*   THIS ROUTINE IS ENTERED FROM THE END-OF-LOADING 
*    SECTION AND PERFORMS THE FOLLOWING:
      SPC 1 
*     1. PUNCHES THE USER LINKAGE AREA
*     2. PUNCHES IOC AND ALL I/O DRIVERS, 
*         INCLUDING THE MEMORY TABLE. 
*     3. STORES A  JMP 3,I  IN -2-, STORES THE
*         EXECUTION POINT ADDRESS IN 3,  AND
*         PUNCHES THE INTERRUPT AND SYSTEM
*         LINKAGE AREA,  INCLUDING WORDS 2 AND 3. 
*     4. WRITES THE ENTRY POINT LIST ON THE 
*         ABSOLUTE BINARY TAPE PRODUCED 
*         DURING LOADING. 
      SPC 2 
PLINK LDA LWABP    SKIP IF
      CPA M1777     NO LINKAGE AREA ESTABLISHED 
      JMP PL1        DURING LOADING.
      INA          SET LINKAGE
      STA PLK1      AREA BOUNDS 
      LDA M2000      AND
      JSB PLK         USER LINKAGE AREA.
PL1   JSB .IOC. 
      OCT 000003
      LDA .DEF.     SET PLK1 TO MEMORY TABLE ADDRESS. 
      STA PLK1       (I.E.  .MEM.-1)
      LDA LWAM1 
      INA 
      LDB .JSB. 
      SLB,RSS 
      AND M076
      SLB           OPERATING UNDER "MTS"?
      JMP PNCH      NO, GO PUNCH ABSOLUTE AREA. 
      ABS 064106B 
      STB .106.     SAVE MTS RETURN ADDRESS.
      LDB LWA       LOAD POINTER TO EXTRA HALT. 
      ABS 074106B 
PNCH  JSB PLK    -- PUNCH IOC/DRIVERS/ETC/MEM TABLE.
      LDA JMP3     SET (2) =  JMP  3,I
      STA 2 
      LDA C.02     PUNCH AREA FROM  2  TO 
      STA PLK1      (PLK4) FOR INTERRUPT LOCATIONS
      LDA PLK4       AND SYSTEM LINKAGE AREA. 
      JSB PLK 
      JSB LTG      GENERATE TRAILER.
      LDA PLK5     SET UNIT-REFERENCE IN -LOUT- 
      STA LOUT0     TO REFERENCE UNIT 4 
      LDA PLK6
      STA LOUT4 
      CLB          CLEAR POSSIBLE HALTS IN
      STB OPT.5     LOUT. 
      STB OPT.6 
      JSB EPL      PUNCH LOADER SYMBOL TABLE. 
      JSB LTG      GENERATE FINAL TRAILER - 
      LDA LOUT7+1 
      STA LOUT0 
      LDA LOUT5+1 
      STA LOUT4 
      LDA .JSB. 
      SLA 
      JMP .LST
      LDA .106.     LOAD POSSIBLE "MTS" RETURN ADDRESS. 
      ABS 070106B   STA 00106B
      SPC 1 
* CHECK FOR LST TO BE PRINTED.
      SPC 1 
.LST  JSB ENDPR     GO PROCESS "LST" AND EJECT. 
      LDA ENDM     PRINT MESSAGE
      LDB C.04      - *END -
      JSB LOUTL 
      JMP HALT
      SPC 2 
ENDM  DEF *+1 
      ASC 2,*END
      SPC 2 
PLK   NOP 
      STA PLK3
PL2   LDA CM.45    INITIALIZE COUNTER 
      STA PLK2      FOR MAX. BLOCK SIZE OF 45 WORDS.
      LDA PLK1     STORE LOAD ADDR. OF BLOCK
      STA ABREC+1   IN WORD 2 OF BUFFER.
PL3   LDA PLK1,I   STORE CURRENT BLOCK
      JSB PACK      WORD IN BUFFER. 
MDULE STA A         4K MEMORY MODULE MASK.
      ISZ PLK1     ADD 1 TO CURRENT BLOCK ADDR. 
      LDA PLK1     IF CURRENT BLOCK 
      CPA PLK3      TERMINATED, GO TO 
      JMP PL4        PUNCH LAST BLOCK.
      ISZ PLK2     INDEX COUNTER. 
      JMP PL3       BUFFER NOT FILLED.
      JSB PUNCH    BUFFER FILLED - PUNCH
      JMP PL2       FILL NEXT BUFFER. 
PL4   JSB PUNCH    PUNCH LAST BUFFER -
      JMP PLK,I     EXIT. 
      SPC 2 
PLK1  NOP      HOLDS FWA PUNCH AREA 
PLK2  NOP      HOLDS BUFFER INDEX 
PLK3  NOP      HOLDS LWA+1 PUNCH AREA 
PLK4  NOP      HOLDS LWA+1 OF SYSTEM LINK AREA
PLK5  OCT 021004    PUNCH DEVICE UNIT-REFERENCE.
CM.45 DEC -45 
M7700 OCT 017700
JMP3  JMP 3,I 
LWA   DEF .106.     STAND-ALONE HALT ADDRESS. 
      SPC 1 
** END OF  ABSOLUTE RECORD SECTION ********** 
      SKP 
**** LOADER  * MAIN CONTROL SECTION *  **** 
      SPC 1 
*  THIS SECTION CONTROLS THE INPUT OF OBJECT
* PROGRAMS FROM THE STANDARD INPUT AND PROGRAM
* LIBRARY DEVICES. THE TRANSFER OF CONTROL TO 
* THE APPROPRIATE RECORD PROCESSORS IS MADE 
* FROM THIS SECTION. EACH PROCESSOR (EXCEPT 
* NAM PROCESSOR) RETURNS TO THE LABEL -LDRIN-.
      SPC 2 
* INPUT RECORD, LEGALITY CHECK AND CHECKSUM SECTION 
      SPC 1 
LDRIN JSB .IOC.    CALL  *IOC* TO INPUT 1 RECORD
IN.1  OCT 10305     IN P-FORMAT, BINARY MODE
      JMP *-2      IGNORE REJECT
ADDR. DEF LBUF      ADDRESS OF INPUT BUFFER - LBUF-.
      DEC 61        MAXIMUM OF 60 WORDS PER RECORD. 
      JSB .IOC.    CALL  *IOC* FOR  STATUS
IN.2  OCT 40005     CHECK OF INPUT REQUEST. 
      SSA          DELAY UNTIL
      JMP *-3       OPERATION COMPLETED.
      STA B         SAVE THE STATUS.
      AND M240     CHECK STATUS FIELD FOR END-OF- 
      SZA           TAPE OR END-OF-FILE.
      JMP ENDC     YES, GO TO END CONDITION SECTION.
      RBR,SLB,RBR   WAS THERE A MT PARITY ERROR?
      JMP IN.3      YES, GO ISSUE A DIAGNOSTIC. 
      RBR,RBR       SHIFT THE TIMING BIT TO 0.
      SLB           WAS THERE A MT TIMING ERROR?
      JMP IN.3      YES, GO ISSUE A DIAGNOSTIC. 
      SPC 1 
* CHECK RECORD LEGALITY 
      SPC 1 
      LDA LBUF+1   GET WORD 2 OF RECORD,
      ALF,RAR       ROTATE RIC FIELD TO 
      AND M.07      LOW A AND ISOLATE CODE. 
      STA RIC      SAVE CODE FOR PROCESSING.
      SZA          IF RIC = 0, SKIP 
      ADA CM.6     SUBTRACT 6 TO TEST FOR  1 TO 5.
      SSA,RSS      IF RESULT IS POSITIVE OR 
      JMP LER2        ZERO, ERROR. ILLEGAL RECORD.
      SPC 1 
* LEGAL RECORD -  COMPUTE AND CHECK CHECKSUM
      SPC 1 
      LDB LBUF     GET RECORD 
      BLF,BLF       WORD COUNT
      CMB,INB        AND SUBTRACT 
      ADB C.03        3 FOR USE AS COUNTER
      SSB,RSS      (PROTECTION AGAINST
      JMP IN.3      LT  4-WORD RECORD.) 
      LDA LBUF+1       IN COMPUTING 
      STB LBUF          CHECKSUM
      LDB LBUFA    SET B = ADDRESS
      ADB C.03      OF WORD 4.
      ADA B,I      ADD
      INB           REMAINING 
      ISZ LBUF       WORDS IN 
      JMP *-3         RECORD - SUM IN A 
      CPA LBUF+2   COMPARE SUM TO CHECKSUM IN RECORD
      JMP LDRC      EQUAL, ASSUME RECORD GOOD.
      SPC 2 
* CHECKSUM ERROR
      SPC 1 
IN.3  LDA ERR01    SET ERROR CODE 01
      JSB DIAG     PRINT DIAGNOSTIC  *L01 
      HLT 03       ERROR HALT-
      JSB .IOC.    CALL FOR BACKSPACE 1 RECORD
IN.4  OCT 31205     IF LOADING FROM MAG. TAPE 
      JMP LDRIN    - IGNORE REJECT IF NOT MT -
      JMP LDRIN    GO TO RE-READ. 
      SPC 2 
LDRC  LDA RIC      (A) = RECORD TYPE
      LDB PLFLG    (B) = PROGRAM LOADING FLAG 
      CPA C.01     IF RIC = 1, THEN GO TO PROCESS 
      JMP LDRC3     NAM RECORD. 
      SSB,RSS      IF FLAG = 0 (NOT LOADING), THEN
      JMP LDRC7     RECORD-OUT-OF-SEQUENCE OR LIB-
      CPA C.02       RARY SKIP. IF RIC = 2, THEN
      JMP ENTR      GO PROCESS ENT RECORD.
      LDB EXMFL    IF EXMFL = -1, GO TO TRANSFER
      SSB           SECTION. EXMFL = 0 OR 1 MEANS 
      JMP LDRC2      LOADING FROM LIBRARY.
      SPC 1 
* LOADING FROM PROGRAM LIBRARY
      SPC 1 
      CMB,INB,SZB,RSS IF EXMFL = 0, THEN NO ENT MATCHES 
      JMP LDRC5     AN EXT IN LST - GO TO BYPASS
      STB EXMFL     CONTINUE LOADING PROGRAM. 
      JSB NAMR     PPOCESS SAVED NAM RECORD.
      JSB LSTI     INITIALIZE LST PROCESSOR.
LDRC1 JSB LSTP     SET LST ENTRY ADDRESSES. 
      JMP LDRC2-1  - END OF LST.
      LDB LST4     (B) = ADDRESS OF WORD 4 LST ENTRY
      LDA LST4,I   EXAMINE WORD 4- ENT ADDRESS. 
      SSA,RSS      IF ENT ADDRESS IS POSITIVE, THEN 
      JMP LDRC1     GO CHECK NEXT ENTRY.
      JSB RELEN    RELOCATE ENT ADDR (FROM LIB.)
      LDA LST5,I   IF EXT LINK ADDRESS ALREADY
      SZA           DEFINED, STORE RELOCATED
      STB A,I        ENT ADDR. IN LINK. 
      JMP LDRC1    REPEAT THRU LST. 
      LDA RIC      RESET  A = RIC.
      SPC 1 
* TRANSFER TO RECORD PROCESSOR SECTION. 
      SPC 1 
LDRC2 CPA C.03     IF RIC = 3, GO TO
      JMP DBLR       DBL RECORD PROCESSOR.
      CPA C.04     IF RIC = 4, GO TO
      JMP EXTR       EXT RECORD PROCESSOR.
      SPC 1 
* END  RECORD  PROCESSOR
      SPC 1 
      LDA LBUF+1    EXAMINE A FIELD OF WORD 2.
      STA UEXFL    INITIALIZE UNDEF. EXT FLAG NOT =0
      SLA,RSS      IF NO TRANSFER ADDRESS PRESENT,
      JMP ENDR1     GO TO CLEAR SECTION.
      LDB PREL     (B) = PROGRAM   RELOCATION BASE
      ARS,SLA      IF A-FIELD = 1, SET (B) =
      LDB BPREL     BASE PAGE RELOCATION BASE.
      ADB LBUF+3   ADD EXECUTION POINT ADDRESS TO 
EXECP EQU 00003B
      STB EXECP     BASE AND SAVE.
ENDR1 JSB LSTI     INITIALIZE LST PROCESSOR 
ENDR2 JSB LSTP     SET LST ENTRY ADDRESSES. 
      JMP ENDR3    -END OF LST. 
      LDA LST3,I   GET WORD 3 OF EACH 
      AND UPCM      LST ENTRY - CLEAR BITS 07-00
      STA LST3,I    (EXT ORD FIELD) AND RESET.
      LDA LST4,I   IF WORD 4 OF THE ENTRY,
      SZA,RSS       ENT ADDRESS, = 0, SET UEXFL 
      STA UEXFL      = 0 TO SAY UNDEFINED EXT.
      JMP ENDR2     REPEAT THRU LST.
ENDR3 LDA FTNFL    GO TO BOUNDS 
      SSA,RSS       LIST IF 
      JMP ENDR4      NOT A FTN PROGRAM. 
      SPC 1 
* PROGRAM JUST LOADED WAS GENERATED BY EITHER 
*  FORTRAN OR ALGOL.  FINAL LENGTHS OF PROGRAM
*  AND BASE PAGE (FOR ALGOL) MUST BE SET FOR
*  BOUNDS LIST. 
      SPC 1 
      CCB           SUBTRACT 1 FROM 
      ADB BND+1     NEW FWA TO GET UPPER
      STB BND+1      BOUND OF PROGRAM.
      CCA           SUBTRACT 1 FROM BND+3 TO
      ADA BND+3     GET ABSOLUTE UPPER BOUND OF 
      STA BND+3      A BASE PAGE ALLOCATION.
ENDR4 LDA MAPF     IF NAME/BOUNDS LIST IS TO
      SSA           BE DELETED, GO SET
      JMP ENDR6      FOR NEXT PROGRAM LOAD. 
      LDA BOUND    (A) = ADDR. OF 6-WORD AREA.
      LDB BND      IF NO PROGRAM
      SZB,RSS       ALLOCATION (LOWER BOUND = 0)
      JMP ENDR5      GO CHECK FOR BASE PAGE ALLOC.
      JSB CONV     CONVERT LOWER BOUND. 
      LDB BND+1    CONVERT
      JSB CONV      UPPER BOUND.
      LDA BOUND    PRINT
      LDB C.12      BOUNDS OF 
      JSB LOUTL      PROGRAM AREA.
ENDR5 LDA BOUND    IF NO
      LDB BND+2     BASE PAGE ALLOCATION MADE,
      SZB,RSS        GO TO SET FOR
      JMP ENDR6       NEXT LOAD.
      JSB CONV     CONVERT LOWER BP BOUND.
      LDB BND+3    CONVERT UPPER
      JSB CONV       BASE PAGE BOUND. 
      LDA BOUND    PRINT
      LDB C.12      BASE PAGE 
      JSB LOUTL      BOUNDS 
      SPC 1 
* CHECK FOR COMPLETION OF LIBRARY LOADING.
      SPC 1 
ENDR6 LDA LIBFL    (A) = LIBRARY LOADING FLAG.
      LDB UEXFL  (B) = WORD USED FOR STATING
      SZA           UNDEFINED EXTS. IF NOT LOADING
      SZB,RSS       FROM LIB OR IF UNDEFINED EXTS,
      JMP LDRC6     GO TO LOAD NEXT PROGRAM.
REW.L JSB .IOC.    REWIND LIBRARY UNIT
      OCT 31403     IF MAG. TAPE
      JMP ENDC2    - IGNORE REJECT IF NOT MT -
      JMP ENDC2    END OF LIBRARY LOADING.
      SPC 1 
* PROCESSING NAM RECORD SECTION.
      SPC 1 
LDRC3 SZB          IF PLFLG NOT = 0, THEN NAM RECORD
      JMP LDRC8     OUT OF ORDER -  ERROR.
      LDA CM.9      SET TO
      STA LBUF+57    MOVE  9 WORD 
      LDA NBUFA       NAM RECORD
      STA LBUF+58      TO 
      LDB LBUFA         NBUF. 
      LDA B,I        MOVE NAM 
      STA LBUF+58,I    RECORD 
      ISZ LBUF+58      TO 
      INB              NAM
      ISZ LBUF+57       BUFFER
      JMP *-5            AREA 
      CCA           SET PLFLG AND 
      STA PLFLG      EXMFL = -1 TO SAY
      STA EXMFL       LOAD. 
      LDA LIBFL    IF LOADING 
      SZA           FROM PROGRAM LIBRARY, GO TO 
      JMP LDRC4      SAVE LST AND LWAM  VALUES
      SPC 1 
*                LOADING FROM STANDARD INPUT
      SPC 1 
      JSB NAMR     ALLOCATE MEMORY FOR PROGRAM
      JMP LDRIN    GO TO PROCESS NEXT RECORD. 
      SPC 1 
*    LIBRARY LOADING. 
      SPC 1 
LDRC4 LDA LSTA,I   SAVE CURRENT LST AND LWA AVAIL.
      STA LSTS      MEMORY FOR LATER RESTORATION
      LDA LWAM      IF CURRENT PROGRAM IS 
      STA LWAMS      NOT TO BE LOADED.
      CLA           SET EXMFL = 0 TO
      STA EXMFL      SAY LOADING FROM LIBRARY.
      JMP LDRIN     GO TO PROCESS NEXT RECORD.
      SPC 1 
* RESET PROCESSING - PROGRAM FROM LIBRARY IS
*  NOT TO BE LOADED.
      SPC 1 
LDRC5 LDA LSTS     RESET ORIGINAL (BEFORE CURRENT 
      STA LSTA,I    PROGRAM) LST LENGTH.
      LDA LWAM
      LDB HLTB. 
INITB CPA LWAMS 
      JMP RESET 
      INA 
      STB A,I       STORE THE SPECIAL HALT. 
      JMP INITB 
      SPC 1 
RESET STA LWAM      AVAILABLE MEMORY. 
LDRC6 CLA          SET PLFLG = 0 TO SAY END OF PROG-

      STA PLFLG     RAM OR TO FORCE A SKIP OF PROG. 
      JMP LDRIN 
      SPC 1 
* RECORD OUT-OF-SEQUENCE CHECK
      SPC 1 
LDRC7 LDA LIBFL    IF LOADING FROM LIBRARY, THEN
      SZA           FLAG SAYS TO SKIP REMAINING 
      JMP LDRIN     RECORDS IN PROGRAM. 
LDRC8 LDA ERR08    RECORD OUT OF SEQUENCE 
      JMP ERR09 
      SPC 1 
* CONSTANT/STORAGE SECTION FOR MAIN CONTROL SECTION.
      SPC 1 
RIC   OCT 0        HOLDS RECORD IDENTIFICATION CODE 
C.01  OCT 1 
C.02  OCT 2 
C.04  OCT 4 
CM.6  DEC -6
M.07  OCT 7 
CM.9  DEC -9
LIBFL OCT 0   LIBRARY LOADING FLAG:=0, INPUT,=-1,LIB. 
PLFLG OCT 0   LOADING FLAG:=0,NO,=-1,YES
EXMFL OCT 0   ENT/EXT MATCH:=-1 DURING INPUT LOADING
      SPC 1 
* FOR LIBRARY LOADING: =0,NO MATCH, =1, MATCH.
      SPC 1 
UPCM  OCT 177400    MASK FOR UPPER 8-BITS.
M.37  OCT 37
M240  OCT 240      MASK FOR EOF, EOT
      SPC 1 
A     EQU 0 
B     EQU 1 
      SPC 1 
FTNFL OCT 0       FLAG WORD FOR DESIGNATING 
*                               WHETHER A FORTRAN GENERATED 
*                               PROGRAM IS BEING LOADED:
*                               BIT 15 = 1, YES. = 0, NO. 
UEXFL OCT 0    UNDEFINED EXT FLAG, =0,YES 
      SKP 
*              - NAMR - 
*  NAME  ( NAM - RIC = 1 ) RECORD PROCESSOR 
      SPC 1 
* PURPOSE:  1) LIST PROGRAM NAME
      SPC 1 
*           2) ALLOCATE  MEMORY NEEDED FOR
*               LOADING THE MAIN SECTION OF A 
*               PROGRAM, THE BASE PAGE
*               SECTION (OPTIONAL) AND A
*               COMMON DECLARATION. 
      SPC 1 
*           3) UPDATE MEMORY TABLE TO REFLECT 
*               NEW BOUNDS OF AVAILABLE 
*               MEMORY
      SPC 1 
*           4) ESTABLISH THE RELOCATION BASES 
*               FOR THE SECTIONS OF A PROGRAM 
      SPC 2 
* OPERATION:
      SPC 1 
*  THIS PROCESSOR OPERATES AS A CLOSED  SUB-
*   ROUTINE CALLED BY THE MAIN CONTROL
*   SECTION OF THE LOADER. THE NAM RECORD 
*   IS MOVED FROM LBUF TO NBUF BEFORE THE 
*   PROCESSOR IS ENTERED. CONTROL IS RETURNED 
*   TO P+1 IN THE CALL.  THERE ARE NO ERROR 
*   RETURNS.
      SPC 1 
* SPECIAL PROCESSING IS MADE FOR ALLOCATING 
*  STORAGE FOR A FORTRAN GENERATED PROGRAM. (A
*  FORTRAN GENERATED OBJECT PROGRAM IS IDENT- 
*  IFIED BY BIT 15 OF WORD 7 OF THE NAM RECORD
*  = 1.)  THE PROGRAM LENGTH IN WORD 7 MAY BE 
*  GREATER THAN THE ACTUAL LENGTH. TO INSURE
*  THAT THE ACTUAL LENGTH IS USED TO REFLECT
*  THE MEMORY ALLOCATION, THE UPPER BOUND AND 
*  NEW FWA AVAILABLE MEMORY ARE NOT SET UNTIL 
*  THE PROGRAM IS LOADED. 
      SPC 2 
NAMR  NOP           ENTRY/EXIT
      LDA MAPF      IF MAP IS TO
      SSA           BE DELETED, 
      JMP NM1       SKIP NAME OUTPUT
      LDA NBUFA     WRITE 
      ADA C.02      PROGRAM NAME. 
      LDB BLANK     LOAD: A= TWO(2) BLANKS. 
      STB A,I       BLANK THE CHECKSUM WORD.
      LDB M.07           ON 
      JSB LOUTL            TELETYPE.
NM1   CLA          CLEAR WORDS
      STA BND       HOLDING LOWER BOUND VALUES -
      STA BND+2     (FOR BOUNDS LIST IN  -ENDR-)
      SPC 1 
* ALLOCATE BASE PAGE STORAGE
      SPC 1 
      LDA NBUF+7   CHECK FOR BASE PAGE ALLOCATION 
      SZA,RSS       IF NO BP ALLOCATION,
      JMP NM2        CHECK FOR PROGRAM ALLOCATION.
      CMA,SZA      IF BP LENGTH NOT = -1, 
      JMP RSTOR     THEN ATTEMPT TO ALLOCATE. 
      SPC 1 
* LOADING AN ALGOL PROGRAM - BP LENGTH NOT KNOWN
      SPC 1 
      LDA FWABP    SET FWA BASE PAGE
      STA BPREL     AS RELOCATION BASE
      STA BND+2      AND LOWER BOUND. 
      JMP NM2 
RSTOR LDA NBUF+7   RESTORE LENGTH IN A FOR ALLOCATE.
      LDB MEMRY    (B) = ADDR. OF BASE PAGE MT. 
      JSB ALLOC    ATTEMPT ALLOCATION.
      JMP LER3     - OVERFLOW OF BASE PAGE -
      LDA BND      SET BP AREA ORIGIN 
      STA BND+2     IN BND+2, AND 
      STA BPREL      IN RBT TABLE.
      LDA BND+1    SET UPPER BOUND IN 
      STA BND+3     BND+3.
      CLA          SET BND = 0 IN CASE NO MAIN
      STA BND       ALLOCATION IS MADE. 
      SPC 1 
* ALLOCATE PROGRAM AREA STORAGE 
      SPC 1 
NM2   LDA NBUF+6   (A) = PROGRAM LENGTH 
      STA FTNFL    SET FORTRAN LOADING FLAG - BIT 15
      SZA,RSS      IF PROGRAM LENGTH = 0, 
      JMP NM5       CHECK FOR COMMON. 
      LDB MEMRY    SET (B) = ADDRESS OF 
      ADB C.02       -FWAM- IN MEMORY TABLE.
      ELA,CLE,ERA  CLEAR FTN FLAG ( BIT 15 ). 
      JSB ALLOC    ATTEMPT ALLOCATION - 
      JMP NM3      NO - OVERFLOW
      LDA FTNFL    (A) = FTN LOADING FLAG.
      LDB BND      (B) = PROGRAM ORIGIN 
      SSA          IF FTN PROGRAM BEING LOADED, 
      STB FWAM      RESET FWA TO ORIGINAL VALUE,
      STB PREL      SET ORIGIN IN -RBT TABLE -, 
      JMP NM5       AND GO CHECK FOR COMMON.
NM3   LDA FTNFL    -OVERFLOW PROGRAM AREA - 
      SSA           IF FTN PROGRAM BEING LOADED,
      JMP NM4        GO TO FORCE LOADING. 
      SPC 1 
* ATTEMPT PROGRAM ALLOCATION IN BASE PAGE 
      SPC 1 
      LDA NBUF+6   TRY TO LOAD
      LDB MEMRY     PROGRAM 
      JSB ALLOC      IN BASE PAGE AREA -
      JMP LER3     NO, CANNOT LOAD THIS PROGRAM - 
      LDA BND      ALLOCATED, SET PROGRAM 
      STA PREL      ORIGIN IN RBT TABLE,
      JMP NM5       GO CHECK FOR COMMON.
      SPC 1 
* FORCE LOADING FOR FORTRAN OBJECT PROGRAM
*  OR  ALGOL MAIN PROGRAM 
      SPC 1 
NM4   CMA,SZA,RSS  IF PROGRAM LENGTH = -1,
      JMP NM7       GO TO LOAD IN PROGRAM AREA. 
      LDA LWABP    GET NUMBER OF AVAILABLE
      CMA,INA       WORDS IN
      ADA FWABP      BASE PAGE
      LDB FWAM     GET NUMBER OF AVAILABLE
      CMB,INB       WORDS IN
      ADB LWAM       PROGRAM AREA 
      ADA B         PROGRAM AREA NUMBER 
      LDB FWABP    (B) = FWA BASE PAGE. 
      SSA,RSS      IF PROGRAM AREA IS LARGER, 
NM7   LDB FWAM      SET (B) = FWAM
      STB BND       SET FOR BOUND PRINTOUT. 
      STB PREL      AND SET ORIGIN IN RBT.
      SPC 1 
* COMMON ALLOCATION CHECK 
      SPC 1 
NM5   LDA NBUF+8   (A) = COMMON LENGTH
      SZA,RSS      IF NO COMMON SPECIFIED IN
      JMP NAMR,I    PROGRAM, EXIT PROCESSOR.
      LDB COML     IF NO PREVIOUS COMMON
      SZB,RSS       SPECIFIED, GO ALLOCATE TOTAL
      JMP NM6       COMMON LENGTH.
      CMA,INA      SUBTRACT NEW LENGTH FROM FIRST 
      ADA COML     LENGTH DECLARED. IF NEW LESS THAN
      SSA,RSS        OR = TO FIRST, THEN CONTINUE 
      JMP NAMR,I     PROCESSING. EXIT.
      SPC 1 
* COMMON LENGTH ERROR 
      SPC 1 
      LDA ERR06 
      JMP ERROR 
      SPC 1 
* ALLOCATE FIRST COMMON 
      SPC 1 
NM6   STA COML     SAVE TOTAL COMMON LENGTH 
      CMA,INA      SUBTRACT LENGTH FROM END OF LDR
      ADA ENDL      TO GET ORIGIN-1.
      STA B        SAVE IN B, AND SUBTRACT ORIGIN-1 
      CMA            FROM FWA 
      ADA FWAM       AVAILABLE MEMORY.
      SSA,RSS      A POSITIVE RESULT MEANS OVERFLOW 
      JMP LER3      OF AVAIL. MEMORY --- ERROR. 
      STB A        O.K. SAVE FOR POSSIBLE NEW LWA.
      INB          ADD 1 TO GET COMMON ORIGIN 
      STB COMOR     AND SET IN RBT TABLE. 
      CMB,INB       SUBTRACT COMMON ORIGIN-1 FROM 
      ADB LWAM      CURRENT LWA AVAIL. MEM. 
      SSB,RSS      IF ORIGIN-1 LT LWA, SET ORIGIN-1 
      STA LWAM      AS NEW LWA AVAILABLE MEMORY.
      JMP NAMR,I   -EXIT  NAM PROCESSOR-
      SKP 
* SUBROUTINE:  ALLOC   (CHECK MEMORY ALLOCATION)
      SPC 1 
* CALL:    (A) = LENGTH TO BE ALLOCATED 
*          (B) = ADDRESS OF MEMORY TABLE FOR
*                 BASE PAGE OR PROGRAM AREA 
      SPC 1 
*          (P)     JSB   ALLOC
*          (P+1)   -OVERFLOW RETURN - 
*          (P+2)   -BLOCK ALLOCATED RETURN
*                  (A) AND (B) MEANINGLESS ON RETURN. 
      SPC 2 
ALLOC NOP           ENTRY/EXIT POINT
      STB NBUF+5    SAVE MEMORY TABLE ADDRESS.
      LDB B,I       GET  FWA ADDRESS OF AREA. 
      STB BND       SET FOR PROGRAM ORIGIN. 
      ADA B         ADD PROGRAM LENGTH AND
      STA B          SAVE FOR NEW FWA OF AREA.
      ADA CM.1      GET UPPER BOUND OF PROGRAM
      STA BND+1      AND SAVE.
      CMA,INA       SET UPPER BOUND NEGATIVE- 
      ISZ NBUF+5     AND ADD THE
      ADA NBUF+5,I    LWA OF AVAILABLE AREA.
      SSA           A NEGATIVE VALUE MEANS OVER-
      JMP ALLOC,I    FLOW - TAKE P+1 EXIT.
      CCA           SET (A) = ADDRESS OF FWA WORD 
      ADA NBUF+5     IN MEMORY TABLE AND
M174  STB A,I        SET NEW FWA. 
      ISZ ALLOC     SET EXIT TO P+2 AND 
      JMP ALLOC,I    RETURN.
      SPC 2 
* CONSTANT AND STORAGE SECTION FOR -NAMR-.
      SPC 1 
BOUND DEF LSTPX    DEFINE ADDRESS OF 6-WORD AREA. 
COML  OCT 0        HOLDS INITIAL COMMON LENGTH
CM.1  DEC -1
      SKP 
*              - DBLR - 
* DATA BLOCK RECORD PROCESSOR (RIC = 3) 
      SPC 2 
* PURPOSE OF THIS SECTION IS TO ADJUST
*  (RELOCATE) THE LOAD ADDRESS OF  A  DATA
*  BLOCK AND  RELOCATE AND STORE EACH WORD
*  IN THE DATA BLOCK.  THIS SECTION CHECKS
*  THE OPERAND ADDRESS OF EACH MEMORY-REFER-
*  ENCE INSTRUCTION AND, IF THE OPERAND IS
*  NOT IN THE SAME PAGE AS THE INSTRUCTION, 
*  A REQUEST TO SUBROUTINE  *LINK* IS MADE
*  TO ALLOCATE A WORD IN BASE PAGE TO HOLD
*  THE OPERAND ADDRESS. THE INSTRUCTION IS
*  THEN ALTERED TO INDIRECTLY REFERENCE THE 
*  LINKAGE WORD IN BASE PAGE. 
      SPC 1 
* A RELOCATION BYTE IS ASSOCIATED WITH EACH 
*  INSTRUCTION OR DATA WORD IN A DBL RECORD.
*  THIS 3-BIT BYTE CONTAINS ONE OF THE
*  FOLLOWING RELOCATION INDICATORS: 
      SPC 1 
*         000   ABSOLUTE
*         001 -  PROGRAM RELOCATABLE
*         010 -  BASE PAGE RELOCATABLE
*         011 -  COMMON RELOCATABLE 
*         100 -  EXTERNAL SYMBOL REFERENCE
*         101 -  2-WORD MEMORY REFERENCE
*                 GROUP- WORD 1 CONTAINS
*                 OP-CODE AND A RELOCATION
*                 BYTE IN THE OPERAND FIELD,
*                 WORD 2 CONTAINS THE FULL
*                 15-BIT ADDRESS OF THE 
*                 REFERENCED OPERAND. 
*         110  -  2-WORD SPECIAL REFERENCE GROUP. 
*                 WORD 1 CONTAINS THE TYPE INDICATOR
*                 FOR THE GROUP AND THE RELOCATION
*                 INDICATOR FOR THE RELOCATIBLE OPERAND 
*                 FOUND IN WORD 2. THE TYPE INDICATORS
*                 DEFINED BY BITS 15-12 ARE OUTLINED
*                 AS FOLLOWS: 
*                    1.  0000  - BYTE ADDRESS REFERENCE 
*                  THE RELOCATION BYTE IN 
*                 WORD 1 IS ONE OF THE
*                 FOLLOWING VALUES: 
*                    00 - PROGRAM 
*                    01 - BASE PAGE 
*                    10 - COMMON
*                    11 - ABSOLUTE
      SPC 1 
* THE SECTION USES THE RELOCATION BASE
*   TABLE  (RBT) TO RELOCATE THE LOAD 
*   ADDRESS AND DATA WORDS. THE RELOCATION
*   BASES IN THE RBT ARE SET BY THE NAM 
*   RECORD PROCESSOR. THE TABLE IS STRUCTURED 
*   AS: 
*      RBTA  DEF *+1
*      RBT   OCT 0  (ABSOLUTE)
*      PREL  (PROGRAM ORIGIN - FWA) 
*      BPREL (BASE PAGE ORIGIN (FROM ORB) 
*      COMOR (COMMON AREA ORIGIN) 
      SPC 1 
* IF A FORTRAN GENERATED PROGRAM IS BEING LOADED, 
*  A CHECK FOR MEMORY OVERFLOW IS MADE BEFORE 
*  EACH DBL RECORD IS PROCESSED. IF OVERFLOW OCCURS,
*  AN IMMEDIATE TERMINATION OF LOADING IS MADE
*  BY TRANSFERRING TO THE ERROR ROUTINE.  OTHERWISE,
*  THE NEW FWA OF THE MEMORY AREA IS SET AND
*  LOADING CONTINUES.   THE DBL RECORDS FOR A FTN 
*  OBJECT PROGRAM ARE GENERATED IN ASCENDING
*  ORDER - I.E. THE LOAD ADDRESS OF EACH DBL RECORD 
*  IS LARGER THAN THE PREVIOUS - AND THE LAST DBL 
*  RECORD LOADED IS THE LAST PROGRAM SEGMENT (I.E., 
*  A BSS DOES NOT FOLLOW) SO THE NEW FWA OF AVAIL.
*  MEMORY IS KNOWN AFTER THE LAST DBL RECORD IS 
*  PROCESSED. 
      SPC 2 
DBLR  LDA LBUF+1    GET WORD 2 AND
      AND M100       ISOLATE -Z- FIELD. 
      LDB BPREL     SET (B) = BASE PAGE RELOCATION
      SZA           IF (Z) = 1, THEN SET (B)
      LDB PREL       = PROGRAM RELOCATION.
      ADB LBUF+3   ADD LOAD ADDR. TO RELOCATION BASE
      STB LBUF      AND SAVE. 
      CCE,SZA,RSS  SET E = 1 IF RECORD
M.40  CLE           IS FOR PROGRAM AREA 
      SPC 1 
* FOLLOWING IS A SWITCH FOR ABSOLUTE OUTPUT OPTION
*  THE WORD AT OPT.1 IS CLEARED (NOP) IF THE OPTION 
*   IS NOT SELECTED. OTHERWISE THE ABSOLUTE LOAD
*    ADDRESS IS STORED IN WORD 2 OF ABREC BUFFER. 
      SPC 1 
OPT.1 STB ABREC+1 
      LDA LBUF+1   GET WORD 2 AGAIN, ISOLATE
      AND M77        COUNT FIELD, SET NEGATIVE
      CMA,INA        FOR COUNTER AND
      STA LBUF+1     SAVE.
      SPC 1 
* CHECK FOR MEMORY OVERFLOW OF FTN PROGRAM
      SPC 1 
      CMA,INA      RESET WORD COUNT TO POSITIVE.
      ADA LBUF     ADD LOAD ADDR. TO WORD COUNT.
      LDB FTNFL    IF PROGRAM BEING 
      SSB,RSS       LOADED IS NOT FORTRAN GENERATED,
      JMP DBL0       CONTINUE PROCESSING. 
      STA B         SAVE POSSIBLE NEW FWA.
      AND M076      ISOLATE MODULE/PAGE ADDRESS.
      SZA           IF ADDRESS IS TO PROGRAM AREA,
      STB FWAM      SET NEW FWA AVAILABLE MEMORY. 
      SZA,RSS       IF ADDRESS IS TO BASE PAGE, 
      STB FWABP     SET NEW FWA AV.MEM IN BASE PAGE.
      SEZ,RSS      SET AS UPPER BOUND FOR 
      STB BND+3      BASE PAGE  OR
      SEZ 
      STB BND+1      PROGRAM AREA.
      CMB,INB      SET FWA NEG. FOR OVERFLOW CHECK. 
      SZA          IF FWA IS TO PROG. AREA, 
      ADB LWAM      ADD LWA PROG. AREA. 
      SZA,RSS      ADD FOR
      ADB LWABP     BASE PAGE.
      SSB          A NEGATIVE RESULT MEANS OVERFLOW 
      JMP LER3      AND TERMINATION OF LOADING. 
DBL0  LDA LBUFA    SET ADDRESS OF WORD 5 OF DBL 
      ADA C.04      RECORD (FIRST RELOC. BYTE WORD) 
      STA LBUF+2    IN LBUF+2.
DBL1  LDB LBUF+2,I  SET RELOCATION BYTE WORD
      STB LBUF+3     IN LBUF+3. 
      LDA CM.5      SET BYTE COUNTER
      STA NBUF        = -5
      ISZ LBUF+2    SET ADDRESS FOR FIRST DATA WORD.
DBL2  LDA LBUF+3    GET RELOC. BYTE WORD - ROTATE 
      ALF,RAR        3-BIT BYTE FOR NEXT INSTR. TO
      STA LBUF+3     LOW A AND RESTORE WORD.
      AND M.07      ISOLATE BYTE. 
      CPA C.04      IF BYTE = 4, THEN GO TO EXTERNAL
      JMP DBL4       REFERENCE SECTION. 
      CPA C.05      IF BYTE = 5, THEN GO TO 2-WORD
      JMP DBL6       MEMORY REFERENCE GROUP SECTION.
      CPA C.06     SPECIAL REFERENCE? 
      JMP DBL10    YES
      ADA RBTA      BYTE = 0-3. ADD ADDR. OF RBT
      LDA A,I        TO BYTE AND GET BASE VALUE.
      ADA LBUF+2,I  ADD DATA WORD TO RELOCATION BASE. 
      SPC 1 
* FOLLOWING SWITCH FOR ABSOLUTE OUTPUT IS CLEARED 
*  IF OPTION NOT SELECTED. OTHERWISE, THE RELOCATED 
*   OR ABSOLUTE DATA WORD IS STORED IN THE ABREC
*    BUFFER (VIA A  JSB PACK). RETURN FROM PACK 
*    BYPASSES THE STA LBUF,I. 
      SPC 1 
DBL3  JSB PACK
      STA LBUF,I
      ISZ LBUF+1   INDEX DATA WORD COUNT. 
      JMP DBL9      MORE IN RECORD. 
      SPC 1 
* FOLLOWING SWITCH FOR ABSOLUTE OUTPUT IS CLEARED 
*  IF OPTION NOT SELECTED. OTHERWISE, THE ABSOLUTE
*   BUFFER IS PUNCHED.
      SPC 1 
OPT.2 JSB PUNCH 
      JMP LDRIN    GO TO PROCESS NEXT RECORD. 
DBL9  ISZ LBUF     ADD 1 TO LOAD ADDRESS. 
DBL12 ISZ LBUF+2    ADD 1 TO RECORD ADDR. 
      ISZ NBUF     INDEX REL-BYTE COUNTER 
      JMP DBL2      MORE BYTES IN WORD
      JMP DBL1     GET NEXT BYTE WORD.
      SPC 1 
HLTB. OCT 106055
      SPC 1 
* RELOCATION BASE TABLE  ( RBT )
      SPC 1 
RBTA  DEF *+1   DEFINES ADDRESS OF RBT
      OCT 000000    ABSOLUTE
PREL  OCT 0      PROGRAM RELOCATION 
BPREL OCT 0      BASE PAGE RELOCATION 
COMOR OCT 0      COMMON RELOCATION
      OCT 0         ABSOLUTE
      SPC 1 
* CONTROL SECTION FOR PROCESSING
*  INSTRUCTIONS  ( OR A DEF ) REFERENCING 
*  AN EXTERNAL SYMBOL.
      SPC 1 
DBL4  LDA LBUF+2,I   GET INSTR. WORD
      AND M377      ISOLATE  EXT ORDINAL
      STA NBUF+1     AND SAVE 
      JSB LSTI     INITIALIZE  LST PROCESSOR
DBL5  JSB LSTP     SET LST ENTRY ADDRESSES. 
      SPC 1 
* THE EXT CORRESPONDING TO THE ORDINAL SHOULD BE
*  FOUND IN THE LOADER SYMBOL TABLE. THE END OF 
*  LST RETURN FROM -LSTP- SHOULD NEVER BE TAKEN 
*  AT THIS POINT.  IF IT IS, A HALT IS PROVIDED 
*  TO ALLOW EXAMINATION OF THE FACTORS CAUSING
*  THIS ABNORMAL CONDITION. 
      SPC 1 
      HLT 01B 
      LDA LST3,I   GET WORD 3 OF LST ENTRY, ISOLATE 
      AND M377      BITS 07-00, AND COMPARE VALUE TO
      CPA NBUF+1    SAVED EXT ORDINAL 
      CCE,RSS 
      JMP DBL5     NOT FOUND, KEEP SEARCHING LST
      LDB LST5,I   GET EXT LINK ADDR. IN BASE PAGE
      LDA LBUF+2,I  GET INSTRUCTION, REMOVE  EXT
      AND M174       ORDINAL,  SET  I = 1 FOR AN
.DBL3 RAL,ERA 
DBL3. IOR B          ADDRESS IN BITS 09-00 AND GO 
      JMP DBL3       TO STORE INSTRUCTION WORD. 
      SPC 1 
* 2-WORD MEMORY REFERENCE GROUP PROCESSOR 
      SPC 1 
DBL6  LDA LBUF+2,I   GET WORD 1 (OP-CODE,REL. BYTE) 
      ISZ LBUF+2     SET ADDR. TO WORD 2
      STA NBUF+2
* 
      RAR,RAR       IF EXT. ORDINAL THEN INSTR. IS
      AND M377      AN I/O INSTR. WITH EXT. S.C.
      SZA,RSS       EXT. ORDINAL? 
      JMP CONFG     NO - GO PROCESS AS MEM.REF. 
      STA EXORD     SAVE ORDINAL. 
      LDA NBUF+2   GET WORD 1, AGAIN
      RAR          IS THE "MR" FIELD
      SSA,SLA,RSS  EQUAL TO 3?
      JMP LER10    NO - ERROR 
      JSB LSTI      SEARCH LST FOR EXT. ENTRY 
SREXT JSB LSTP      (SHOULD FIND ONE )
      JMP LER10     SOMETHING WORNG - COULDN'T FIND.
      LDA LST3,I    GET ORDINAL FROM LST ENTRY. 
      AND M377      MATCH ORDINAL DECLARED
      CPA EXORD     IN INSTRUCTION? 
      RSS 
      JMP SREXT     NO - TRY AGAIN. 
      LDA LST4,I    FOUND EXT ENTRY - IS ENTRY POINT
      SZA,RSS       DEFINED?
      JMP LER10     NO - CAN'T RESOLVE - ERROR
      LDA LST5,I    GET SELECT CODE FROM
      LDA A,I       LINKAGE AREA. 
      STA B        SAVE IN B
      CMB,INB 
      ADB M77 
      SSB          SELECT CODE > 77?
      JMP LER10    YES - ERROR
      IOR LBUF+2,I  COMBINE WITH INSTRUCTION. 
      JMP DBL3      GO STORE INSTRUCTION. 
* 
CONFG LDA NBUF+2
      LDB BPREL     SET B= BASE PAGE RELOCATION BASE
      SLA           IF BYTE 1, GO TO PROCESS
      JMP DBL8       FOR BASE PAGE
      LDB PREL      SET B = PROGRAM RELOCATION
      RAR,SLA,RAL   ROTATE BIT 1, TEST, RESTORE 
      LDB COMOR     BYTE = 2, SET B= COMMON BASE
      ADB LBUF+2,I  ADD BASE TO WORD 2- OPERAND ADDR. 
      AND M174     REMOVE REL. BYTE FROM INSTR. 
      CCE,SSA 
      RBL,ERB 
      STA NBUF+2    SAVE INSTRUCTION
      LDA LBUF      GET LOAD ADDRESS, ISOLATE AND 
      AND M076       SAVE MODULE/PAGE ADDRESS.
      STA NBUF+1
      LDA B         GET OPERAND ADDR. AND ISOLATE 
      AND M076       MODULE/PAGE ADDR.
      CPA NBUF+1    IF MODULE/PAGE ADDRESSES EQUAL, 
      JMP DBL7       THEN OPERAND IS IN SAME PAGE.
      LDA B         NOT IN SAME PAGE- SET (A) = OPER- 
      JSB LINK       AND ADDRESS AND ESTABLISH LINK.
      LDA NBUF+2    (B) =LOCATION OF LINK,(A) = INSTR.
      JMP .DBL3      GO TO STORE WORD.

      SPC 1 
* OPERAND IN SAME PAGE AS INSTRUCTION.
      SPC 1 
DBL7  LDA B        SET (A) = OPERAND ADDRESS
      AND M1777     ISOLATE PAGE AREA ADDRESS.
      IOR M2000    SET Z BIT = 1 (CURRENT PAGE) 
      IOR NBUF+2   -OR- IN I AND OP-CODE
      JMP DBL3     GO TO STORE WORD.
      SPC 1 
* REFERENCE TO BASE PAGE OPERAND
      SPC 1 
DBL8  ADB LBUF+2,I  ADD OPERAND ADDR. TO BP RELOC.
      AND M174      REMOVE RELOC. BYTE IN INSTR.
      JMP DBL3.     GO TO STORE INSTRUCTION WORD. 
      SPC 2 
*SPECIAL REFERENCE GROUP PROCESSOR
      SPC 1 
DBL10 LDA LBUF+2,I  GET WORD 1
      AND M170      ISLOATE TYPE FIELD
      SZA           =0? 
      JMP NBYT      NO - NON-RECOGNIZABLE SPECIAL 
*                                  REF. INST. - IGNORE
      LDA LBUF+2,I  GET WORD 1 AGAIN
      AND C.03      ISOLATE "MR" FIELD. 
      ISZ LBUF+2    POINT TO WORD 2 
      ADA RBTA
      INA 
      LDA A,I       GET RELOCATION BASE 
      ALS           CONVERT TO BYTE ADDR. 
      ADA LBUF+2,I  ADD ON OFFSET 
      JMP DBL3      GO STORE INSTRUCTION
* 
NBYT  ISZ LBUF+2    BUMP RECORD ADDR. 
      ISZ LBUF+1    INDEX WORD COUNT
      JMP DBL12     GO GET NEXT INSTR.
      JMP LDRIN     END OF RECORD - GO GET NEXT REC 
      SPC 2 
* CONSTANT AND STORAGE SECTION FOR -DBLR-.
      SPC 1 
EXORD OCT 0 
CM.5  DEC -5
C.05  DEC 5 
C.06  DEC 6 
M77   OCT 77
M100  OCT 100 
M170  OCT 170000
M377  OCT 377 
M1777 OCT 1777
M076  OCT 76000 
M2000 OCT 2000
      SKP 
* SUBROUTINE:   LINK  (ALLOCATE LINK WORD)
      SPC 1 
* PURPOSE: TO SEARCH LINKAGE AREA IN BASE PAGE
*          FOR AN EXISTING OPERAND ADDRESS MATCHING 
*          THE PARAMETER OPERAND AND TO ALLOCATE
*          A WORD TO CONTAIN THE OPERAND ADDRESS
*          IF A MATCH IS NOT FOUND. 
      SPC 1 
*          THE OPERAND ADDRESS PARAMETER IS STORED
*          IN THE LINKAGE WORD IF A MATCH IS NOT
*          FOUND IN THE LINKAGE AREA. 
      SPC 1 
*          THE OPERAND ADDRESS PARAMETER IS IN
*           THE  A-REGISTER ON ENTRY TO LINK. THE 
*           LOCATION OF THE WORD IN THE LINKAGE 
*           AREA CONTAINING THE OPERAND IS RETURNED 
*           TO THE CALLER IN THE B-REGISTER.
      SPC 1 
*          THE LINKAGE AREA BEGINS AT LOCATION
*           1777(8) IN BASE PAGE AND EXTENDS
*           TOWARD LOW-NUMBERED MEMORY. THE 
*           LAST LOCATION OF THE LINKAGE AREA 
*           IS AT (LWABP)+1.
      SPC 1 
*          IF, IN ATTEMPTING TO ALLOCATE A NEW
*           WORD IN THE LINKAGE AREA, THE NEW 
*           ADDRESS < FWA AVAIL. MEM IN BASE PAGE,F 
*           THEN BASE PAGE AREA IS EXHAUSTED AND
*           THE LOADING PROCESS IS TERMINATED.
      SPC 2 
LINK  NOP          ENTRY/EXIT POINT 
      LDB LWABP 
      CCE,SZA 
      LDB M1777    (B) = LWA OF LINK AREA.
LINK1 CPB LWABP    IF LINK AREA SCANNED WITHOUT 
      JMP LINK2     MATCH, GO TO ALLOCATE WORD. 
      CPA B,I 
      JMP LINK,I   EQUAL, EXIT. 
      ADB CM.1     SUBTRACT 1 FROM (B) TO LOOK
      JMP LINK1     AT NEXT LINK WORD.
      SPC 1 
* ALLOCATE NEW LINK WORD. 
      SPC 1 
LINK2 INB          CHECK FOR FWABP=LWABP+1
      CPB FWABP     (ALL BASE PAGE ALLOCATED) 
      JMP LER4      ==> OVERFLOW ERROR
      ADB CM.1      (ELSE RESTORE B)
      STA B,I      STORE OPERAND IN NEW LINK WORD 
      ADB CM.1     SUBTRACT 1 FROM LINK ADDRESS TO
      STB LWABP     SET NEW LWA BP. 
      INB          RESET (B) TO ADDRESS OF NEW LINK.
      JMP LINK,I   -EXIT-.
      SKP 
* ENT / EXT RECORDS PROCESSOR 
      SPC 1 
* PURPOSE OF THIS SECTION IS TO PROCESS ENTRY POINTS
*  AND EXTERNAL SYMBOLS, ADD SYMBOLS TO THE 
*  LST (LOADER SYMBOL TABLE), ESTABLISH A LINK
*  WORD IN THE LINKAGE AREA TO HOLD THE ENTRY 
*  POINT ADDRESS OF A SYMBOL FOR AN EXT REFERENCE,
*  SET A FLAG IF AN ENTRY POINT FROM A LIBRARY
*  LOAD MATCHES AN UNDEFINED EXTERNAL SYMBOL. 
      SPC 1 
* AN LST ENTRY CONSISTS OF FIVE WORDS EXTENDING 
*  TOWARDS LOW-NUMBERED MEMORY. FOR EXAMPLE:
      SPC 1 
*    ADDRESS    WORD      CONTENTS
*    -------    ----    --------------------
*     5760       1      -   S        Y     -
*     5757       2      -   M        B     -
*     5756       3      -   L   EXT ORDINAL-
*     5755       4      - EPT ADDRESS      -
*     5754       5      - EXT LINK ADDRESS -
      SPC 1 
* ERRORS DETECTED ARE:
*   1. DUPLICATE ENTRY POINTS 
*   2. MEMORY OVERFLOW IN ADDING NEW LST ENTRY
      SPC 1 
* CONTROL RETURNED FROM THIS SECTION TO -LDRIN-.
      SPC 1 
* WORDS USED FOR TEMPORARY STORAGE: 
      SPC 1 
*  LBUF - RECORD TYPE FLAG: =0, ENT.,=1, EXT. 
*  LBUF+1 - NEGATIVE COUNT OF ENT/EXT ENTRIES IN RECORD.
*  LBUF+2 - FIRST WORD ADDRESS OF CURRENT ENTRY.
*  NBUF+2 - HOLDS UPPER CHAR./WORD 3 OF ENTRY.
      SPC 1 
* SUBROUTINES CALLED: 
*   - LSTI -, - LSTP -, -RELEN-, -LINK- 
      SPC 2 
ENTR  CLA,RSS   ENT--SET A = 0 FOR FLAG.
EXTR  CLA,INA   EXT--SET A = 1 FOR FLAG.
      STA LBUF  STORE A FOR RECORD TYPE FLAG. 
      LDA LBUF+1   GET AND ISOLATE
      AND M.37     ENTRY COUNT OF RECORD- 
      CMA,INA      SET NEGATIVE FOR 
      STA LBUF+1   COUNTER IN PROCESSING
      LDA LBUFA    SET LBUF+2 = ADDRESS OF
      ADA C.03      FIRST ENTRY 
      STA LBUF+2    IN RECORD 
      JSB LSTI     INITIALIZE LST PROCESSOR 
ENTX1 JSB LSTP     SET LST ENTRY ADDRESSES
      JMP ENTX6    END OF LST- MAKE NEW ENTRY 
      SPC 1 
*  CHECK LST AND RECORD ENTRIES FOR MATCHING SYMBOLS
      SPC 1 
      LDB LBUF+2   (B) = RECORD ENTRY ADDR. 
      LDA B,I      GET WORD 1 REC. ENTRY, 
      CPA LST1,I    COMPARE TO WORD 1 LST ENTRY 
      INB,RSS      EQUAL, SET FOR WORD 2. 
      JMP ENTX1    NOT =, CHECK NEXT ENTRY
      LDA B,I      CHECK WORD 2 OF
      CPA LST2,I     THE ENTRIES
      INB,RSS      =, SET FOR WORD 3. 
      JMP ENTX1    NOT =, CHECK NEXT ENTRY. 
      LDA B,I      CHECK UPPER
      AND UPCM      CHARACTER IN
      STA NBUF+2     WORD 3 
      LDA LST3,I      OF BOTH RECORD
      AND UPCM         ENTRY AND
      CPA NBUF+2        LST ENTRY.
      RSS          EQUAL, SYMBOLS MATCH.
      JMP ENTX1    NOT =, CHECK NEXT ENTRY. 
      LDA LBUF     IF RECORD TYPE 
      SZA           IS EXT, 
      JMP ENTX4      GO PROCESS EXT.
      SPC 1 
*          ENT  RECORD. 
      SPC 1 
      CPA LST4,I    IF ENT ADDR. IN LST ENTRY = 0,
      JMP ENT21      GO TO SET ADDR. FROM RECORD. 
      CPA LIBFL     ENT ALREADY DEFINED.
      JMP LER7       A DUPLICATE ENTRY POINT ERROR. 
      JMP ENTX5     IGNORE DUPLICATE FROM LIBRARY.
      SPC 1 
* ADD ENTRY POINT ADDRESS TO LST ENTRY. 
      SPC 1 
ENT21 CPA LIBFL    A=0, IF LIBFL =0, THEN LOADING 
      JMP ENTX2     FROM INPUT. 
      SPC 1 
*                    LOADING FROM LIB.
      SPC 1 
      CLA,INA      SET EXMFL = 1 TO SAYLOAD THIS
      STA EXMFL     PROGRAM.  ENT MATCHES EXT.
ENTX2 LDA B,I      GET WORD 3 OF RECORD ENTRY.
      STA LST3,I    AND STORE IN LST WORD 3.
      INB          SET B=ADDR. WORD 4 RECORD ENTRY. 
      LDA LIBFL    WORD 3 (BIT 0 CONTAINS ENT RELOCA- 
      SZA,RSS       TION BYTE.) 
      JMP ENTX3    IF LOADING FROM INPUT,BRANCH.
      LDA B,I      LIBRARY LOADING. - SET ENTRY 
      CMA           POINT ADDRESS NEGATIVE IN LST - 
      STA LST4,I    ADDRESS WILL BE RELOCATED LATER.
      JMP ENTX5    GO TO COMPLETE ENTRY PROCESSING. 
      SPC 1 
* ENTRY FROM INPUT LOADING
      SPC 1 
ENTX3 JSB RELEN   (B) ADDR OF WORD 4 - RELOCATE ADDR
      LDA LST5,I   GET EXT LINK ADDRESS. IF LINK
      SZA           ESTABLISHED, STORE ENT. ADDRESS 
      STB A,I       IN LINK WORD. 
      JMP ENTX5    GO TO COMPLETE ENTRY PROCESSING. 
      SPC 1 
* EXT RECORD ENTRY MATCHES AN EXISTING LST ENTRY. 
      SPC 1 
ENTX4 LDA B,I      SET WORD 3 (BITS 07-00 CONTAIN 
      STA LST3,I    EXT ORDINAL) IN LST ENTRY 
      LDA LST5,I   IF THE EXT LINK WORD (WORD 5)
      SZA           IS NON-ZERO THEN LINKAGE
      JMP ENTX5      ALREADY SET. OTHERWISE, ESTA-
      JSB LINK       BLISH EXT LINK (A=0 CALL). 
      LDA LST4,I   STORE ENTRY POINT ADDRESS
      STA B,I       INT O EXT LINK
      STB LST5,I     WORD-SET EXT LINK ADDR. IN LST.
ENTX5 LDA LBUF     (A) = RECORD TYPE FLAG 
      LDB LBUF+2   (B) = RECORD ENTRY ADDR. 
      ADB C.03      ADD 3 FOR NEXT EXT ENTRY. 
      SZA,RSS      IF RECORD IS ENT,
      INB            ADD 2 MORE (4-WORD ENTRY). 
      STB LBUF+2   SET ADDRESS OF NEXT ENTRY. 
      ISZ LBUF+1   INDEX ENTRY COUNT -
      JMP ENTX1-1   MORE TO PROCESS.
      JMP LDRIN    FINISHED- GET NEXT RECORD. 
      SPC 1 
* NO MATCH IN LST FOR RECORD ENTRY SYMBOL - ADD 
*  NEW ENTRY - CHECK FIRST FOR MEMORY CONFLICT. 
      SPC 1 
* FOLLOWING WORD HOLDS ADDRESS OF MEMORY BOUNDARY 
*  USED IN CHECKING FOR OVERFLOW OF AVAILABLE 
*  MEMORY IN ADDING A NEW LST ENTRY. THE BOUNDARY 
*  IS FWA PROGRAM AREA WHEN ACTUAL LOADING IS 
*  BEING DONE.  THE BOUNDARY IS 2000(8) 
*  WHEN THE SIMULATED LOADING (OPTION) IS BEING DONE
      SPC 1 
OPT.3 DEF FWAM
ENTX6 LDA OPT.3,I   SUBTRACT LOWER LIMIT OF MEMORY
      CMA,INA       FROM LWA OF NEW 
      ADA LST5       LST ENTRY. 
      SSA          A NEGATIVE RESULT MEANS NEW ENTRY
      JMP LER5      EXTENDS INTO PROGRAM AREA-ERROR.
      CCB           OK. 
      ADB LST5      SET B = ADDR-1 OF NEW LST WORD 5. 
      LDA LWAM     SUBTRACT LWA AVAIL.MEMORY FROM 
      CMA,INA       LWA NEW ENTRY.  A POSITIVE
      ADA B         RESULT MEANS COMMON ORIGIN LT 
      SSA           LST ENTRY. NEGATIVE, THEN SET 
OPT.4 STB LWAM      LST5 AS NEW LWA AVAIL. MEMORY.
      SPC 1 
* PREVIOUS WORD IS CLEARED (NOP) IF ABSOLUTE RECORD 
*  OUTPUT OPTION IS SELECTED. 
      SPC 1 
      LDB LBUF+2    (B) = RECORD ENTRY ADDR.
      LDA B,I       MOVE WORDS 1 AND 2 OF RECORD
      STA LST1,I     ENTRY TO WORDS 
      INB             1 AND 2 NEW LST ENTRY 
      LDA B,I       (WORD 3 WILL BE SET LATER)
      STA LST2,I
      CLA           SET WORDS 4 AND 5 = ZERO
      STA LST4,I
      STA LST5,I
      INB          (B) = ADDR. OF WORD 3, REC. ENTRY
      ISZ LSTA,I    ADD 1 TO LST ENTRY COUNT. 
      CPA LBUF     (A) = RECORD TYPE FLAG.
      JMP ENTX2 
      JMP ENTX4     EXTERNAL ENTRY
      SPC 2 
* SUBROUTINE:  RELEN  (RELOCATE ENTRY POINT ADDRESS)
      SPC 1 
* CALLING SEQUENCE:  (B)= ADDRESS OF WORD 
*                         CONTAINING ENT ADDRESS
      SPC 1 
*             (P)   JSB  RELEN
*             (P+1)  -RETURN-  A-DESTROYED
*                        (B) = RELOCATED ENT ADDRESS
      SPC 1 
* PURPOSE:    RELOCATES  ENT  ADDRESS AS DESIGNATED 
*              BY THE RELOCATION FIELD (R) IN BIT 
*              00 OF (LST3).  0 = PROGRAM, 1 = BASE 
*               PAGE. 
      SPC 1 
*             IF ENT ADDRESS IS NEGATIVE ( FROM 
*              LIBRARY LOADING), IT IS  COMPLE- 
*              MENTED BEFORE RELOCATION.
      SPC 1 
*             BITS  07-00 OF (LST3) ARE SET = ZERO. 
      SPC 2 
RELEN NOP 
      LDB B,I       GET ENTRY POINT ADDRESS 
      SSB           IF NEGATIVE,
      CMB           SET POSITIVE. 
      LDA LST3,I    GET WORD 3 OF LST ENTRY 
      AND C.03      ISOLATE "R" FIELD.
      ADA RBTA      INDEX INTO RELOCATION BASE
      INA           TABLE TO GET EITHER PROGRAM,
      LDA A,I       BASE PAGE, OR COMMON RELOC. BASE
      ADB A         RELOCATE ENTRY POINT. 
      STB LST4,I    STORE IN LST ENTRY
      LDA LST3,I    GET LST ENTRY (WORD 3)
      AND UPCM      CLEAR BITS 0-7. RESTORE 
      STA LST3,I    IN LST. 
      JMP RELEN,I 
      SKP 
* LOADER  *** INITIALIZATION ***  SECTION * 
      SPC 1 
* THIS SECTION BEGINS EXECUTION OF THE LOADER.
* THE EXECUTION POINT IS AT THE ENTRY POINT:
      SPC 1 
*              .LDR.
      SPC 1 
*  LOCATIONS 00002 AND 00003 CONTAIN: 
      SPC 1 
*      (00002) -   JMP   3,I
*      (00003) -   DEF   .LDR.
      SPC 1 
*   AS SET BY PCS TO PROVIDE A COMMON 
*  STARTING POINT TO BEGIN LOADER 
*   EXECUTION.  THE INITIALIZATION
*   SECTION RESETS  LOCATION 00002 TO 
*   CONTAIN A HALT TO ELIMINATE RE-STARTING 
*   WITHOUT RE-LOADING AS THE LOADER IS 
*   NOT SELF-INITIALIZING.
      SPC 1 
* THE INITIALIZATION SECTION OCCUPIES THE 
*  AREA USED FOR THE LOADER INPUT BUFFER. 
      SPC 1 
* THE SWITCH REGISTER IS EXAMINED AS THE FIRST
*  STEP IN THE INITIALIZATION PHASE. THE SETTING
*  OF  BIT 15 DETERMINES WHETHER A LISTING OF 
*  PROGRAM NAMES, BOUNDS, ENTRY POINTS AND
*  ADDRESSES, COMMON AREA BOUNDS AND BASE PAGE
*  LINKAGE AREA. THE SETTING IS:
      SPC 1 
*          0 -  PRODUCE LISTING 
*          1 -  DELETE  LISTING 
      SPC 1 
* THE SETTING OF BIT 14 OF THE SWITCH REGISTER
*  DESIGNATES WHETHER AN ABSOLUTE BINARY TAPE OF
*  THE LOADED PROGRAMS IS TO BE PRODUCED DURING 
*  THE LOADING PROCESS.  THE SETTING OF BIT 14 IS:
      SPC 1 
*          0 - LOAD IN THE NORMAL MANNER
*          1 - PROVIDE A SIMULATED LOAD AND PRODUCE 
*               AN ABSOLUTE BINARY TAPE WHICH CAN 
*               BE LOADED BY THE ABSOLUTE BINARY
*               LOADER. 
      SPC 1 
* * IF THE ABSOLUTE RECORD OPTION IS NOT SELECTED,
* THE FIXED PORTION OF THE LOADER SYMBOL TABLE
* IS MOVED UP TO BE POSITIONED OVER THE OPTION
* SECTION.  THE SWITCHES FOR THE OPTION ARE ALL 
* CLEARED (NOP).
      SPC 1 
* AFTER THE INITIALIZATION PHASE IS COMPLETED,
*  CONTROL IS TRANSFERRED TO THE MAIN CONTROL 
*  SECTION, AT  -LDRIN- 
      SKP 
* FOLLOWING STATEMENT DEFINES LOADER BUFFER 
      SPC 1 
LBUFA DEF LBUF
MT.RC DEF HLT.B 
HLT.B ABS 106055B 
LBUF  OCT 000000,000000 
LBUF3 BSS 58
      SPC 3 
      ORG LBUF3    RESET ORIGIN FOR INITIALIZATION
*                  SECTION RELATIVE TO WORD 3 OF
*                  LOADER BUFFER. 
      SPC 2 
.LDR. LIA 01B       GET SWITCH REGISTER 
      SZB 
      LDB MTS 
      SZB 
      STB .JSB. 
      LDB ENDC5    RESET LOCATION 00002  TO 
      STB 00002B         BE A HALT. 
      STA MAPF     SET MAPPING FLAG (BIT 15). 
      RAL          POSITION BIT 14 TO BIT 15. 
      SSA,RSS      IF NORMAL LOADING, GO TO MOVE
      JMP L.2      LOADER SYMBOL TABLE-BIT 14 = 0.
      SPC 1 
* ABSOLUTE OPTION SELECTED
      SPC 1 
      LDA ENDL     RESET LWA AVAIL. MEMORY TO BE
      STA LWAM      AT END OF LOADER. 
      LDA FWABP    SET LWA+1 OF SYSTEM LINKAGE AREA 
      STA PLK4      IN ABSOLUTE SECTION.
      LDA A2000    RESET OPT.3 TO BE 2000(8)
      STA OPT.3     FOR ENT/EXT PROCESSOR.
      JSB LTG      PRODUCE LEADER 
      STA OPT.4     DO NOT RESET LWAM FOR NEW LST ENTRY.
      LDB MAPF      GET SSW CONTENTS AGAIN. 
      RBL,RBL       IF BIT 13 
      SSB            = 1, CLEAR -LOUTL- HALTS.
      JMP L.1        FOR ASR-35 USE.
      JSB .IOC.    GET EQUIPMENT
      OCT 040004     TYPE CODE FOR
      AND M77.      PUNCH OUTPUT DEVICE.
      SZA,RSS       IS PUNCH DEVICE A TELEPRINTER?
      JMP LSTS      HALTS IN LOUT.  BEGIN PROCESSING
      CLA           ENTER: A=0. 
L.1   STA OPT.5     CLEAR HALTS IN LOUT 
      STA OPT.6      AND
      JMP LSTS        BEGIN LOADING.
      SPC 1 
L.3   DEF LDRIN-1   NEW LWA OF AVAILABLE MEMORY.
A2000 DEF M2000     DEFINE ADDRESS OF 2000B.
MTS   ABS 114106B   JSB 00106B,I
M77.  OCT 037400    EQUIPMENT TYPE MASK.
      SPC 2 
* ABSOLUTE OPTION NOT SELECTED
      SPC 1 
L.2   LDA L.3      RESET LWA AVAIL. MEMORY TO 
      STA LWAM      BE : LDRIN-1. 
      SPC 1 
* MOVE LST TO OVERLAY ABSOLUTE OUTPUT OPTION
      SPC 1 
      LDA LST      GET NO. OF LST ENTRIES 
      ALS,ALS      -MULTIPLY
      ADA LST       BY 5. 
      CMA          COMPLEMENT FOR N*5*1 AND 
      STA LST1      SAVE AS COUNTER.
      LDB LSTA     (B) = ADDR. OF LST 
      LDA LWAM     (A) = CURRENT LWA AVAIL MEMORY.
      STA LSTA     SET LWA AS NEW ADDR. OF LST. 
      ADA LST1     SUBTRACT NO. WORDS IN LST TO GET 
      STA LWAM      NEW LWA AVAILABLE MEMORY. 
      INA          SET DESTINATION ADDRESS FOR MOVE 
      ADB LST1     GET SOURCE ADDRESS FOR LST 
      STA LST2
..5   INB           MOVE IN "B".
      LDA B,I        REPOSITION 
      STA LST2,I      LST 
      ISZ LST2         TO 
      ISZ LST1     START AT 
      JMP ..5            LDRIN-1
      CLA           CLEAR:
      STA OPT.1      STB ABREC+1
      STA OPT.2      JSB PUNCH
      STA DBL3       JSB PACK 
      STA OPT.7      JSB PLINK
      LDB FWABP 
      LDA HLT.B 
HLT55 STA B,I       STORE A HLT 55B (B) IN AVAIL. CORE. 
      INB           INCREMENT THE STORAGE ADDRESS.
      CPB LWAM      IS ALL OF AVAILABLE MEMORY PRESET?
      SPC 2 
      ORR          RESET ORIGIN TO LBUF3+58.
NBUF  BSS 9 
      SPC 1 
* THE CODE OF THE INITIALIZATION SECTION
*  MUST NOT OVERLAY THE FOLLOWING WORD. 
      SPC 1 
BND   RSS 
      JMP HLT55 
      STA LWAM,I
      JMP L.1-1 
      SPC 1 
LSTS  STA EXECP 
LWAMS JMP LDRIN 
      SPC 1 
NBUFA DEF NBUF     DEFINE ADDRESS OF NAM BUFFER.
      SKP 
* SUBROUTINE:  LSTP  / LSTI  (LST PROCESSOR)
      SPC 1 
* PURPOSE:  TO SET IN WORDS  LST1 - LST5 THE
*            ADDRESSES OF THE FIVE WORDS IN AN
*            ENTRY IN THE LST (LOADER SYMBOL TABLE) 
      SPC 1 
*           INITIAL SETUP IS MADE BY THE ROUTINE
*            -LSTI-   THIS SECTION INITIALIZES
*             THE NEGATIVE COUNT OF THE NUMBER
*             OF ENTRIES IN THE LST AND SETS THE
*             VALUE OF THE ADDRESS+1 OF THE 
*             FIRST ENTRY. THIS ADDRESS IS STORED 
*             IN LST5.
      SPC 1 
*           THE SECTION -LSTP- SETS THE FIVE
*             ADDRESSES OF THE NEXT LST ENTRY 
*             IN LST1-LST5.  IT ALSO INDEXES THE
*             ENTRY COUNTER.  WHEN THE COUNTER = ZERO 
*             EXIT FROM LSTP IS TO P+1 OF THE CALL
*             AND LST1-LST5 CONTAIN THE ADDRESSES 
*             FOR A NEW ENTRY.  IF THE COUNT AFTER
*             INDEXING IS NOT ZERO, EXIT IS TO
*             P+2 OF THE CALL.
      SPC 1 
*           LSTP SEQUENTIALLY SETS THE ADDRESSES
*            OF LST ENTRIES  1 TO N.
      SPC 1 
* CALLING SEQUENCE: (P-1)     JSB LSTI
*                   (P)       JSB LSTP
*                   (P+1)  (END OF LST RETURN)
*                   (P+2)  (NEXT ENTRY ADDRESSES
*                             SET RETURN) 
      SPC 2 
*             - INITIALIZER-
      SPC 1 
LSTI  NOP 
      LDA LSTA,I   GET NUMBER OF LST ENTRIES - SET
      CMA           NEGATIVE THE VALUE + 1. 
      STA LSTPX    STORE
      LDA LSTA     SET ADDRESS+1 OF WORD 1 OF FIRST 
      STA LST5      ENTRY IN LST5.
      JMP LSTI,I   EXIT 
      SPC 2 
*             - PROCESSOR - 
      SPC 1 
LSTP  NOP 
      LDA LST5     SUBTRACT 5 TO GET ADDR. OF WORD5 
      ADA CM.5      OF THE NEXT ENTRY 
      STA LST5      AND SET IN  LST5. 
      INA 
      STA LST4      SET FOR WORD 4. 
      INA 
      STA LST3      SET FOR WORD 3. 
      INA 
      STA LST2      SET FOR WORD 2. 
      INA 
      STA LST1      SET FOR WORD 1. 

      ISZ LSTPX     INDEX ENTRY COUNTER.
      ISZ LSTP     NOT END OF LST - SET P+2 EXIT
      JMP LSTP,I   -EXIT-  TO P+1 IF END OF LST.
      SPC 2 
LSTA  DEF LST     DEFINE STARTING ADDRESS OF LST
LSTPX OCT 0        HOLDS ENTRY COUNTER(NEG. #+1). 
LST1  OCT 0 
LST2  OCT 0 
LST3  OCT 0 
LST4  OCT 0 
LST5  OCT 0 
      SKP 
* SUBROUTINE:  DIAG  (DIAGNOSTIC OUTPUT)
      SPC 1 
* CALLING SEQUENCE: (A) 2-DIGIT (ASCII) ERROR CODE
      SPC 1 
*                (P)    JSB DIAG
*                (P+1)  (RETURN)
      SPC 1 
* DIAG STORES THE 2-DIGIT DIAGNOSTIC IDENTIFIER IN
*    THE SECOND WORD OF THE DIAGNOSTIC BUFFER - 
*    THE FIRST WORD CONTAINS   *L  .  THE DIAGNOSTIC
*    IS OUTPUT  AS   *LXX - XX IS THE NUMERIC CODE. 
      SPC 1 
*  AFTER THE DIAGNOSTIC IS OUTPUT, CONTROL
*   IS RETURNED TO THE CALLER.
      SPC 2 
DIAG  NOP 
      STA DBUF2   SET 2-DIGIT NUMBER IN BUFFER. 
      LDA DBUF     (A) = ADDR. OF BUFFER. 
      LDB C.04     (B) = 4 CHARS. OUTPUT. 
      JSB LOUTL    OUTPUT DIAGNOSTIC. 
      JMP DIAG,I   RETURN.
      SPC 1 
DBUF  DEF *+1 
      ASC 1,*L
DBUF2 ASC 1,00
      SPC 1 
* DIAGNOSTIC OUTPUT SECTION 
      SPC 1 
LER2  LDA ERR02     ILLEGAL RECORD
      JMP IN.3+1    GO TO HALT FOR RE-INPUT 
LER7  LDA ERR07     DUPLICATE ENTRY POINTS
      JMP ERROR 
LER10 LDA ERR10 
      JMP ERROR 
LER5  LDA ERR03     SYMBOL TABLE OVERFLOW 
      INA,RSS 
LER4  LDA ERR03     LINKAGE AREA OVERFLOW 
ERR09 INA,RSS 
LER3  LDA ERR03     MEMORY OVERFLOW 
ERROR JSB DIAG      PRINT DIAGNOSTIC
      JSB .IOC.     GO TO THE LIBRARY UNIT DEVICE.
      OCT 031403    REWIND REQUEST COMMAND CODE.
      JMP HALT      IGNORE ANY DRIVER REJECT RETURN.
      JMP HALT      ***  ERROR HALT  ***
      SPC 1 
ERR01 ASC 1,01
ERR02 ASC 1,02
ERR03 ASC 1,03
ERR06 ASC 1,06
ERR07 ASC 1,07
ERR08 ASC 1,08
ERR10 ASC 1,10
      SKP 
* SUBROUTINE: LOUT  (LOADER OUTPUT) 
      SPC 1 
* CALLING SEQUENCE:  (A)= ADDRESS OF BUFFER 
*                    (B)= NUMBER OF CHARACTERS
*                          IN BUFFER
      SPC 1 
*                (P)     JSB  LOUT
*                (P+1)   (RETURN)-OUTPUT COMPLETED, 
*                           (A),(B) MEANINGLESS.
      SPC 1 
* LOUT CONSTRUCTS A CALL TO IOC USING THE ENTRY 
*  PARAMETERS.  THE CALL IS TO THE TELETYPE OUTPUT
*  DEVICE (EQT ORDINAL 2). THE OPERATION IS 
*  HANDLED IN A NON-BUFFED MANNER- I.E., A STATUS 
*  AND DELAY IS EXECUTED AFTER THE WRITE CALL AND 
*  BEFORE RETURNING TO THE CALLER.
      SPC 1 
LOUT  NOP 
      STA LOUT1    SET BUFFER ADDRESS IN CALL 
      CMB,INB      SET NO. OF CHARS. NEGATIVE 
      STB LOUT2     AND SET IN CALL.
LOUT6 JSB .IOC.    CALL IOC FOR A WRITE REQUEST,
LOUT0 OCT 021002     ASCII MODE, TO TTY.
      JMP LOUT3     IGNORE ANY REJECT RETURN. 
LOUT1 NOP          BUFFER ADDR. 
LOUT2 NOP          CHAR. COUNT
LOUT3 JSB .IOC.    STATUS CALL FOR
LOUT4 OCT 040002     WRITE OPERATION. 
      STA SIX6      SAVE THE UNIT STATUS. 
      RAL,SLA      CHECK -O- FIELD. 
      JMP LOUT3     BUSY, DELAY.
      SSA,RSS       IS THE UNIT "NOT READY"?
      JMP LOUT,I   COMPLETED, EXIT. 
LOUT7 JSB .IOC.     GO PRINT "*EQR".
      OCT 021002    WRITE REQUEST.
      JMP LOUT7     REJECT RETURN.
      DEF EQR       OUTPUT BUFFER ADDRESS DEFINITION. 
      DEC -4        BUFFER LENGTH (CHARACTERS). 
LOUT5 JSB .IOC.     GO GET THE UNIT STATUS. 
      OCT 040002    STATUS REQUEST. 
      SSA           IS UNIT-REFERENCE 2 BUSY? 
      JMP LOUT5     YES, CONTINUE.
      LDA LOUT0     NO, LOAD THE I/O REQUEST WORD.
      AND M77       ISOLATE THE UNIT-REFERENCE #. 
      LDB SIX6      LOAD THE UNIT STATUS. 
      HLT 06B       WAIT FOR OPERATOR TO READY UNIT.
      JMP LOUT6     GO RETRY PRINT OPERATION. 
      SPC 1 
SIX6  NOP 
EQR   ASC 2,*EQR
      SKP 
* SUBROUTINE: -LOUTL- 
      SPC 1 
* CALLING SEQUENCE: (A) = ADDRESS OF BUFFER 
*                   (B) = NUMBER OF CHARACTERS
      SPC 1 
*           (P)   JSB LOUTL 
*           (P+1) -RETURN-, REGISTERS MEANINGLESS,
*                         RETURN/LINE-FEED OUTPUT,
*                         MESSAGE PRINTED.
      SPC 1 
* PURPOSE: THIS ROUTINE CALLS FOR A DOUBLE-SPACE
*          TO BE OUTPUT BEFORE THE MESSAGE OR 
*          LINE IS OUTPUT. IT USES -LOUT- TO
*          PERFORM THE OUTPUT.
      SPC 1 
*          THE HALTS AT -OPT.5- AND -OPT.6- ARE 
*          CLEARED IF THE ABSOLUTE OPTION IS NOT
*          SELECTED OR, IF IT IS, THE COMMENT OUT 
*          AND PUNCH OUTPUT UNITS ARE DIFFERENT 
*          PHYSICAL I/O DEVICES OR ARE DIRECTED 
*          TO AN ASR-35 (PARALLEL INTERFACE). 
      SPC 1 
*         OTHERWISE, THE HALTS ALLOW THE PUNCH
*          UNIT TO BE TURNED OFF, THE OUTPUT
*          PERFORMED, AND THE PUNCH TO BE TURNED ON.
      SPC 1 
LOUTL NOP 
      STA LT1      SAVE (A) 
      STB LT2       AND (B).
OPT.5 HLT 55B      TURN PUNCH OFF.
      LDA LINF     OUTPUT 
      CLB,INB       LINE-FEED AND 
      JSB LOUT       R/LF FROM DRIVER.
      LDA LINF      LOAD BUFFER ADDRESS DEFINITION. 
      CLB,INB       ENTER: B=1. 
      JSB LOUT      GO ISSUE A BLANK LINE.
      LDA LT1      RESTORE CALLER'S 
      LDB LT2       A AND B.
      JSB LOUT     PRINT MESSAGE. 
OPT.6 HLT 56B      TURN PUNCH ON. 
      JMP LOUTL,I  -RETURN- 
      SPC 1 
LINF  DEF BLANK    DEFINES ADDRESS OF : 
LT1   NOP 
LT2   NOP 
      SKP 
* SUBROUTINE -  (ENTRY POINT LIST)
      SPC 1 
* CALLING SEQUENCE: 
*          (A): =0, LIST UNDEFINED EXTERNAL SYMBOLS.
*               =1, LIST  ENTRY POINT SYMBOLS AND 
*                    ABSOLUTE ADDRESSES FROM LST. 
      SPC 1 
*        (P)     JSB  EPL 
*        (P+1)   (RETURN) A AND B DESTROYED 
      SPC 1 
* LIST UNDEFINED EXTERNAL SYMBOLS:  EACH LST ENTR 
*     IS EXAMINED FOR A ZERO ENTRY POINT ADDRESS. 
*     EACH ENTRY WITH A ZERO ENT ADDRESS (WORD 4) 
*     IS LISTED ON THE TTY OUT DEVICE.  THE 
*     LIST FORMAT IS: 
      SPC 1 
*         SYMB1 
*         SYMB2 
*         ----- 
*         ETC.
      SPC 1 
* LIST ALL ENTRY POINT SYMBOLS AND ADDRESSES: 
*     EACH ENTRY IN THE  LST IS OUTPUT TO THE 
*     COMMENT OUT DEVICE IN THE FORMAT: 
      SPC 1 
*        SYMB1  NNNNN    (NNNNN= ABSOLUTE ADDRESS)
*        SYMB2  NNNNN 
*        -----
*        SYMBN  NNNNN 
      SPC 1 
*    AT THE END OF THE PRINTOUT, THE BOUNDS OF THE
*     COMMON AREA ARE LISTED IF AN AREA WAS 
*     ALLOCATED:
      SPC 1 
*        *COM 
*         LLLLL UUUUU 
      SPC 1 
*     (LLLLL = COMMON ORIGIN, UUUUU = LWA COMMON) 
      SPC 1 
*    THE LISTING OF THE BOUNDS OF THE LINKAGE 
*     AREA IN BASE PAGE COMPLETES THE OUTPUT. 
*     THE FORMAT IS:
      SPC 1 
*       *LINK 
*        LLLLL UUUUU
      SPC 1 
*        (LLLLL= STARTING ADDRESS OF LINK AREA, 
*         UUUUU= ENDING ADDRESS OF LINK AREA) 
      SPC 1 
*  EPL  USES THE SUBROUTINE -CONV- TO CONVERT THE 
*    ABSOLUTE ADDRESSES TO ASCII FORMAT.
      SPC 2 
EPL   NOP          ENTRY/EXIT POINT 
      STA NBUF     SAVE ENTRY PARAMETER.
      JSB LSTI    -INITIALIZE LST PROCESSOR-
EPL1  JSB LSTP     SET LST ENTRY ADDRESSES
      JMP EPL4      END OF LST -- 
      SPC 1 
*                     PROCESS LST ENTRY 
      SPC 1 
      LDA LST1,I   MOVE FIRST 3 WORDS OF
      STA LBUF      LST ENTRY ( SYMBL ) 
      LDA LST2,I    TO
      STA LBUF+1     LBUF.
      LDA LST3,I   MAKE 6TH CHARACTER 
      IOR M.40      A BLANK 
      STA LBUF+2
      LDB LST4,I   (B) = ENT. ADDRESS 
      LDA NBUF     (A) = ENTRY PARAMETER
      SZA          IF ENT LIST REQUESTED
      JMP EPL2      GO TO CONVERT ADDRESS IN B. 
      SZB          IF ENT ADDR NOT = ZERO, THEN 
      JMP EPL1     EXT DEFINED,GO CHECK NEXT ENTRY. 
      LDB C.05    SET TO OUTPUT UNDEFINED 
      LDA LBUFA     EXT  (6 CHAR. OUTPUT) 
      JSB LOUTL     WRITE SYMBOL, 
      JMP EPL1       CONTINUE SCAN
      SPC 1 
* ENTRY POINT LIST
      SPC 1 
EPL2  LDA LBUFA    SET -CONV- TO CONVERT ENT. 
      ADA C.03      ADDRESS TO ASCII AND
      JSB CONV      STORE IN LBUF+3-LBUF+5. 
      LDB C.12      YES, LOAD RECORD LENGTH OF 12.
      LDA LBUFA     OUTPUT BUFFER 
      JSB LOUT      STARTING AT LBUF. 
      JMP EPL1     PROCESS NEXT ENTRY IN LST. 
      SPC 1 
* COMMON ALLOCATION BOUNDS LIST 
      SPC 1 
EPL4  LDA NBUF     IF LIST OF UNDEFINED EXTS
      SZA,RSS       REQUESTED, THEN EXIT. 
      JMP EPL,I 
      LDB COMOR    IF NO COMMON 
      SZB,RSS        ALLOCATED, THEN
      JMP EPL5       EXIT.
      SPC 1 
*  LIST  COMMON BOUNDS
      SPC 1 
      LDA LBUFA    CONVERT FWA (ORIGIN) 
      JSB CONV       OF  COMMON.
      LDB ENDL     CONVERT LWA
      JSB CONV       OF COMMON. 
      LDA CMMSG    OUTPUT 
      LDB C.05       MESSAGE
      JSB LOUTL       *COM. 
      LDA LBUFA    OUTPUT 
      LDB C.12      COMMON
      JSB LOUT       BOUNDS.
      SPC 1 
* BASE PAGE LINKAGE BOUNDS LIST 
      SPC 1 
EPL5  LDB LWABP    CONVERT
      CPB M1777       EXIT IF NO LINK AREA
      JMP EPL,I         ESTABLISHED IN LOADING. 
      INB           FWA OF
      LDA LBUFA     PROGRAM 
      JSB CONV       LINK AREA. 
      LDB M1777    CONVERT LWA OF 
      JSB CONV       LINK AREA. 
      LDA LINKM    OUTPUT 
      LDB M.07       MESSAGE
      JSB LOUTL      -*LINK-. 
      LDA LBUFA    OUTPUT 
      LDB C.12      LINK AREA 
      JSB LOUT       BOUNDS.
      JMP EPL,I    EXIT --. 
      SPC 2 
* CONSTANT AND STORAGE SECTION FOR -EPL- .
      SPC 1 
MAPF  OCT 000000   FLAG TO DESIGNATE WHETHER A
*          NAME AND BOUNDS LIST OR EPL LIST IS
*                   TO BE GENERATED : 
      SPC 1 
*                   BIT 15 : =0, YES
*                            =1, NO 
      SPC 1 
BLANK ASC 1,
C.12  DEC 12
CM.3  DEC -3
M.60  OCT 000060
CMMSG DEF *+1 
      ASC 3, *COMMON
LINKM DEF *+1 
      ASC 4, *LINKS 
      SKP 
* SUBROUTINE: CONV  (CONVERT 15-BIT BINARY NUMBER 
*                    TO 6-CHARACTER (LEADING BLANK) 
*                    ASCII FORM OF THE OCTAL
*                    REPRESENTATION.) 
      SPC 1 
* CALLING SEQUENCE: 
      SPC 1 
*             (A)-ADDRESS OF 3-WORD AREA FOR
*                   STORING ASCII/OCTAL CHARACTERS
*             (B)-BINARY VALUE FOR CONVERSION 
      SPC 1 
*       (P)    JSB  CONV
*       (P+1)  (RETURN)-(A)=NEXT ADDRESS OF STORAGE 
*                            AREA,(B)-DESTROYED.
      SPC 2 
CONV  NOP          ENTRY/EXIT POINT 
      STA NBUF+3   SAVE STORAGE AREA ADDRESS
      RBL          POSITION FIRST DIGIT TO B(15-13).
      LDA CM.3     SET CONVERT COUNTER
      STA NBUF+4     = -3.
      LDA M.40     MAKE FIRST CHARACTER A SPACE.
CONV1 ALF,ALF      ROTATE CHAR. TO UPPER POSITION 
      STA NBUF+5    AND SAVE. 
      BLF,RBR      POSITION NEXT DIGIT TO B(02-00), 
      LDA B         PUT IN B AND
      AND M.07       ISOLATE DIGIT. 
      IOR M.60     MAKE AN ASCII CHAR. (60 - 67). 
      IOR NBUF+5   PACK IN UPPER CHARACTER
      STA NBUF+3,I  AND STORE IN STORAGE AREA.
      ISZ NBUF+3   ADD 1 TO STORAGE AREA ADDRESS. 
      BLF,RBR      ROTATE NEXT DIGIT TO LOW B,
      LDA B         ISOLATE CHAR
      AND M.07       IN LOW A,
      IOR M.60      MAKE AN ASCII CHAR. 
      ISZ NBUF+4   INDEX CONVERT COUNTER
      JMP CONV1     NOT FINISHED. 
      LDA NBUF+3   FINISHED, SET (A)= NEXT STORAGE
      JMP CONV,I    AREA WORD ADDRESS AND EXIT. 
      SKP 
*  END CONDITION SECTION
      SPC 1 
* THIS SECTION RECEIVES CONTROL AFTER AN END- 
*  OF-TAPE CONDITION IS DETECTED BY THE INPUT 
*  SECTION *LDRIN*. THE MESSAGE -LOAD- IS OUTPUT
*  TO THE COMMENT OUT DEVICE FOLLOWED BY A
*  COMPUTER HALT. THE SWITCH REGISTER IS TO 
*  BE SET TO ONE OF THE FOLLOWING VALUES BY 
*  THE OPERATOR BEFORE RESTART: 
      SPC 1 
*     SR(02-00)         MEANING 
*     ---------   ----------------------------
*        000      LOAD NEXT PROGRAM FROM INPUT
*        001      END OF LOADING
*        010      TERMINATE LOADING 
*        100      LOAD FROM PROGRAM LIBRARY 
      SPC 1 
*     SWITCH 15 IS ALSO USED TO SET THE MAP FLAG
*      FOR THE NEXT LOADING SEQUENCE: 
      SPC 1 
*         BIT 15 = 0, PRODUCE LIST, = 1, DELETE 
      SPC 1 
*    THE ACTION RESULTING FROM EACH SR DESIG- 
*     NATION IS DETAILED IN THE COMMENTS BELOW. 
      SPC 1 
* PROGRAM EXECUTION IS INITIATED WITHIN THIS
*  SECTION STARTING AT THE LABEL  *ENDC4*.
      SPC 1 
* ** NOTE: THIS SECTION MUST BE THE LAST SECTION
*     IN THE LOADER BECAUSE OF DETERMINING
*     COMMON LWA AND FOR RELEASING THE AREA 
*     OF MEMORY OCCUPIED BY THE LOADER. 
      SPC 2 
LDMSG DEF *+1 
      ASC 3,*LOAD 
RUNM  DEF *+1 
      ASC 2,*RUN
LSTM  DEF *+1 
      ASC 2,*LST
      SPC 1 
ENDC  LDA RIC      IGNORE END-OF-TAPE CONDITION 
      SZA,RSS       OCCURRING BEFORE THE FIRST
      JMP LDRIN     RECORD HAS BEEN INPUT.
      LDA LIBFL    IF END-OF-TAPE HAS OCCURRED
      SSA           IN LOADING FROM LIBRARY, GO 
      JMP REW.L     TO LIST UNDEFINED EXTS. 
ENDC1 LDA LDMSG    WRITE MESSAGE
      LDB C.05      -*LOAD- ON TTY
      JSB LOUTL      OUT DEVICE.
      SPC 1 
* FOLLOWING HALT IS FOR SWITCH REGISTER 
*  SETTING BY OPERATOR. 
      SPC 1 
      HLT 01B 
      SPC 1 
* EXAMINE  SR CONTENTS UPON RESTART 
      SPC 1 
      CLB          CLEAR RIC TO PROVIDE FOR IGNORING
      STB RIC       EOT BEFORE FIRST RECORD INPUT.
      STB LIBFL         CLEAR LIB. LOAD FLAG
      LDA IN5           -INSURE 
      STA IN.1           THAT 
      LDA LBUFA 
      STA ADDR. 
      LDA IN6            INPUT CALLS WILL 
      STA IN.2           REFERENCE
      LDA IN7            STANDARD INPUT 
      STA IN.4           UNIT.
      LIA 01B       GET SWITCH REGISTER 
      STA MAPF     SET MAPPING FLAG  (BIT 15).
      AND M.07     ISOLATE SWITCHES 02-00 . 
      SZA,RSS      IF SR = 0, 
      JMP LDRIN     GO TO LOAD NEXT PROGRAM 
      SLA          IF SR = 1, GO TO CHECK 
      JMP ENDC2     FOR UNDEFINED EXTS. 
      LDB UEXFL     LOAD THE UNDEF. EXTS. FLAG. 
      SZB,RSS       ARE ANY EXT. SYMBOLS UNDEFINED? 
      ARS,SLA       IF SR = 2, TERMINATE ALL
      JMP ENDC3       LOADING 
      SPC 1 
* ASSUME SR = 4 AND SET TO LOAD FROM PROGRAM LIBRARY
      SPC 1 
      CCA          SET LIBRARY LOAD FLAG
      STA LIBFL     = -1. 
      LDA LIB1     SET WORD 2 OF
      STA IN.1      EACH IOC CALL IN
      LDA LIB2       INPUT SECTION TO REFERENCE 
      STA IN.2        PROGRAM LIBRARY IN SQT. 
      LDA LIB3
      STA IN.4
      JSB .IOC.    REWIND LIB. UNIT IF
      OCT 031403     MAG. TAPE. 
      JMP ENDR6    - IGNORE REJECT IF NOT MT. 
      LDA MT.RC     LOAD THE MT BUFFER ADDRESS. 
      STA ADDR.     STORE THE INPUT BUFFER ADDRESS. 
SEOF  JSB .IOC.    SKIP FILE FORWARD TO POSITION
      OCT 031703
      JMP SEOF     OF FILE 2. 
MTBUS JSB .IOC.    DELAY WITH 
      OCT 040003         STATUS UNTIL 
      RAL,SLA,ALF        UNIT NOT BUSY
      JMP MTBUS 
      ALF,SLA       WAS AN "EOF" RECORD READ? 
      JMP ENDR6     YES, GO CHECK UNDEFINED EXTS..
      JMP SEOF      CHECK NEXT RECORD.
      SPC 2 
LIB1  OCT 010303
LIB2  OCT 040003
LIB3  OCT 031203
IN5   OCT 010305
IN6   OCT 040005
IN7   OCT 031205
      SPC 1 
* END OF LOADING  ( SR = 1) 
      SPC 1 
ENDC2 LDA UEXFL    IF NO UNDEFINED EXTS 
      SZA           THEN GO OUTPUT
      JMP ENDC3      ENTRY POINT LIST.
      JSB EPL      LIST ALL UNDEFINED EXTS IN LST 
      JMP ENDC1    REPEAT HALT AND SR SETTING.
      SPC 1 
ENDPR NOP           ENTRY POINT.
      LDA LSTM      LOAD OUTPUT BUFFER ADDRESS. 
      LDB C.04      LOAD: B=4.
      JSB LOUTL     GO PRINT: "*LST". 
      HLT 00B       ALLOW FOR SELECTION OF LST PRINT. 
      LIB 01B       LOAD THE SENSE SWITCH REGISTER. 
      CLA,INA       ENTER: A=1. 
      SSB,RSS       IS THE LST TO BE LISTED?
      JSB EPL       YES, GO PRINT THE LST.
      JMP ENDPR,I   RETURN. 
      SPC 2 
ENDL  DEF .DEF. 
      SPC 1 
*                                   SECTION OF LOADER OR
*                                   LWA OF  COMMON. 
      SPC 1 
ENDC3 CCA           (A) = COMMON ORIGIN 
      ADA COMOR     GET ADDRESS OF WORD PRIOR TO COM..
      SSA           IF A=-1 (NO COMMON ALLOCATED) 
      LDA ENDL      SET A = LWA OF RELEASABLE MEMRY 
      STA LWAM     SET LWA AVAIL.MEMORY FOR EXECUTE 
      LDA EXECP       SET (A) = EXECUTION 
      SZA             POINT ADDR.  IF NO ADDR.
      JMP OPT.7        PRESENT, OUTPUT DIAGNOSTIC.
ENDC4 LDA ERR08     SET ASCII  08 FOR DIAGNOSTIC -
      JSB DIAG     NO EXECUTION POINT ADDRESS.
      CLA           ENTER: A=0. 
ENDC5 HLT 02B 
      SZA,RSS       WAS A VALID ADDRESS ENTERED?
      JMP ENDC4     NO, GO REPEAT THE DIAGNOSTIC. 
      SPC 1 
*  EXECUTION POINT MAY BE CHANGED - NEW ADDRESS IN A
      SPC 1 
      STA EXECP    SET EXECUTION POINT ADDRESS. 
      SPC 1 
* FOLLOWING WORD IS CLEARED IF THE ABSOLUTE 
*  RECORD OUTPUT OPTION IS NOT SELECTED.
*  OTHERWISE THE ROUTINE -PLINK- IS ENTERED 
*  WHICH PUNCHES THE LINKAGE AREAS AND IOC
*  AND THE I/O DRIVERS AS PART OF THE ABSOLUTE
*  TAPE. CONTROL IS NOT RETURNED. 
      SPC 1 
OPT.7 JMP PLINK 
      SPC 1 
* CHECK FOR -LST- TO BE PRINTED.
      SPC 1 
      JSB ENDPR     GO PROCESS "LST" AND EJECT. 
      SPC 2 
* EXECUTION SECTION 
      SPC 1 
      LDA RUNM      OUTPUT MESSAGE. 
      LDB C.04       - * RUN -
      JSB LOUTL 
      HLT 00B       HALT FOR EXECUTION SET-UP.
      JSB .IOC. 
C.03  OCT 000003    CLEAR REQUEST FOR "LIB" UNIT. 
      SPC 1 
* SET REGISTERS FOR ENTRY TO LOADED PROGRAMS
      SPC 1 
      LDA MEMRY    (A) = ADDRESS OF MEMORY TABLE. 
      LDB LSTA     (B) = ADDRESS OF LST 
      CLO          CLEAR OVERFLOW,
      CLE 
      JSB EXECP,I   BEGIN EXECUTION 
      SPC 1 
* FOLLOWING HALT IS PROVIDED FOR A COMMON RETURN
*  FROM EXECUTION.
      SPC 1 
.DEF. DEF *+1 
      SPC 1 
HALT  CLA 
.JSB. HLT 77B 
.106. JMP .JSB. 
      SPC 1 
HLT77 HLT 77B       STAND-ALONE HALT. 
      JMP HLT77     PROTECT THE HALT. 
      SPC 1 
*****   MEMORY  TABLE   *********** 
      SPC 1 
MEMRY DEF *+1      DEFINES ADDRESS OF MEMORY TABLE
.MEM. EQU MEMRY    DEFINE NAME FOR LST. 
FWABP OCT 0        DEFINES AVAILABLE MEMORY 
LWABP OCT 1777      FOR BASE PAGE 
FWAM  OCT 2000     DEFINES AVAILABLE MEMORY 
LWAM  ABS .LWA.-1       FOR PROGRAM AREA. 
LWAM1 OCT 0         LWA OF BCS
      SPC 1 
***** END OF B C S RELOCATABLE LOADER ***** 
      SPC 1 
      END .LDR. 
