ASMB,A,B,L,T,C
      HED ***  16K - 32K SIO SYSTEM DUMP  ***               (JRW) 
      ORG 35000B
      SPC 1 
****** S I O  DUMP  ********
      SPC 1 
* PURPOSE:    THIS PROGRAM PRODUCES AND ABSOLUTE
*             BINARY TAPE OF THE SYSTEM INPUT/
*             OUTPUT DRIVERS, LOCATIONS 4, 5 AND THE
*             SIO LINKAGE AREA. 
      SPC 1 
*             -OPTIONALLY, A PROGRAMMING SYSTEM 
*              MAY BE DUMPED IN CONJUCTION WITH 
*              THE SIO DRIVERS. 
      SPC 1 
* OPERATION:  -SDUMP-  IS LOADED AFTER THE APPROPRIATE
*             S10 DRIVERS HAVE BEEN LOADED AND
*             CONFIGURED.  (THE PROGRAMMING SYSTEM, 
*             E.G., EDITOR, ASSEMBLER, FORTRAN PASS 1,
*             ETC., SHOULD BE LOADED BEFORE 
*             OPERATING -SDUMP- IF THE SYSTEM IS
*             TO BE DUMPED WITH SIO.) 
      SPC 1 
*             SDUMP DUMPS IN ABSOLUTE FORMAT THE
*              AREA: 4, 5, 101-104, 106-107 AND 
*              (106)+1 TO (X)7677 FOR THE 
*              SIO DRIVERS AND LINKAGE AREA.
*             -IF SWITCH 15 = 1  THE PROGRAMMING
*              SYSTEM IS TO BE DUMPED.  THIS AREA IS: 
*              6-100, 105, 107 TO (105)-1 
      SPC 1 
*             SDUMP USES THE PUNCH OUTPUT DEVICE
*             AND DRIVER OF SIO BY REFERENCING
*             LOCATION 103. 
      SPC 1 
*             SDUMP IS EXECUTED STARTING AT LOCATION
*                2:  (2)   JMP  3,I 
*                    (3)   DEF  SDUMP 
      SPC 1 
*             MULTIPLE COPIES OF THE DUMP OUTPUT
*             MAY BE OBTAINED BY RESTARTING SDUMP 
*             AT THE END OF EACH OUTPUT PHASE.
      SKP 
      ORG 00002B
      SPC 1 
      JMP 00003B,I  STARTING
      DEF SDUMP     POINT 
      SPC 2 
      ORR 
      SPC 1 
SDUMP JSB LTG       GENERATE LEADER 
SSW   EQU 01B       SWITCH REGISTER ADDRESS DEFINITION. 
      LIA SSW       CHECK SWITCHES FOR SIGN BIT 
      SSA           IF SWITCH 15=1 DUMP SYSTEM
      JMP SYSTM 
      LDA C.04      DUMP
      LDB C.05      LOCATIONS 4 AND 5 
      JSB PNCHA 
      LDA A101      DUMP
      LDB A104      LOCATIONS  101 - 104. 
      JSB PNCHA 
      LDB A106
      CCA 
MT.D  EQU 00107B    MT OR DISC/DRUM DRIVER LINK ADDRESS.
      ADA MT.D      "SUBTRACT": (00107B) - 1. 
LWA   EQU 00106B    DEFINITION OF LAST WORD ADDRESS OF AVAIL. MEM.. 
      CPA LWA       IS A MASS STORAGE DRIVER IN THE SYSTEM? 
      INB 
      LDA A106
      JSB PNCHA     106. (LWA AVAILABLE MEMORY) 
DRIVR LDA LWA       GET LWA AVAIL. MEMORY 
      AND MDULE     ISOLATE MODULE ADDRESS AND
      IOR M7677     ADD 7677B TO GET LWA
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      STA B         FOR DUMPING S10.
      LDA LWA       SET (A) = STARTING
      INA           ADDRESS OF S10 PACKAGE. 
      JSB PNCHA     DUMP S10 DRIVER PACKAGE 
      JMP TRAIL     TO GENERATE TRAILER.
      SPC 2 
*  DUMP PROGRAMMING SYSTEM  (SWITCH 15 = 1) 
      SPC 1 
SYSTM LDA C.04      DUMP LOCATIONS 4 THROUGH
      CCB           (105)-1 
FWA   EQU 00105B    DEFINITION OF FIRST WORD ADDRESS OF AVAIL. MEM..
      ADB FWA       "SUBTRACT": (00105B) - 1. 
      JSB PNCHA 
      JMP DRIVR 
      SPC 1 
TRAIL JSB LTG       GENERATE TRAILER. 
      HLT 77B       HALT - END OF DUMP. 
      JMP SDUMP     RESTART, REPEAT DUMP. 
      SPC 2 
*  SUBROUTINE- PNCHA  (PUNCH ABSOLUTE BLOCK)
      SPC 1 
*  CALLING SEQUENCE:  (A) = FWA OF BLOCK
*                     (B) = LWA OF BLOCK
*                     (P) - JSB PNCHA*
*                     (P+1) - (RETURN)
      SPC 1 
PNCHA NOP 
      STA T1        SAVE FIRST AND LAST WORD
      STB T2        ADDRESSES OF BLOCK. 
      CLA           ENTER: A=0. 
P1    STA BUFFR     INITIALIZE THE WORD COUNT.
      LDA CM.27     SET T3 = -27 AS INDEX FOR 
      STA T3        FILLING BUFFER. 
      LDA T1        SET BUF+1 FOR LOAD ADDRESS
      STA BUFFR+1   OF CURRENT BLOCK. 
      STA CKSUM     INITIALIZE CHECKSUM WORD. 
      LDA BUF       SET T4 = ADDRESS
      ADA C.02      OF WORD 3 OF BUFFER 
      STA T4        FOR STORING WORDS.
P2    LDA T1,I      STORE CURRENT WORD FORM MEMORY
      STA T4,I      BLOCK IN BUFFER.
      ISZ T4        ADD 1 TO BUFFER ADDRESS.
      ADA CKSUM     ADD WORD TO CUMULATED 
      STA CKSUM     CHECKSUM
      ISZ BUFFR     COUNT WORD STORED IN BUFFER.
      LDA T1        CHECK FOR END OF BLOCK. 
      CPA T2
      JMP P3        YES, FWA = LWA. 
      ISZ T1        NO, ADD 1 TO BLOCK ADDRESS. 
      ISZ T3        INDEX BUFFER COUNTER. 
      JMP P2        BUFFER NOT YET FILLED.
P3    LDA CKSUM     BUFFER FILLED.  SET CHECKSUM IN 
      STA T4,I      LAST WORD IN BUFFER.
      LDA BUFFR     POSITION RECORD 
      ALF,ALF       WORD COUNT TO 
      STA BUFFR     UPPER CHARACTER IN WORD 1.
      ALF,ALF       REPOSITION, ADD 3 FOR 
      ADA C.03      TOTAL RECORD LENGTH, SET
      CMA,INA       NEGATIVE FOR OUTPUT.
      LDB BUF       (B) = ADDR. OF BUFFER.
PU.D  EQU 00103B    PUNCH DRIVER LINK ADDRESS.
      JSB PU.D,I    ---PUNCH RECORD---. 
      LDA T3        LOAD THE BUFFER INDEX.
      SZA           END OF LOGICAL BLOCK? 
      JMP PNCHA,I   YES, EXIT.
      JMP P1        NO, SET NEXT RECORD.
      SKP 
*  SUBROUTINE:  LTG  (LEADER/TRAILER GENERATOR) 
      SPC 1 
*  CALL: (P)  JSB LTG 
*        (P+1)  -RETURN-
      SPC 1 
*  LTG PRODUCES APPROXIMATELY 10 INCHES 
*   OF BLANK TAPE (FEED-FRAMES) 
      SPC 1 
LTG   NOP 
      LDB CM.27 
      LDA BUF 
      STA T1
      CLA           ZERO
ZERO  STA T1,I      PUNCH 
      ISZ T1        BUFFER
      INB,SZB 
      JMP ZERO
      LDA CM.27     PUNCH 
      LDB BUF       BUFFER
      JSB PU.D,I    (ZERO-FILLED) 
      LDA CM.27     2 
      LDB BUF       TIMES.
      JSB PU.D,I
      JMP LTG,I     EXIT. 
      SPC 3 
*  TEMPORARY STORAGE
      SPC 1 
T1    NOP 
T2    NOP 
T3    NOP 
T4    NOP 
C.02  DEC 2 
C.03  DEC 3 
C.04  DEC 4 
C.05  DEC 5 
CM.27 DEC -27 
CKSUM NOP 
MDULE OCT 070000
M7677 OCT 007677
A101  ABS 00101B
A104  ABS 00104B
A106  DEF LWA 
      SPC 1 
*  PUNCH BUFFER 
      SPC 1 
BUF   DEF BUFFR 
BUFFR BSS 30
      SPC 1 
              END 
