#!/bin/bash
#
# SENDTOHP - SEND FILE TO HP MINI USING SIMULATED HP PROGRAM
# FOR THE 5/23/10 VERSION OF SENDTOHP.IPL
#
if [ -e $1 ];then
# ------- edit below as needed -----------------------------
hp2100="hp2100"                  # [path/]name of simulator
termwin="xterm"                  # terminal window to run in
serial=/dev/ttyS0                # serial port device
absfil=~/sendtohp/sendtohp.abs   # path/name of sendtohp.abs
simscr=~/sendtohp/simscr.tmp     # path/name of temp script
stty -F $serial 9600 raw -crtscts cs8 -echo  # port setup
# ----------------------------------------------------------
echo "set cpu 21MX"       >  $simscr
echo "set cpu 64K"        >> $simscr
echo "set clk dev=10"     >> $simscr
echo "set tty dev=11"     >> $simscr
echo "set ptr dev=12"     >> $simscr
echo "set ptp dev=13"     >> $simscr
echo "set tty1 8B"        >> $simscr
echo "load $absfil"       >> $simscr
echo "d ptr trllim 255"   >> $simscr
echo "attach ptr $1"      >> $simscr
echo "d 117 7"            >> $simscr  # 0=plain 1=ANSI 3=UC 5=ANSI blink 7=UC blink
echo "d 120 4"            >> $simscr  # background color
echo "d 121 7"            >> $simscr  # text color
echo "d 122 12"           >> $simscr  # box color
echo "d 123 3"            >> $simscr  # bar color
echo "d 124 16"           >> $simscr  # CPU FG
echo "d 125 4"            >> $simscr  # CPU BG
echo "d 126 11"           >> $simscr  # LED color
echo "run 2"              >> $simscr
echo "d ptr trllim 0"     >> $simscr
echo "attach ptr $serial" >> $simscr
echo "attach ptp $serial" >> $simscr
echo "c"                  >> $simscr
$termwin -e $hp2100 $simscr
# some terminals like gnome-terminal require this instead...
# $termwin -e "$hp2100 $simscr"
rm $simscr
fi

