' Adds PC files to a SIMH and HP-IPL/OS compatible magtape file
'
' HP-IPL/OS magtape file format:
'  1st record 32 words, 1st 15 are significant...
'   offset 0 = 6912 dec 15400 octal
'   offset 1 = 0 for text or load address for binary
'   offset 2 = data record length in words
'   offset 3 = number of data records = 1
'   offset 4 = 3338 dec 6412 octal (fn marker, a crlf)
'   offset 5-14 dec = filename in high/low packed format
'  Gap+Second record is the data record, padded with a space
'   if original byte length was odd. Applicable only if 15400
'   and 6412 markers and the data record are actually present,
'   bootable files consist of only one record.
'  Gapmark
'  More MT files
'  Final Gapmark
'
' SIMH magtape file format:
'  32 bit byte-count header, least significant bytes first, for
'     64Kbyte max files comes out: LSB MSB 0 0  (LSB should be even)
'  Specified number of bytes
'  Another copy of the 32 bit byte-count header
'  More header/data/header records
'  Filemark = 0 0 0 0
'  More header/data/header ... Filemark files
'  Final Filemark = 0 0 0 0
'  End of medium = 255 255 255 255
'
PRINT
PRINT "*** MAKE_MT ***  Version 1.0  12/4/02"
PRINT
PRINT "This program adds PC files to a HP-IPL/OS-compatible"
PRINT "SIMH magtape volume, ready to import using MTRESTORE."
PRINT "Max filesize supported by HP-IPL/OS' TOS and this program"
PRINT "is 65534 bytes. Each PC file is added to the magtape file"
PRINT "as a 32 word header record containing filename and length"
PRINT "followed by a data record containing the PC file, padded"
PRINT "with a space if the PC file length is odd."
PRINT
PRINT "Press just enter to exit or finish."
INPUT "Output file (erases): ", outfile$
outfile$ = LTRIM$(RTRIM$(outfile$))
IF outfile$ = "" THEN CLS : SYSTEM
ON ERROR GOTO baderror
OPEN outfile$ FOR OUTPUT AS #1
nfiles = 1
addloop:
ON ERROR GOTO oops
PRINT "File "; RIGHT$(" " + STR$(nfiles), 2);
INPUT ": ", infile$: infile$ = LTRIM$(RTRIM$(infile$))
IF infile$ = "" GOTO finish
OPEN infile$ FOR INPUT AS #2: CLOSE #2 'trigger oops if bad filename
ON ERROR GOTO baderror
OPEN infile$ FOR APPEND AS #2
flen& = SEEK(2) - 1: CLOSE #2  'get file length in bytes
IF flen& > 65534 THEN PRINT "That file is too big!": GOTO addloop
OPEN infile$ FOR BINARY AS #2
odd = 0  'initialize getbyte routine
'write "File" header to MT file...
PRINT #1, CHR$(64); CHR$(0); CHR$(0); CHR$(0);       'write record header
PRINT #1, CHR$(27); CHR$(0); CHR$(0); CHR$(0);  'write 15400, la=0 (File)
lenhigh% = INT(flen& / 256) AND 255
lenlow% = (flen& - lenhigh% * 256) AND 255
hlen& = flen&: IF (flen& AND 1) = 1 THEN hlen& = flen& + 1 'make hlen even
hlenhigh% = INT(hlen& / 256) AND 255
hlenlow% = (hlen& - hlenhigh% * 256) AND 255
wlen& = hlen& / 2
wlenhigh% = INT(wlen& / 256) AND 255
wlenlow% = (wlen& - wlenhigh% * 256) AND 255
' PRINT "Byte len = "; OCT$(flen&); " Header len = "; OCT$(hlen&); " Word len = "; OCT$(wlen&)
PRINT #1, CHR$(wlenhigh%); CHR$(wlenlow%); 'record len in words
PRINT #1, CHR$(0); CHR$(1);              'number of records = 1
PRINT #1, CHR$(13); CHR$(10);            'crlf
tapefile$ = infile$ + "                    "  'space-pad filename
FOR i = 1 TO 20: PRINT #1, MID$(tapefile$, i, 1); : NEXT i 'write filename
FOR i = 1 TO 17: PRINT #1, "  "; : NEXT i   'fill rest of rec with spaces
PRINT #1, CHR$(64); CHR$(0); CHR$(0); CHR$(0);  'write dup record header
'copy file to the next record...
PRINT #1, CHR$(hlenlow%); CHR$(hlenhigh%); CHR$(0); CHR$(0);  'write header
FOR i& = 1 TO flen&: GOSUB getbyte: PRINT #1, CHR$(byte); : NEXT i& 'copy file
IF (flen& AND 1) = 1 THEN PRINT #1, " ";  'pad with space if odd
PRINT #1, CHR$(hlenlow%); CHR$(hlenhigh%); CHR$(0); CHR$(0);  'write dup header
PRINT #1, CHR$(0); CHR$(0); CHR$(0); CHR$(0);  'write file marker
CLOSE #2: nfiles = nfiles + 1: GOTO addloop

finish:
ON ERROR GOTO baderror
PRINT #1, CHR$(0); CHR$(0); CHR$(0); CHR$(0);
PRINT #1, CHR$(255); CHR$(255); CHR$(255); CHR$(255);
CLOSE : CLS : SYSTEM

oops:
CLOSE #2: PRINT "File not found, try again..."
RESUME addloop

baderror:
PRINT "Error": CLOSE : SYSTEM

getbyte:
'return one byte in byte from file #2
'has to get 2 bytes from file then split between calls
IF odd = 0 THEN
GET #2, , inword%  'get 2 bytes
iwv = inword%
IF iwv < 0 THEN iwv = iwv + 65536
byte = iwv - INT(iwv / 256) * 256 'return low byte
odd = 1
ELSE
byte = INT(iwv / 256) 'return high byte
odd = 0
END IF
RETURN

