ASMB,R,B,L
      NAM LIB.B 
      END 
ASMB,R,B,L,T,C
      NAM MEMRY 
      HED ***  BCS MEMORY ALLOCATION ROUTINE  ***            (JRW)
*     MEMORY ALLOCATION ROUTINE - 
      SPC 2 
*     REQUESTS MAY BE MADE TO ALLOCATE AND RELEASE BUFFERS
*     FROM THE MEMORY AVAILABLE AFTER LOADING.
      SPC 1 
*         1. ALLOCATE: CALLING SEQUENCE - 
*            (P)     JSB .ALC.
*            (P+1)   (# OF WORDS NEEDED)
*            (P+2)   -RETURN- 
      SPC 1 
*                    (A) = FWA BUFFER 
*                    (B) = # OF WORDS ALLOCATED (MAY BE > (P+1))
      SPC 1 
*         2. RELEASE BUFFER TO AVAILABLE MEMORY 
      SPC 1 
*            (P)     JSB .RTN.
*            (P+1)   (FWA OF BUFFER)
*            (P+2)   (# OF WORDS RETURNED)
*            (P+3)   -RETURN- (ALL REGISTERS UNCHANGED) 
      SPC 1 
*         3. CLEAR - RETURN ALL BUFFERS, INSERT THE FOLLOWING BEFORE
*                    ANY ALLOCATION CALLING SEQUENCE: 
      SPC 1 
*                    CLA
*                    STA .CLR.
      SPC 1 
*     IF A REQUEST FOR A BUFFER OF LENGTH X CANNOT BE FILLED
*     DURING A GIVEN CALL, RETURN IS MADE WITH: 
      SPC 1 
*         (A) = 0 
      SPC 1 
*     IF, WHEN BUFFER REQUESTED, - (AVMEM) - SHOWS INSUFFICIENT CORE
*     AVAILABLE TO CONTAIN A BUFFER OF THE LENGTH REQUESTED,
*     THEN RETURN IS MADE WITH: 
      SPC 1 
*         (A) = -1
*         (B) = MAXIMUM LENGTH BUFFER THAT THE PROGRAM MAY ALLOCATE.
      SPC 1 
*     TO FIND OUT HOW LARGE A BUFFER MAY BE ALLOCATED, USE THE CALL 
      SPC 1 
*                   JSB .ALC. 
*                   DEC 32767 
      SPC 1 
*     BLOCKS OF MEMORY AVAILABLE FOR OUTPUT BUFFERING ARE LINKED THROUGH
*     THE FIRST TWO WORDS OF EACH BLOCK - 
      SPC 1 
*         WORD1 -  LENGTH OF BLOCK
*         WORD2 - ADDRESS OF NEXT BLOCK (OR 77777 IF THIS IS LAST BLOCK)
      SPC 1 
*     THE ALLOCATOR 'TRANSFERS' THE UPPER END OF A BLOCK TO IOC AND 
*     SHORTENS THE LENGTH OF THE BLOCK BY THE AMOUNT 'TRANSFERRED'
      SPC 3 
      ENT .ALC.,.RTN.,.CLR. 
      EXT .MEM. 
      SKP 
.ALC. NOP           ENTRY POINT TO ALLOCATE MEMORY
      CLA           SET .RTN. TO INDICATE STATUS O
INT   EQU 00B       INTERRUPT SYSTEM FLAG ADDRESS.
      SFC INT       OF THE INTERRUPT
      CLA,INA       ENTER: A=1. 
      CLF INT       DISABLE THE INTERRUPT SYSTEM. 
.A22  STA .RTN.     SO WE KMOW WHETHER TO TURN
      LDA .CLR.     IT ON OR NOT CHECK INIT FLAG
      CLE,SZA,RSS   IF ZERO GO INITILIZE
      JSB INIT      THE MEMORY
      LDA .ALC.,I   GET THE LENGTH OF THE REQUEST 
      STA SAVB      AND SAVE IT 
      ADA AVMEM     CHECK TO SEE IF WE CAN EVER 
      CMA,SSA,INA,SZA  HONOR THE REQUEST
      JMP ERETN     NO GO ABORT 
      CCA           SET CORE AVAIL. NOW TO 0
      STA SAVR
      LDB PNTRA     START THE SEARCH LOOP WITH
.A2   LDA .RTN.     THE FIRST WORD POINTER
      SZA           IF INTERRUPT SYS WAS OFF SKIP 
      STF INT       TURNING ON THE INTERRUPT SYSTEM 
      STB BAD       SET LAST BUFFER ADDRESS 
      CLF INT       TURN OFF THE INTERRUPT SYS
      CPA .RTN.     WAS .RTN. ENTERED DURING THE WINDOW?
      CLE,INB,RSS   NO INCREMENT B AND SKIP 
      JMP .A22      YES  GO REINITILIZE SEARCH LOOP 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I       GET THE NEXT SEGMENT ADDRESS
      CPB M7        IF 77777 THEN END OF LIST AND NO
      JMP REJ       MEMORY SO REJECT
      LDA B,I       CHECK TO SEE IF THIS IS THE 
      ADA SAVR      LARGEST LENGTH SO FAR 
      LDA B,I       GET THE LENGTH
      CMA,SEZ       SET NEG(-1) AND IF
      STA SAVR      LARGEST SO FAR SAVE 
      ADA SAVB      WILL IT SATISFY THE REQUEST?
      CMA,SSA       IF ZERO OR NEGATIVE USE IT
      JMP .A2       ELSE GO TRY NEXT ONE
      ADA CM4       IS BLOCK AT LEAST 4 WORDS 
      CCE,SSA       LARGER THAN REQUEST?
      JMP .A4       NO-ALLOCATE WHOLE BLOCK 
      ADA C4        (A)=LENGTH(I)-L(X)
      STA B,I       SET NEW L(I)
      ADA B         (A)=BUFFER ADDRESS
      JMP SETB      RETURN TO USER
      SPC 1 
ERETN CCA,CLE,RSS   SET A AND E FOR NEVER ANY CORE
REJ   CLA,CLE       SET A AND E FOR NO CORE NOW 
      JMP SETB      RETURN
      SPC 1 
.A4   LDA B,I       SET BUFFER LENGTH TO PASS 
      STA SAVB      THE WHOLE BLOCK 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      STB A         BUFFER ADDRESS TO A 
      CCE,INB       SET E FOR ACCEPTED RETURN 
      LDB B,I       GET THE POINTER TO THE NEXT BLOCK 
      ISZ BAD       STEP TO POINTER ADDRESS IN LAST 
      STB BAD,I     BLOCK AND SET THE POINTER 
SETB  LDB .RTN.     CHECK TO SEE IF THE INTERRUPT SYS 
      SZB           WAS ON AT ENTRY 
      STF INT       IF SO RE SET IT 
      LDB AVMEM     SET B FOR REJECT
      SZA,RSS       IF JUST FOR NOW RESET TO MAX
      LDB SAVR      AVAILABLE NOW 
      CMB,SEZ       SET POSITIVE AND IF REQUEST 
      LDB SAVB      SATISFIED SET TO LENGTH 
      ISZ .ALC.     STEP RETURN ADDRESS 
      JMP .ALC.,I   AND RETURN
      SPC 2 
.RTN. NOP           ENTRY POINT FOR BUFFER RETURN 
      LDA .CLR.     LOAD THE MEMORY RELEASE FLAG. 
      SZA,RSS       HAS MEMORY BEEN INITIALIZED?
      JSB INIT      NO, GO INITIALIZE MEMORY. 
      LDA .RTN.,I   (A) = FWA RETURN BUFFER (ADX) 
      STA ADX 
      CMA,INA       SET NEG AND 
      STA SAVA      SAVE
      ISZ .RTN. 
      LDA .RTN.,I   # OF WORDS RETURNED (X) 
      ADA CM4 
      SSA           <4? 
      JMP RETNR     BUFFER TO SMALL - IGNORE
      LDA PNTRA     GET THE STARTING POINTER
      JMP .R11      JUMP INTO THE SEARCH LOOP 
      SPC 1 
.R1   STB A         A _ PNTR
      ADB SAVA      AAD -ADX
      CMB,SSB,INB,SZB  ADX-AAD>=0?
      JMP .R2       JUMP IF GREATER THAN ZERO 
.R11  STA BAD       BAD _ AAD 
      INA 
      LDB A,I       AAD _ NEXTBUFAD 
      JMP .R1       LOOP
      SPC 1 
.R2   LDB BAD       GET LOWER BUFFER ADDRESS
      CPB PNTRA     IF LOCAT POINTER
      JMP .R3       ASSUME NO OVERLAP 
      ADB B,I       ADD LENGTH AND
      ADB SAVA      SUBTRACT THE NEW BLOCK ADDRESS
      CMB,SSB,INB,RSS  IF NEG NO OVERLAP SO 
      JMP .R3       JUMP
      ADB .RTN.,I   ELSE COMPUTE NEW LENGTH 
      SSB           TOTAL OVERLAP?
      CLB           YES USE OLD LENGTH
      ADB BAD,I     NOW HAVE NEW +OLD-OVERLAP 
.R4   STB BAD,I     SET LENGTH ;CHECK FOR HIGH OVER 
      ADB BAD       LAP COMPUTE END OF BLOCK
      CMB,CLE,INB   AND SUBTRACT FROM THE HIGH BLOCK
      ADB A         A HASS HIGH BLOCK ADDRESS 
      SEZ,CLE,SZB   IF RESULT POSITIVE
      JMP .R5       JUMP
      ADB A,I       ADD OLD UPPER LENGTH
      SSB           TOTAL OVER LAP? 
      CLB           YES SET TO ZERO TO USE
      ADB BAD,I     CURRENT LENGTH
      STB BAD,I     NEW+OLD-OVERLAP 
      CLE,INA       GET POINTER AND BRING 
      LDA A,I       DOWN TO NEW BLOCK 
.R5   LDB BAD,I     SAVE MAX LENGTH THIS RETURN 
      ISZ BAD       STEP TO POINTER ADRRESS 
      STA BAD,I     SET THE POINTER 
      LDA AVMEM     CHECK TOO SEE IF THIS LENGTH
      ADA B         ADD CURRENT MAX 
      CMB,SEZ,CLE   SET NEG; NEW MAX? 
      STB AVMEM     YES; SET IT 
RETNR ISZ .RTN. 
      JMP .RTN.,I 
      SPC 1 
.R3   ISZ BAD       NO LOW OVERLAP SET NEW BLOCK
      LDB ADX       ADDRESS IN LOW BLOCK
      STB BAD,I     TO LINK THE BLOCKS
      STB BAD       SET POINTER FOR HIGH BLOCK CHECK
      LDB .RTN.,I   SET B TO THE LENGTH OF RETURN 
      JMP .R4       CHECK FOR HIGH OVERLAP
      SPC 2 
INIT NOP            INITIALIZE MEMORY FROM THE
      LDA M7        SET THE POINTR TO MAX 
      STA PNTR      TO INDICARTE NO CORE
      LDA .RTN.     SAVE THE RETURN ADDRESS 
      STA SAVR
      LDA .MEM.     GET THE MEMORY TABLE ADDRESS
      LDB A,I       FWABP TO A
      STB CL1       SET CALL PRAM ONE 
      CMB,INB       CALCULATE NO OF WORSD 
      INB           ON BASE PAGE
      INA           STEP TO LWABP ADDRESS 
      ADB A,I       NO OF WORD OF BP
      STB CL2       TO CALL PRAM TWO
      INA           ADDRESS OF FWAM 
      LDB A,I       TO A
      STB .CLR.     SET CALL PRAM 3 (ALSO CLEAR ) 
      CMB,INB       CALCULATE THE NO OF WORDS 
      INB           OF MAIN MEM 
      INA           ADDRESS OF LWAM 
      ADB A,I       NO OF WORDS IN B
      STB CL4       TO CALL PRAM 4
      JSB .RTN.     SET BASSE PAGE MEM
CL1   NOP 
CL2   NOP 
      JSB .RTN.     SET MAIN MEM
.CLR. NOP 
CL4   NOP 
      LDA SAVR      RESTORE THE RETURN ADDRESS
      STA .RTN.     AND 
      JMP INIT,I    RETURN
      SPC 2 
      ORB 
BAD   NOP 
SAVA  NOP 
SAVB  NOP           UNAVAILABLE TO .RTN. SECTION. 
PNTRA DEF SAVR      ADDRESS OF DUMMY BLOCK
SAVR  NOP           LENGTH OF DUMMY (NEVER USED)
PNTR  OCT 077777
M7    OCT 077777
CM4   OCT -4
C4    DEC 4 
ADX   NOP 
AVMEM OCT -1
      ORR 
      SPC 1 
      END 

ASMB,R,B,L,T,C,Z
      NAM FRMTR 
      IFN 
      HED ***  FORTRAN FORMATTER, 4K VERSION  ***            (JRW)
      XIF 
      IFZ 
      HED ***  FORTRAN FORMATTER, NON-4K VERSION  ***        (JRW)
      XIF 
      ENT .DIO.,.BIO.,.IOI.,.IOR. 
      ENT .IAR.,.RAR.,.DTA.,OLDIO 
      EXT .IOC.,.FLUN,.PACK,FLOAT,IFIX,ENDIO
      SPC 2 
*     USE "N-OPTION" FOR THE 4K VERSION.
*     USE "Z-OPTION" FOR THE NON-4K VERSION.
      SKP 
* * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                   * 
*                F  O  R  T  R  A  N                * 
*                                                   * 
*                      I  /  O                      * 
*                                                   * 
*                P  R  O  G  R  A  M                * 
*                                                   * 
* * * * * * * * * * * * * * * * * * * * * * * * * * * 
      SPC 1 
* THE FORTRAN I/O PROGRAM PROVIDES FOR ALL INPUT AND
* OUTPUT SERVICES SPECIFIED BY THE -HP-2116 FORTRAN 
* COMPILER.  THIS INCLUDES THE FOLLOWING TYPES OF 
* FORTRAN STATEMENTS: 
      SPC 1 
*      I  WRITE (<UNIT>,<FORMAT>) <LIST>
*     II  READ  (<UNIT>,<FORMAT>) <LIST>
*    III  WRITE (<UNIT>) <LIST> 
*     IV  READ  (<UNIT>) <LIST> 
      SPC 1 
* THE FIRST TWO STATEMENTS PROVIDE FOR FORMATTED
* INPUT/OUTPUT, THE LAST TWO FOR BINARY INPUT/
* OUTPUT.  A SPECIAL FORM OF THE TYPE II STATEMENT
* IS FREE-FIELD INPUT.  THIS IS SPECIFIED BY A STAR 
* IN THE FORMAT FIELD.
      SPC 1 
* IN ADDITION TO THE USUAL BASIC FORTRAN FORMAT SPE-
* CIFICATIONS, THE FOLLOWING SPECIFICATIONS ARE RE- 
* COGNIZED: 
      SPC 1 
* 1) Q-FORMAT: THIS CAN BE USED TO OUTPUT A CHARACTER 
*    STRING WITHOUT EXPLICITLY SPECIFYING THE NUMBER
*    OF CHARACTERS. ITS FORM IS:
*              " <CHARACTER STRING> " 
      SPC 1 
* 2) FREE-FIELD INPUT: THIS ALLOWS FOR INPUT DATA 
*    WITHOUT ANY PARTICULAR FORMAT BEING SPECIFIED. 
      SPC 2 
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
      SPC 1 
*    THE PROGRAM ITSELF CONSISTS OF THREE SETS OF 
*    ROUTINES.  THESE CAN BE CLASSIFIED AS: 
      SPC 1 
* 1) THE FORMAT ANALYZER.  THESE ROUTINES ARE RESPON- 
*    SIBLE FOR SCANNING THE FORMAT STRING AND PASSING 
*    CONTROL TO THE CORRECT CONVERSION ROUTINE. 
      SPC 1 
* 2) THE CONVERSION ROUTINES.  THESE ROUTINES ARE THE 
*    ONES THAT PERFORM THE ACTUAL CONVERSION BETWEEN
*    INTERNAL AND EXTERNAL REPRESENTATIONS. 
      SPC 1 
* 3) THE COMMUNICATION ROUTINES.  THESE ARE THE ROU-
*    TINES THAT ARE ACTUALLY CALLED BY THE FORTRAN
*    PROGRAM.  THEY ESSENTIALLY DRIVE THE ROUTINES
*    OF CLASSES 1 AND 2.
      SPC 1 
*     THE CALLING SEQUENCES ARE AS FOLLOWS: 
      SPC 1 
*     INITIALIZATION CALL:
      SPC 1 
*       BINARY INPUT/OUTPUT 
      SPC 1 
*           JSB .BIO.  (A=UNIT, B=0 FOR OUTPUT, 1 FOR INPUT)
      SPC 1 
*       DECIMAL INPUT/OUTPUT
      SPC 1 
*           JSB .DIO.  (A=UNIT, B=0 FOR OUTPUT, 1 FOR INPUT)
*           DEF BUFFER (ONLY IF UNIT=0) 
*           DEF FORMAT (=0 FOR FREE-FIELD INPUT)
*           DEF ENDLIST 
      SPC 1 
*       WHEN UNIT=0, THE FORMATTER WILL CONVERT DIRECTLY TO OR FROM 
*       THE USER'S BUFFER. NO ACTUAL I/O WILL TAKE PLACE. 
      SPC 1 
*     CONTINUATION CALLS: 
*       JSB .IOR. WILL CONVERT A FLOATING POINT NUMBER. 
*       JSB .IOI. WILL CONVERT A FIXED POINT NUMBER.
*       JSB .RAR. OR .IAR. WILL CONVERT AN ENTIRE ARRAY, IN FLOATING
*         POINT OR FIXED POINT. (A=#OF ELEMENTS, B=ADDRESS OF FIRST 
*         ELEMENT 
      SPC 1 
*     TERMINATION CALL: (USED ONLY FOR OUTPUT)
      SPC 1 
*       JSB .DTA. 
      SPC 2 
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
      SKP 
*************************** 
*                         * 
* CONSTANTS AND VARIABLES * 
*                         * 
*************************** 
      SPC 1 
      ORB 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      SPC 1 
      IFZ 
....6 OCT 6 
..7   OCT 7 
..67  OCT 67
ASCIA OCT 101     ASCII "A" 
K     OCT 113        ASCII K
O     OCT 000117    "O".
R     OCT 000122    R 
AOFLG OCT 000000
IFLAG OCT 000000
      XIF 
.4000 OCT 004000    UNIT-RECORD COMPARISON WORD.
.177  OCT 177       USED TO MASK CHARACTERS 
BLANK OCT 40        ALPHABETIC
COMMA OCT 54
E     OCT 105         CONSTANTS 
F     OCT 106 
H     OCT 110 
I     OCT 111 
.36   OCT 36
QUOTE OCT 42        " 
SLASH OCT 57
X     OCT 130 
ISAVE OCT 000000
LPREN OCT 50
RPREN OCT 51
PLUS  OCT 53
MINUS OCT 55
POINT OCT 56
MONEY OCT 44        DOLLAR SIGN ($) 
MIN2  DEC -2
MIN72 OCT -72 
.12   OCT 12
BCR   BSS 1 
PAPER OCT 34000     TEST FOR PAPER TAPE.
PBIT  OCT 200       SET BIT FOR IOC.
TENTH OCT 63146     FIRST 15 BITS OF THE NUMBER 0.1 
...60 OCT 60        SAME AS ASC ZERO
MIN1 DEC -1 
BASIC OCT 10000 
IN2OT OCT 30000 
KBIT  OCT 400 
OCTAL OCT 100      @B PRECEDING A NUMBER IN FREE- 
*                                       FIELD INPUT INDICATES OCTAL.
ASC2B EQU OCTAL 
MIN5  DEC -5
NINE  DEC 9 
...61 OCT 61
HIMSK OCT 174000
MIN4  OCT 177774
MIN3  OCT -3
TEMP1 BSS 1         TEMPORARY 
TEMP2 BSS 1              STORAGE
FCR   BSS 1         POINTS TO CHARACTER IN FORMAT 
DBLNK BSS 1         FLAG FOR SKIPPING BLANKS IN FMT 
DCOMA BSS 1         FLAG FOR SKIPPING COMMAS IN FMT 
BCRS  BSS 1         USED FOR REMEMBERING BCR
CCNT  BSS 1         COUNTS WORDS/CHARS IN BUFFER
RF    BSS 1         FORMAT REPEAT FIELD COUNTER 
IO    BSS 1         FLAG...=0 FOR OUTPUT, 1 FOR IN
NEST  BSS 1         COUNTS PAREN. LEVEL IN FORMATS. 
*                                   INITIALLY -3, =-2 WITHIN FMT, 
*                                   -1 IN INNER PARENS. 
RF1   BSS 1         REPEAT COUNTER FOR INNER PARENS 
RF2   BSS 1         USED TO RECALL REPEAT COUNT 
SKIPL BSS 1         FLAG SET TO AVOID A SPURIOUS RE-
*                                   TURN TO THE LIST
OVTOG BSS 1        FLAG TO SAY WHETHER OUTBUFFER IS BOMBED
PREN1 BSS 1         USED AS POINTERS TO PARENS IN 
PREN2 BSS 1              FORMATS. 
SIGN  BSS 1         USUALLY INDICATES SIGN OF NUMBER
W     BSS 1         COUNTER OF W-FIELD
WSAVE BSS 1         HOLDS INITIAL W FOR REPEATS 
D     BSS 1         COUNTER OF D-FIELD
DSAVE BSS 1         HOLDS INITIAL D FOR REPEATS 
BCNT  BSS 1         COUNTS LEADING BLANKS FOR OUTPUT
DT    BSS 1         TEMP D FOR OUTPUT OVERFLOW
MANTS BSS 2 
EXPS  BSS 1 
EXPON BSS 1         EXPONENT PART OF NUMBER 
UNIT  OCT 1         INPUT/OUTPUT UNIT 
BCTEM EQU TEMP2     TEMPORARY FOR OUTPUT
MULT1 BSS 1         TEMPORARIES FOR 
MULT2 EQU TEMP2          MULTO
ESIGN BSS 1         HOLDS EXPONENT SIGN 
SKIP  BSS 1         FLAG FOR INPUT SKIPPING 
POST  BSS 1         INPUT CONTROL INDICATOR 
CFLAG EQU MULT1     COMMA CHECK FOR FREE-FIELD INPUT
ENDLS BSS 1         POINTS TO ENDOF CALLING SEQUENCE
ARRAY BSS 1         USED BY .RAR. 
ALNTH BSS 1              AND .IAR.
BFLAG BSS 1         =1 FOR BINARY I/O, 0 FOR DECIMAL
STATT BSS 1 
MANT  BSS 2 
MIN10 DEC -10 
...72 OCT 72
BUFLN EQU 67
BUFBN EQU 60        BINARY RECORD, PHYSICAL LENGTH. 
BINRY ABS -BUFBN-BUFBN BINARY RECORD CHARACTER LENGTH.
ASCRY ABS -BUFLN-BUFLN ASCII RECORD CHARACTER LENGTH. 
      SPC 1 
      IFZ 
      ORR 
      XIF 
BUFI BSS BUFLN
BUFO BSS BUFLN
      ORB 
      SKP 
********************* 
*  UTILITY ROUTINES * 
********************* 
      SPC 1 
* THE ROUTINES THAT HANDLE CHARACTER MANIPULATION USE 
* THE FOLLOWING ADDRESSING SCHEME:
* THE ADDRESS OF THE WORD IS CONTAINED IN BITS [15:1] 
* AND BIT 0 IS EITHER 0 FOR THE CHARACTER CONTAINED 
* IN BITS [14:8], OR 1 FOR THE CHARACTER CONTAINED IN 
* BITS [6:0]. THUS, A STRING OF CHARACTERS HAVE AD- 
* DRESSES WHICH ARE SEQUENTIAL. FOR EXAMPLE, IF LOCA- 
* TION 1000 CONTAINS THE TWO CHARACTERS A AND B, THE
* CHARACTER ADDRESS OF THE A IS 2000, AND THAT OF THE 
* B IS 2001. THE SINGLE BIT IS REFERRED TO BELOW AS 
* THE C-BIT.
      SPC 2 
******************************* 
BUF2A NOP     *     THE CHAR WHOSE LOCN IS IN B IS
*******************************         PUT INTO A
      CLE,ERB       POSITION ADDRESS AND SET E=C-BIT
      LDA B,I       WORD CONTAINING CHARACTER TO A. 
      SEZ,RSS       IF E=0, ROTATE TO GET THE CHAR- 
      ALF,ALF         ACTER IN A[6:0].
      AND .177      MASK OUT EXTRANEOUS BITS. 
      JMP BUF2A,I   RETURN WITH CHAR IN A.
      SPC 2 
******************************* 
A2BUF NOP     *     THE CHAR IN A IS PUT IN THE 
*******************************         LOCATION GIVEN BY B.
      STA TEMP1     SAVE THE CHARACTER
      SLB,INB       COMPLEMENT THE LOW ORDER BIT
      ADB MIN2           OF B.
      JSB BUF2A     GET THE OTHER CHARACTER IN THE
      ALF,ALF       MEMORY WORD AND ROTATE TO HI END
      IOR TEMP1     MERGE THE OTHER CHARACTER.
      SEZ           ROTATE IF 
      ALF,ALF       NECESSARY.
      STA B,I       STORE THE NEW WORD. 
      JMP A2BUF,I   RETURN
      SPC 2 
******************************* 
FCHAR NOP     *     THE NEXT CHAR IN THE FORMAT IS
*******************************         MOVED TO A
NCHAR ISZ FCR       ADVANCE FORMAT STRING POINTER.
      LDB FCR       LOAD CHARACTER INTO A AND TEST
      JSB BUF2A     FOR BLANK OR COMMA
      LDB DBLNK     SKIP BLANKS IF DBLNK=1
      SZB,RSS 
      JMP *+3       DON'T SKIP BLANKS.
      CPA BLANK     IF DBLNK=1 AND A=BLANK, GO GET
      JMP NCHAR     ANOTHER CHARACTER.
      LDB DCOMA     SKIP COMMAS IF DCOMA=1
      SZB,RSS 
      JMP FCHAR,I   RETURN
      CPA COMMA     IF DCOMA=1 AND A=COMMA, GO GET
      JMP NCHAR     ANOTHER CHARACTER 
      JMP FCHAR,I   RETURN
      SPC 2 
******************************* 
OUTCR NOP     *     THE CHAR IN A IS PLACED IN THE
*******************************         OUTPUT STRING.
      ISZ CCNT        END OF THE BUFFER ? 
      JMP OUTC1 
      CCA           YES-- RESET CCNT AND RETURN 
      STA CCNT
      JMP OUTC2    SET OVTOG TO SAY BUFFER IS BOMBED
      SPC 1 
OUTC1 ISZ BCR      ADVANCE BUFFER POINTER 
      LDB BCR 
      JSB A2BUF     STORE CHARACTER IN BUFFER.
      CLA          CLEAR OVTOG AND WERE OKAY
OUTC2 STA OVTOG 
      JMP OUTCR,I   RETURN. 
******************************* 
      SPC 2 
INCHR NOP           GETS NEXT CHAR FROM BUFFER
      LDA CCNT      IF CCNT=0 THEN
      SZA,RSS         GET THE NEXT
      JSB DTA            LINE.
      ISZ CCNT      IF CCNT=-1 THEN SKIP
      JMP GETC
      CCA           RESET CCNT TO -1. 
      STA CCNT
      LDA POST      IF BEGINNING OF NUMBER SCAN 
      IOR FCR         IN FREE FIELD INPUT,
      SZA,RSS           RETURN TO END OF
      JMP ENDLS,I         LIST. 
      LDA BLANK     OTHERWISE RETURN A BLANK. 
      JMP INCHR,I 
      SPC 1 
GETC  ISZ BCR       IF CCNT<-1 THEN 
      LDB BCR         JUST
      JSB BUF2A         GET THE NEXT
      JMP INCHR,I          CHARACTER
      SPC 2 
DIGIT NOP     *     TESTS CHARACTER IN A FOR A DIGIT
*                             *         IF IT IS RETURN THE TRUE
*                             *         DIGIT IN A AND SKIP. ELSE 
*                             *         RETURN THE CHARACTER AND
*******************************         DON'T SKIP. 
      LDB A         PLACE THE CHARACTER IN B. 
      ADB MIN72     CHARACTERS > '9' REMAIN POSITIVE
      SSB,RSS       SKIP IF B NEGATIVE
      JMP DIGIT,I   RETURN...NOT A DIGIT
      ADB .12       CHARACTERS < '0' REMAIN NEGATIVE
      SSB 
      JMP DIGIT,I   RETURN...NOT A DIGIT
      ISZ DIGIT     BUMP RETURN ADDRESS 
      LDA B         PLACE THE DIGIT IN A
      JMP DIGIT,I 
      SPC 2 
******************************* 
FINTG NOP     *     COMPUTES THE INTEGER IN THE FOR-
*                             *         MAT STRING. THE FIRST DIGIT 
*******************************         IS ALREADY IN A.
      CLB 
      STB DCOMA     DON'T SKIP COMMAS NOW 
FINT1 STA TEMP1     SAVE RESULT SO FAR
      JSB FCHAR     GET NEXT CHARACTER
      JSB DIGIT     CHECK FOR DIGIT 
      JMP GOTIT     END OF INTEGER
      LDB TEMP1     MULTIPLY RESULT SO
      BLS,BLS         FAR BY TEN. 
      ADB TEMP1 
      BLS 
      ADA B         ADD TO NEW DIGIT
      JMP FINT1     LOOP
      SPC 1 
GOTIT CCB           BACK UP FORMAT POINTER
      ADB FCR 
      STB FCR 
      LDA TEMP1     RETURN WITH 
      JMP FINTG,I   RESULT IN A 
      ORR 
      SPC 2 
OLDIO NOP 
      LDA OLDIO,I   LOAD RETURN ADDRESS DEFINITION. 
      JMP A,I       RETURN. 
      SPC 2 
******************************* 
INT   NOP     *     COMPUTES THE NEXT NUMBER IN THE 
*******************************         FORMAT STRING, FROM SCRATCH.
      JSB FCHAR     GET ONE CHARACTER 
      JSB DIGIT     TEST FOR DIGIT
      JMP ERR1      NO DIGIT
      JSB FINTG     GET THE REST OF THE INTEGER 
      JMP INT,I     RETURN
      SPC 2 
********************************************************************
*                                                                  *
*         THE FOLLOWING SECTION IS THE FORMAT ANALYZER. CONTROL IN *
*         HERE IS GOVERNED BY THE CONTROL LOOP, WHICH EXAMINES THE *
*         FORMAT AND PASSES CONTROL TO THE VARIOUS CONVERSION ROU- *
*         TINES. SINCE TERMINATION OF THE I/O STATEMENT IS DETER-  *
*         MINED BY THE CALLING SEQUENCE, EACH CONVERSION ROUTINE   *
*         MUST CHECK THE LIST BEFORE PERFORMING A CONVERSION. THIS *
*         IS DONE BY CALLING A ROUTINE CALLED F2LST. THE SOLE FUNC-*
*         TION OF THIS ROUTINE IS TO HOLD THE ADDRESS FROM WHICH   *
*         IT WAS CALLED, AND THEN TO GET BACK TO THE CALLING       *
*         SEQUENCE. THE CALLING SEQUENCE WILL THEN PASS CONTROL    *
*         BACK THROUGH THE COMMUNICATION ROUTINES (SEE ABOVE).     *
*         EACH OF THESE CALLS A ROUTINE CALLED LST2F, WHICH GETS   *
*         BACK TO THE FORMATTER BY USING THE ADDRESS LEFT AT       *
*         F2LST.                                                   *
*                                                                  *
********************************************************************
      SPC 1 
RFCHK NOP           CHECKS REPEAT FIELD FOR EXHAUS- 
      ISZ RF         TION. IF RF GOES TO ZERO, CON- 
      JMP RFCHK,I     TROL FALLS THROUGH TO FORMT.
FORMT CLA,INA       SET DBLNK AND DCOMA FOR SKIPPING. 
      STA DBLNK 
      STA DCOMA 
      IFZ 
      STA AOFLG 
      XIF 
      CCA 
FORM1 STA RF       SET REPEAT FIELD AT ONE. 
      JSB FCHAR     GET THE CHARACTER AND TEST IT 
      CPA I 
      JMP ITYPE 
      CPA F 
      JMP FTYPE 
      CPA E         FOR TYPES 
      JMP ETYPE 
      CPA X 
      JMP XTYPE 
      CPA QUOTE 
      JMP QTYPE 
      CPA SLASH 
      JMP INOUT 
      CPA LPREN 
      JMP LPTYP 
      CPA RPREN 
      JMP RPTYP 
      CPA H 
      JMP HTYPE 
      IFZ 
      CPA ASCIA     TEST FOR A TYPE 
      JMP ATYPE 
      CPA K     ALTERNATIVE OCTAL TYPE
      JMP OTYPE 
      CPA OCTAL     TEST FOR OCTAL TYPE 
      JMP OTYPE 
      CPA R         IS SPECIFICATION TYPE "R"?
      JMP ATYPE     YES, GO PROCESS AS TYPE "A".
      CPA O         "O"?
      JMP OTYPE 
      XIF 
      JSB DIGIT     LAST CHANCE 
      JMP ERR3      UNKNOWN CHARACTER 
      JSB FINTG     GET THE REST OF THE NUMBER. 
      CMA,INA,SZA,RSS 
      JMP ERR3
      JMP FORM1 
      SPC 2 
***************************************** 
*                                       * 
* FOLLOWING ARE THE CONVERSION ROUTINES * 
*                                       * 
***************************************** 
      SPC 1 
      IFN 
      ORB 
      XIF 
IOCHK NOP           A SWITCH ON THE VALUE OF IO. RE-
      STB TEMP2 
      LDB IO        TURN TO P+1 FOR OUTPUT, P+2 FOR 
      SZB           INPUT.
      ISZ IOCHK 
      LDB TEMP2 
      JMP IOCHK,I 
      ORR 
      SPC 2 
**********************************
*     XTYPE HANDLES X-CONVERSION *
**********************************
XTYPE LDA BLANK     IN CASE OF OUTPUT 
      JSB IOCHK     WHICH WAY?
      JMP XOUT      OUT 
      JSB INCHR     IN
      RSS           SKIP
XOUT  JSB OUTCR     OUT 
      JSB RFCHK     TEST RF 
      JMP XTYPE     LOOP
      SPC 1 
**********************************
*     HTYPE HANDLES H-CONVERSION *
**********************************
HTYPE CLA           SET FOR NO
      STA DBLNK      SKIPPING 
      STA DCOMA 
HLOOP JSB IOCHK     WHICH WAY?
      JMP HOUT      OUT 
      JSB INCHR     IN
      ISZ FCR       ADVANCE FORMAT POINTER
      LDB FCR 
      JSB A2BUF     PLACE INTO FORMAT 
HCHEK JSB RFCHK     TEST RF 
      JMP HLOOP 
HOUT  JSB FCHAR     GET A CHAR FROM STRING
      JSB OUTCR     OUTPUT IT 
      JMP HCHEK 
      SPC 2 
      IFZ 
 HED A SPECIFICATIONS 
* ATYPE HANDLES A-SPECIFICATIONS
      SPC 1 
ATYPE CLA         GET 
      STA SIGN           THE
      JSB WGET             W-FIELD
ALOOP JSB AOSET 
      JSB IOCHK     IN/OUT SWITCH 
      JMP AOUT
      SPC 1 
* A-INPUT 
      SPC 1 
      CLA     INITIALIZE MANT TO ZERO 
      STA MANT
AIN1  JSB INCHR     READ A CHARACTER
      LDB W         FIGURE OUT WHAT TO DO WITH IT 
      INB,SZB      IF W NOT -1, 
      ALF,ALF      ROTATE IT
      IOR MANT        PUT IN PREVIOUS RESULT
      INB    STORE ONLY IF
      SSB,RSS    W IS -2 OR -1
      STA MANT
      ISZ W       TEST FOR FINISHED 
      JMP AIN1      NOT YET 
ATYP1 JSB RFCHK 
      JMP ALOOP 
      SPC 1 
AOUT  LDA MANT     GET SYMBOL TO GO OUT 
      LDB W     GET W 
      INB,SZB     IF NOT -1  WE WANT THE
      ALF,ALF            HIGH PART
      AND .177       ONE CHARACTER ONLY 
      INB 
      SSB     IF NOT -1 OF -2 WE WANT 
      LDA BLANK            BLANK
      JSB OUTCR         THERE IT GOES 
      ISZ W         ALL DONE YET
      JMP AOUT         NOPE 
      JMP ATYP1      END OF ASPECIFICATIONS 
 HED K SPECIFICATION
*OTYPE HANDLES @ SPECIFICATIONS * 
      SPC 1 
OTYPE CLA       GET 
      STA SIGN        THE 
      JSB WGET           W-   FIELD 
OLOOP JSB AOSET 
      JSB IOCHK     IN/OUT SWITCH 
      JMP OCOUT 
      SPC 1 
* OCTAL INPUT * 
      SPC 1 
      CLA        INITIALIZE TO
      STA MANT       ZERO 
OCT1  JSB INCHR      GET A CHARACTER
      STA B        SAVE IN B
      IOR ..7     TEST FOR OCTAL DIGIT
      CPA ..67
      JMP OCT2       IT IS ONE
OCT3  ISZ W         END OF THIS INPUT       ??? 
      JMP OCT1       NOPE 
OCT6  JSB RFCHK    YES--TEST FOR END OF SPEC
      JMP OLOOP 
      SPC 1 
* ADD NEW DIGIT IN *
      SPC 1 
OCT2  LDA B       GET OCTAL DIGIT BACK IN A 
      AND ..7     REMOVE ASCII BITS 
      LDB MANT     REPOSITION PREVIOUS RESULT 
      BLF,RBR 
      ADA B      ADD TO NEW DIGIT 
      STA MANT    PUT IT BACK 
      JMP OCT3
      SPC 1 
* OCTAL OUTPUT *
      SPC 1 
OCOUT LDA BLANK 
      LDB W     IS W GEQ -6?
      ADB ....6 
      SSB 
      JMP OCT4     NO---OUTPUT A BLANK
      LDA MANT     GET NUMBER 
      CMB 
      RAR,RAR     POSITION OVER 2 FOR 16TH BIT
      CPB MIN1
      ALR,RAR 
      ALF,RAR     ROTATE 3
      INB,SZB     DONE ROTATING???? 
      JMP *-2     NOT YET, SON
      AND ..7      MASK OFF 
      IOR ...60     ASCII BITS
OCT4  JSB OUTCR      THERE IT GOES
      ISZ W      END OF VALUE?
      JMP OCOUT 
      JMP OCT6
      SPC 1 
*     END OF OCTAL SPECIFICATIONS 
      SPC 2 
AOSET NOP 
      CCA 
      STA AOFLG 
      JSB WDSET 
      JSB F2LST 
      JMP AOSET,I 
      XIF 
 HED " SPECIFICATION
**********************************
*     QTYPE HANDLES "-CONVERSION *
**********************************
QTYPE CLA           SET FOR NO
      STA DBLNK      SKIPPING 
      STA DCOMA 
      LDA FCR       SAVE FCR FOR
      STA OLDIO     REPEATS 
QLOOP JSB FCHAR     GET FORMAT CHARACTER
      CPA QUOTE     CHECK FOR QUOTE 
      JMP QUOT1     JMP FOR SPECIAL HANDLIG 
      JSB IOCHK 
      JMP *+3 
      JSB INCHR 
      JMP QLOOP 
      JSB OUTCR 
      JMP QLOOP 
QUOT1 JSB RFCHK     CHECK THE REPEAT COUNT
      LDA OLDIO     RESTORE FCR 
      STA FCR         AND 
      JMP QLOOP         LOOP

 HED PARENTHESIS MANIPULATION 
******************************************************* 
* LPTYP AND RPTYP HANDLE THE PARENTHESIS MANIPULATION * 
******************************************************* 
LPTYP ISZ NEST      ADVANCE THE DEPTH COUNTER 
      RSS 
      JMP ERR2      IF TOO DEEP THEN TAKE GAS 
      LDA NEST
      LDB FCR 
      CPA MIN2      IF NEST IS -2 (OUTER PARENS)
      STB PREN2       THEN STORE FCR IN PREN2 
      STB PREN1     ALWAYS STORE IT IN PREN1
      LDB RF        SAVE RF IN
      STB RF2         RF2 FOR LATER RECOVERY
      STB RF1           AND RF1 FOR LOOPING 
      JMP FORMT 
      SPC 1 
RPTYP LDA NEST      IF NEST IS
      INA,SZA,RSS   EQUAL TO 1 THEN 
      JMP RPTY1     GO TO RPTY1 
      INA,SZA       IF NEST NEQ -2 THEN 
      JMP ERR2      TAKE GAS
      JSB F2LST     RETURN TO THE CALLING SEQUENCE
      JSB DTA       IF WE GET BACK, I/O THE RECORD
      LDA RF2       RESET RF1 FOR REPEATING 
      STA RF1         THE FORMAT
      CCA           SET SKIPL TO AVOID A SPURIOUS 
      STA SKIPL     RETURN TO THE CALLING SEQUENCE. 
      LDB PREN1     IF PREN1=PREN2, THERE ARE NO
      CPB PREN2     INNER PARENS, SO LEAVE NEST 
      LDA NEST      ALONE. IF THEY'RE DIFFERENT THEN
      STA NEST      SET IT TO -1. 
RPTY2 STB FCR       RESET FCR TO PREN1
      JMP FORMT     RETURN
      SPC 1 
RPTY1 LDB PREN1 
      ISZ RF1       IF RF1 DOESN'T GO TO ZERO, THEN 
      JMP RPTY2       RESET FCR TO PREN1
      LDA MIN2      OTHERWISE JUST SET NEST TO -2.
      STA NEST
      JMP FORMT 
      SPC 1 
*************************************** 
* INOUT HANDLES THE SLASH IN A FORMAT * 
*************************************** 
INOUT JSB DTA 
      JSB RFCHK 
      JMP INOUT 
 HED NUMERICAL CONVERSIONS
********************************************************************
*     THE NUMERICAL CONVERSIONS ARE ALL PERFORMED USING FLOATING   *
*     ARITHMETIC. THE USUAL FLOATING POINT ROUTINES, WHICH WORK ON *
*     23 BIT FRACTIONS, ARE BYPASSED IN FAVOR OF UNPACKED ROUTINES.*
*     THESE OPERATE ON 31 BITS AND THEREBY PROVIDE MUCH BETTER     *
*     ACCURACY.  THE ENTRY POINTS TO THE FLOATING POINT            *
*     PACKAGE THAT ARE USED ARE:                                   *
*                                                                  *
*         .FLUN     UNPACK ROUTINE                                 *
*         FLOAT     FLOAT ROUTINE                                  *
*         .PACK     PACK AND ROUND ROUTINE                         *
*         IFIX      UNFLOAT ROUTINE                                *
********************************************************************
*                                                                  *
* FOLLOWING ARE SOME UTILITY ROUTINES FOR OBTAINING THE W AND D    *
* FIELDS, AND DOING A FEW OTHER LITTLE THINGS.                     *
*                                                                  *
********************************************************************
      SPC 1 
WGET  NOP 
      JSB INT       GET NUMBER IN FORMAT
      CMA,INA       NEGATE. 
      ADA SIGN      =4 FOR E-FORMAT OUT, 0 OTHERWISE
      SSA,RSS       IF NOT NEGATIVE THEN
      JMP ERR1      TAKE GAS. 
      STA WSAVE 
      JMP WGET,I
      SPC 2 
      IFN 
      ORB 
      XIF 
WDSET NOP           RESTORES W AND D. 
      LDA WSAVE 
      STA W 
      LDA DSAVE 
      STA D 
      JMP WDSET,I 
      SPC 2 
WDFIX NOP           INITIALIZES W & D. A=POSITIVE D.
      CMA           -D-1
WDFX1 STA DSAVE     SET DSAVE TO INCLUDE POINT
      CMA           D 
      ADA WSAVE     D-W 
      CMA,SSA       W-D-1 
      JMP *+3       JUMP IF W<D+1 
      STA BCNT      NUMBER OF LEADING BLANKS. 
      JMP WDFIX,I 
      SPC 1 
      LDA WSAVE 
      JMP WDFX1     SET D=W TO GIVE THE GUY A CHANCE
      ORR 
      SPC 2 
WDGET NOP           OBTAINS BOTH W AND D. 
      JSB WGET      FIRST W 
      JSB FCHAR     MAKE SURE NEXT CHARACTER
      CPA POINT     IS A DECIMAL POINT. 
      RSS           IT IS...OK
      JMP ERR1      IT'S NOT...TOO BAD
      JSB INT       GET D 
      JSB WDFIX     FIX UP
      JMP WDGET,I 
      SPC 2 
      IFN 
      ORB 
      XIF 
LODEM NOP           LOADS MANTISSA INTO A&B.
      LDA MANT
      LDB MANT+1
      JMP LODEM,I 
      SPC 2 
STORM NOP           STORES MANTISSA INTO MANT.
      STA MANT
      STB MANT+1
      JMP STORM,I 
      SPC 2 
MBY10 NOP           MULTIPLIES MANTISSA BY 10 
      LDA MANT      IF NUMBER IS ZERO,
      SZA,RSS 
      JMP MBY10,I    RETURN.
      LDB EXP       MULTIPLY BY 8.
      ADB ....3 
      STB EXP 
      LDB MANT+1    GET MANTISSA
      CLE,ERA       DIVIDE
      ERB            BY 
      CLE,ERA         4.
      ERB,CLE 
      ADB MANT+1    DOUBLE ADD, PRODUCING 1.25*MANT.
      SEZ 
      INA 
      ADA MANT
      SSA,RSS       IF OVERFLOW,
      JMP *+5 
      CLE,ERA        SHIFT RIGHT
      ERB              AND
      ISZ EXP         BUMP EXP. 
      NOP 
      STA MANT
      STB MANT+1
      JMP MBY10,I 
      ORR 
      SPC 2 
DBY10 NOP           DIVIDES MANTISSA BY 10
      LDA MANT      IF NUMBER IS ZERO,
      SZA,RSS 
      JMP DBY10,I    RETURN.
      LDB MIN2      ADJUST
      ADB EXP        EXPONENT 
      STB EXP 
      LDA MANT+1    MULTIPLY LOWER MANTISSA 
      CLE,ERA        BY 63146 AFTER SHIFTING SO THAT
      MPY TENTH       SIGN BIT IS ZERO. 
      CLE,ELA       SHIFT BACK
      ELB,CLE 
      ADA B         ADD HIGH PART OF RESULT TO LOW
      SEZ            PART FOR THE CROSS PRODUCT.
      INB 
      STB MANT+1
      LDA MANT      NOW MULTIPLY HIGH MANTISSA THE
      MPY TENTH      SAME WAY.
      CLE 
      ADA B 
      ADA MANT+1
      SEZ 
      INB 
      STB MANT      EXCHANGE
      STA B          REGISTERS
      LDA MANT        AND 
      JSB NORML        NORMALIZE. 
      JMP DBY10,I 
 HED I,F, E SPECIFICATIONS
************************************* 
ITYPE CLA           SIGN IS SET TO
      STA SIGN      ZERO FOR THE USE OF 
      JSB WGET      WGET.D=-1 FOR INTEGERS OUT, 0 
      JSB IOCHK     FOR INTEGERS IN.
      CCA,RSS 
      CLA 
      JSB WDFIX 
      JMP FCONV 
      SPC 1 
FTYPE CLA           SET SIGN=0 FOR WGET 
      STA SIGN
      JSB WDGET 
FCONV JSB F2LST     CHECK CALLING SEQUENCE
      JSB WDSET     RESET W&D 
      CMA 
      JSB WDFIX 
      JSB IOCHK     IN OR OUT ? 
      JMP FOUT      OUT 
      JSB INPUT     IN
FIN1  JSB RFCHK     CHECK REPEATS 
      JMP FCONV     LOOP
FOUT  JSB FLABS     SET ABSOLUTE
      LDA BCNT
      JSB OUTPT 
      SPC 1 
*     THE NEXT FEW LINES OF CODE ARE A KLUDGE NECESSARY FOR OUTPUT- 
*     TING THE NUMBER ZERO. IT IS NECESSARY BECAUSE OUTPT WILL HAVE 
*     DELETED ALL LEADING ZEROES, AND THIS FORCES 1 LESS BLANK. 
      SPC 1 
      STA BCNT
      ADA WSAVE 
      SZA,RSS 
      JMP .OUT. 
      JSB OUTP1 
      JMP FIN1
      SPC 2 
FLABS NOP           SET NUMBER TO BE OUTPUT TO POSI-
      JSB LODEM     TIVE AND SIGN TO 0 OR -1. 
      CMA,SSA       COMPLEMENT A. 
      JMP POSIT     IT WAS POSITIVE.
      CMB,INB,SZB,RSS TWO'S COMPLEMENT B. 
      INA           IF B=0, MUST BUMP A.
      SSA,RSS       IF A IS NEG. WE HAD MAX NEG.
      JMP NEGIT 
      RAR           THAT GIVES THE RIGHT FRACTION 
      ISZ EXP       BUMP EXPONENT 
      NOP 
NEGIT STA MANT     STORE NEW FRACTION 
      CCA,RSS       SET A=-1 AND SKIP 
POSIT CLA           SET A=0 
      STA SIGN      SET SIGN
      LDA MANT      MAKE SURE MANTISSA
      JSB NORML     IS NORMALIZED 
      JMP FLABS,I   RETURN
      SPC 1 
ETYPE JSB IOCHK 
      RSS 
      JMP FTYPE     INPUT IS THE SAME AS F-TYPE.
      LDA ....4     SET SIGN=4 FOR WGET.
      STA SIGN
      JSB WDGET 
ELOOP JSB F2LST     CHECK THE LIST
      JSB WDSET     RESET W&D 
      CMA 
      JSB WDFIX 
      JSB FLABS     SET TO POSITIVE 
      CLB 
      STB EXPON     INITIALIZE EXPON TO ZERO
      CPB EXP       IF NUMBER=0, SKIP THIS
      JMP EOUT1         NEXT PART.
      SPC 1 
******************* ADJUST NUMBER TO BE AT LEAST 0.1 ***************
      SPC 1 
EOUT2 JSB MBY10     IF 10 TIMES NUMBER
      LDA EXP         IS < 1 (EXP LEQ 0)
      CMA,INA 
      SSA 
      JMP *+3 
      ISZ EXPON     BUMP EXPON AND
      JMP EOUT2     CONTINUE. 
      JSB DBY10     ELSE UNDO THE LAST MULTIPLY 
      SPC 1 
******************* NOW OUTPUT THE FRACTION PART  ******************
      SPC 1 
EOUT1 LDA EXPON 
      JSB OUTPT 
      CMA,INA       SAVE FINAL VALUE OF EXPONENT
      STA EXPON 
      JSB OUTP1 
      SPC 1 
******************* OUTPUT THE EXPONENT PART ***********************
      SPC 1 
      LDA E         FIRST THE 
      JSB OUTCR       DESCRIPTIVE E 
      LDA MINUS 
      LDB EXPON 
      SSB           SKIP IF POSITIVE
      CMB,INB,RSS   IF NEGATIVE, 2'S COMPLEMENT&SKIP
      LDA PLUS      IF POSITIVE,CHANGE A TO '+' 
      STB EXPON 
      JSB OUTCR     OUTPUT THE SIGN 
      SPC 1 
******************* OUTPUT THE EXPONENT MAGNITUDE ******************
      SPC 1 
      LDB EXPON 
      LDA ...60 
      ADB MIN10 
      SSB 
      JMP *+3 
      INA 
      JMP *-4 
      SPC 1 
      ADB ...72 
      STB EXPON 
      JSB OUTCR 
      LDA EXPON 
      JSB OUTCR     SECOND DIGIT
      JSB RFCHK     CHECK FOR REPEATS 
      JMP ELOOP 
 HED NUMERICAL OUTPUT CONVERSION
********************************************************************
*  OUTPT IS THE ROUTINE WHICH PERFORMS ALL THE OUTPUT CONVERSION.  *
*  IT ASSUMES THAT WSAVE, DSAVE, AND BCNT HAVE BEEN PROPERLY INI-  *
*  TIALIZED, AND THAT THE NUMBER IS POSITIVE AND AT LEAST 0.1.     *
*  THIS LATTER CONDITION IS NOT NECESSARY FOR OTHER THAN E-CONVER- *
*  SION, FOR LEADING ZEROES MAY APPEAR IN THE OTHER TYPES OF       *
*  CONVERSIONS. THE MAIN PROCESS IS TO FIRST REDUCE THE NUMBER TO  *
*  LESS THAN 1, THUS BUILDING UP EITHER BCNT OR EXPON, DEPENDING   *
*  UPON WHO IS CALLING. WHEN THIS IS DONE, THIS VALUE IS RETURNED  *
*  TO THE CALLER, WHO THEN STORES IT AND SETS THE CORRECT VALUE    *
*  OF BCNT. THE CALLER THEN RETURNS TO OUTP1, WHICH DOES THE       *
*  ACTUAL BINARY TO DECIMAL CONVERSION BY REPEATEDLY MULTIPLYING   *
*  THE NUMBER BY 10 AND OUTPUTTING THE INTEGER PART, THEN THROWING *
*  IT AWAY. SPECIAL CARE IS TAKEN TO OUTPUT THE SIGN AND DECIMAL   *
*  POINT PROPERLY, AND TO ROUND THE RESULT CORRECTLY.              *
********************************************************************
      SPC 1 
OUTPT NOP 
OUTP3 STA BCTEM     INITIAL VALUE OF BCNT AS PUT- 
*                                       ED BY CALLER
      SPC 1 
******************  REDUCE NUMBER TO < 1  **************************
      SPC 1 
      LDB EXP       TEST THE EXPONENT 
      CMB,INB 
      SSB,RSS       IF POSITIVE, THE
      JMP OUTPT,I   REDUCTION IS DONE 
.OUT. JSB DBY10     DIVIDE BY TEN(10).
      CCA           ENTER: A=-1.
      ADA BCTEM     BCTEM.
      JMP OUTP3     LOOP
      SPC 2 
OUTP1 NOP 
      JSB LODEM 
      STA MANTS     SAVE
      STB MANTS+1    NUMBER 
      LDA EXP 
      STA EXPS
OFTRY LDB BCNT      OUTPUT LEADING BLANKS 
      LDA SIGN
      ADB A         SUBTRACT 1 FOR SIGN IF NEGATIVE 
      SSB,RSS       SKIP IF NEGATIVE
      JMP OUTP4 
      SPC 1 
*     IF BCNT GEQ D WE CAN STILL OUTPUT THE NUMBER    * 
      SPC 1 
      CMB           -BCNT-1 
      STB DT        USED FOR OUTPUT FIELD OVERFLOW
      ADB D         D-BCNT-1
      SSB,INB,RSS   SKIP IF BCNT GEQ D&SET B=D-BCNT 
      JMP BUCKS     OUTPUT DOLLARS OTHERWISE
      STB D         SET NEW VALUE OF D
      CMA,INA       BCNT = 0 OR 1 
      STA BCNT
      JMP OUTP6 
      SPC 1 
OUTP4 LDA BLANK     OUTPUT THE
      JSB MULTO     LEADING BLANKS
OUTP6 ISZ SIGN      OUTPUT A MINUS? 
      JMP OUTP8     NO. 
      ISZ W 
      NOP           JUST IN CASE
      LDA MINUS 
      JSB OUTCR 
      SPC 1 
***** NOW PRINT THE DIGITS ONE AT A TIME, AS DESCRIBED ABOVE.  *****
      SPC 1 
OUTP8 LDA D 
      STA DT
OUT15 LDB W 
      SSB,RSS 
      JMP BUCKS     IF W >=0, OVERFLOW
      LDA POINT 
      CPB D         PRINT A DECIMAL POINT.
      JMP OUTDP 
      JSB GETDG     GET THE DIGIT 
      ADA ...60     CONVERT TO ASCII
OUTDP JSB OUTCR 
      ISZ W        SKIP IF DONE 
      JMP OUT15 
      SPC 1 
******************  GET 1 MORE DIGIT TO ROUND  *********************
      SPC 1 
      JSB GETDG 
      ADA MIN5
      ISZ OVTOG    IF BUFFER IS BOMBED, FORGET IT!
      SSA           SKIP IF DIGIT WAS 5 OR MORE 
      JMP OUTP1,I 
      SPC 1 
******************  ROUNDING SECTION  ******************************
      SPC 1 
      JSB WDSET     RESET W SO WE DON'T BACK TOO FAR FAR
      LDB BCR       GET THE LAST
OUT11 JSB BUF2A     CHARACTER OUTPUT. 
      JSB DIGIT     WAS IT A DIGIT? 
      JMP OUTP9     NO. 
      LDB BCR 
      CPA NINE      YES. WAS IT A NINE. 
      JMP OUT10     YES.
      SPC 1 
******** SINCE THE DIGIT WAS < 9, WE JUST BUMP IT UP. ************* 
      SPC 1 
      ADA ...61 
      JMP OUT14 
      SPC 1 
OUT10 LDA ...60     CHANGE THE NINE TO A ZERO 
      JSB A2BUF 
OUT12 JSB BACKB     BACK UP BUFFER POINTER
      ISZ W         TEST FOR BEGINNING OF FIELD.
      JMP OUT11 
BUCKS LDA .OBUF     PLACE $'S IN THE FIELD. 
      RAL            FIRST RESET CCNT AND 
      CMA,INA         BCR TO POINT AT THE 
      ADA ASCRY        BEGINNING OF THE 
      ADA BCRS          FIELD.
      STA CCNT
      LDA BCRS
      STA BCR 
      JSB WDSET     RESET W 
      LDA DT
      SSA,INA       IF NEGATIVE, CAN STILL FIX
      JMP FIXIT 
      LDA MONEY 
      LDB WSAVE 
      CMB,INB 
      JSB MULTO 
      JMP OUTP1,I 
FIXIT STA D         SET D TO 1 LESS THAN BEFORE 
      ISZ BCNT
      LDA MANTS 
      LDB MANTS+1   RESTORE 
      JSB STORM      NUMBER 
      LDA EXPS
      STA EXP 
      LDA SIGN
      ADA MIN1
      STA SIGN      RESTORE SIGN
      JMP OFTRY     TRY AGAIN 
      SPC 1 
OUTP9 CPA POINT     WAS THE CHARACTER A DECIMAL PT.?
      JMP OUT12     NOTHING TO DO IF IT WAS.
      CPA BLANK     WAS IT A BLANK? 
      JMP OUT13     YES. REST IS EASY 
      SPC 1 
******** OTHERWISE IT HAS TO BE A MINUS.   ************************ 
      SPC 1 
      ISZ W         CHECK W/
      RSS           CAN MOVE IT BACK. 
      JMP BUCKS     SORRY ABOUT THAT
      JSB BACKB 
      JSB A2BUF 
      ISZ BCR       NOW PUT IN A '1'. 
OUT13 LDB BCR 
      LDA ...61 
OUT14 JSB A2BUF 
      LDA WSAVE     PUT BCR BACK AT THE END OF THE
      CMA,INA       FIELD.
      ADA BCRS
      STA BCR 
      JMP OUTP1,I 
      SPC 2 
******************************* 
BACKB NOP     *     SUBTRACTS 1 FROM BCR
******************************* 
      CCB 
      ADB BCR 
      STB BCR 
      JMP BACKB,I 
      SPC 2 
******************************* 
MULTO NOP     *     OUTPUTS THE CHARACTER IN A THE
*                             *         NUMBER OF TIMEGIVEN BY B
******************************* 
      CMB,INB       SET B NEGATIVE
      SSB,RSS       SKIP IF B WAS POSITIVE
      JMP MULTO,I   RETURN IF B WAS 0 OR LESS 
      STB MULT2     STORE THE COUNT 
      STA MULT1     SAVE THE CHARACTER
MULTL LDA MULT1 
      JSB OUTCR 
      ISZ W 
      NOP           JUST IN CASE
      ISZ MULT2 
      JMP MULTL 
      JMP MULTO,I 
      SPC 2 
******************************* 
GETDG NOP     *     THIS ROUTINE MULTIPLIES THE NUM-
*                             *         BER BY 10 AND PEELS OFF THE 
*******************************       INTEGER PART. 
      JSB MBY10     MULTIPLY BY 10
      LDB EXP       GET THE EXPONENT IN B 
      CMB,INB         AS NEGATIVE.
      AND HIMSK     KEEP HIGH ORDER 5 BITS OF A 
      RAL           NORMALIZE TO BIT 15 
      SSB,INB       ROTATE LEFT UNTIL EXP GETS TO 
      JMP *-2       ZERO:THIS PUTS THE INTEGER IN A 
      AND .177      GET RID OF THE OTHER STUFF
      STA TEMP1 
      LDB EXP       NOW ROTATE BACK 
      CMB,INB 
      RAR 
      SSB,INB 
      JMP *-2 
      XOR MANT       REMOVE THE INTEGER PART
      LDB MANT+1    NORMALIZE THE REMAINDER.
      JSB NORML 
      LDA TEMP1 
      JMP GETDG,I 
      SPC 2 
NORML NOP           NORMALIZES MANTISSA.
      SZA,RSS       IF A=B=0, 
      SZB 
      JMP NRML1 
      STA EXP        SET EXP=0 ALSO.
NRML3 JSB STORM 
      JMP NORML,I 
NRML1 SSA,RSS       IF SIGN OF A IS SET,
      JMP NRML2 
      CLE,ERA         SHIFT RIGHT,
      ERB 
      ISZ EXP           BUMP EXPONENT & 
      NOP 
      JMP NRML3           RETURN
      SPC 1 
NRML2 STA MANT       SUBTRACT 
      CCA             ONE 
      ADA EXP          FROM 
      STA EXP           EXP 
      LDA MANT           AND
      CLE,ELB 
      ELA                 SHIFT 
      JMP NRML1 
 HED NUMERICAL INPUT CONVERSION 
********************************************************************
* INPUT IS THE ROUTINE THAT DOES ALL OF THE INPUT CONVERSION. IT   *
* INCLUDES BOTH A FREE-FIELD SCANNER AND A FORMATTED SCANNER.      *
* FREE-FIELD IS INDICATED BY FCR=0. ALL CONVERSION IS DONE IN      *
* THE SAME WAY, REGARDLESS OF THE FORMAT TYPE. THIS ALLOWS REAL    *
* VARIABLES TO APPEAR AS INTEGERS, AND VICE VERSA. THE FORM OF A   *
* NUMBER IS AS FOLLOWS:                                            *
*                                                                  *
* <SIGN><INTEGER PART><DEC.PT><FRACTION><E><EXP.SIGN><EXPONENT>    *
*                                                                  *
* ALL OF THESE ARE OPTIONAL, AND THE APPEARANCE OF THE FIRST       *
* SIGN, DIGIT, OR DECIMAL PT. DEFINES A NUMBER. ANY COMBINATION    *
* OF THE ABOVE IS LEGAL, WITH THE FOLLOWING EXEPTIONS:            * 
*                                                                  *
*    (1) AN INITIAL E IS IGNORED IN FREE-FIELD, AND IS ILLEGAL IN  *
*        FIXED FIELD;                                              *
*    (2) IF NO INTEGER PART OR FRACTION APPEARS (AND A SIGN OR     *
*        DEC.PT. DOES), THE RESULT IS ZERO                         *
*                                                                  *
* IN FIXED-FIELD INPUT, IF NO DECIMAL PT.  APPEARS, THE RESULT IS * 
* MULTIPLIED BY 10**(-D).                                          *
*                                                                  *
* THE FOLLOWING SPECIAL FEATURES ARE INCLUDED FOR FREE-FIELD INPUT:*
*                                                                  *
*    (1) WHEN 2 CONSECUTIVE COMMAS APPEAR WITH NO DATA BETWEEN,    *
*        THAT LIST ELEMENT IS SKIPPED.                             *
*                                                                  *
*    (2) WHEN A SLASH OCCURS IN AN INPUT RECORD, THE REMAINDER     *
*        OF THE RECORD IS TREATED AS COMMENTS.                     *
*                                                                  *
*    (3) IF A LINE TERMINATES WITHOUT A SLASH, THE INPUT OPERATION *
*        TERMINATES AND THE REMAINDER OF THE LIST REMAINS          *
*        UNCHANGED.                                                *
*                                                                  *
*    (4) WHEN A QUOTE APPEARS, THE FOLLOWING                      * 
*        CHARACTERS IN THAT LINE ARE TREATED AS COMMENTS          * 
*        UNTIL ANOTHER QUOTE APPEARS.                             * 
*                                                                  *
*    (5) ALL UNRECOGNIZED CHARACTERS ARE TREATED AS BLANKS         *
*                                                                  *
*    (6) WHEN AN INTEGER IS PRECEDED BY THE CHARACTER "B", THE IN- *
*        TEGER IS INTERPRETED AS OCTAL. 
* 
* CONTROL WITHIN INPUT IS GOVERNED BY THE VARIABLE POST,           *
* WHOSE VALUE INDICATES HOW FAR THE NUMBER HAS BEEN                *
* SCANNED, AS FOLLOWS:                                             *
*                                                                  *
* POST = 0 : NUMBER NOT STARTED YET                                *
*        1 : NUMBER STARTED, BUT NO DECIMAL PT. REACHED YET        *
*        3 : LAST CHARACTER WAS THE 'E'                            *
*          : EXPONENT BEING PROCESSED                              *
*                                                                  *
********************************************************************
      SPC 1 
FFCHK NOP      TEST FOR FREE-FIELD. IF NOT, JUMPS TO
      LDA FCR  AN ERROR ROUTINE 
      SZA 
     JMP ERR4 
     JMP FFCHK,I
      SPC 2 
INPUT NOP 
      CLA           INITIALIZATION SECTION
      STA SIGN
      STA ESIGN 
      STA MANT
      STA MANT+1
      STA EXPON 
      STA EXP 
      STA SKIP
      STA POST
      CPA FCR       FREE-FIELD? 
      RSS 
      JMP INLUP 
      STA W 
      STA D 
FLIP  ISZ W         CHECK FOR END OF FIELD WIDTH. 
      JMP INLUP 
FINAL CLA 
FINL1 STA CFLAG 
      LDA EXPON   FINAL COMPUTATION OF NUMBER 
      ISZ ESIGN     COMPUTE EXTERNAL
      CMA,INA          EXPONENT AS NEGATIVE 
      LDB D         COMPUTE D CONTRIBUTION. 
      SSB           POSITIVE MEANS A PT APPEARED, 
      CMB             NEGATIVE MEANS IT'S IMPLICIT
      ADA B         FINAL VALUE OF EXP AS NEGATIVE
      SZA,RSS       IF ZERO THEN WE CAN 
      JMP INXIT     SKIP THIS PART
      SSA           IF POSITIVE WE HAVE TO MULTIPLY 
      JMP BIGEX       BY .1 , OTHERWISE BY 10 
      CMA,INA       SET NEGATIVE TO COUNT 
      STA EXPON 
      JSB DBY10 
      ISZ EXPON 
      JMP *-2 
      JMP INXIT 
      SPC 1 
BIGEX STA EXPON 
      JSB MBY10 
      ISZ EXPON 
      JMP *-2 
INXIT JSB LODEM 
      ISZ SIGN      TEST THE SIGN 
      JMP INBAK     POSITIVE--NO SWEAT
      CMA           TWO'S COMPLEMENT THE
      CMB,INB,SZB,RSS    DOUBLE LENGTH
      INA                     NUMBER
INBAK JSB .PACK     NORMALIZE AND PACK THE RESULT.
EXP   BSS 1 
     JSB STORM
      JMP INPUT,I   RETURN
      SPC 1 
INLUP JSB INCHR 

      SPC 1 
*********** BRANCH TO THE ROUTINE THAT HANDLES THIS CHARACTER ***** 
      SPC 1 
      LDB POST
      CPA SLASH 
      JMP INSLS 
      CPA COMMA 
      JMP INCOM 
      CPA PLUS
      JMP INPLS 
      CPA MINUS 
      JMP INMIN 
      CPA POINT 
      JMP INPNT 
      CPA E 
      JMP INE 
      CPA QUOTE 
      JMP INQUO 
      CPA OCTAL 
      JMP INOCT 
      JSB DIGIT 
      JMP INBLN 
      SPC 1 
***** THE CHARACTER IS A DIGIT. WE FIRST SET POST AS FOLLOWS:  *****
*     POST=0      : POST_1                                         *
*     POST=2      : DF_DF+1                                        *
*     POST=3      : POST_6                                        * 
********************************************************************
      SPC 1 
      LDB POST
      SZB,RSS 
      ISZ POST      IF POST=0, SET IT TO 1
      CPB ....2 
      ISZ D         IF POST=2, BUMP D 
      CPB ....3 
      JMP INEX3     PROCESSING EXPONENT 
      CPB ....4 
      JMP INEX4     PROCESSING EXPONENT 
      ALF,ALF 
      ALF,RAR 
     STA TEMP1
      JSB MBY10     MULTIPLY INPUT SO FAR BY 10 
      LDB EXP       ADD DIGIT TO RESULT SO FAR
      SZB           IF EXPONENT IS ZERO 
      JMP INADD 
      LDA ....4      SET UP EXP=4 AND 
      STA EXP 
      LDA TEMP1       NORMALIZE 
      CLB 
INORM JSB NORML 
      JMP FLIP
      SPC 1 
INADD ADB MIN4
      CMB 
      LDA TEMP1     SET UP NUMBER FOR 
      STB TEMP1      SHIFTS & STORE COUNT 
      CLB 
INADL ISZ TEMP1 
      JMP INSHF 
      ADA MANT
      CLE 
      ADB MANT+1
      SEZ 
      INA 
      JMP INORM 
      SPC 1 
INSHF CLE,ERA 
      ERB 
      JMP INADL 
      SPC 1 
INEX3 ISZ POST
INEX4 LDB EXPON     MULTIPLY EXPON BY 10
      BLS,BLS 
      ADB EXPON 
      BLS 
      ADA B 
      STA EXPON 
      JMP FLIP
      SPC 1 
INCOM JSB FFCHK     TREAT A COMMA ON INPUT
      CCA 
      SZB           IS POST=0?
      JMP FINL1 
      CPA CFLAG 
      JMP *+3    DOUBLE COMMA 
      STA CFLAG 
      JMP FLIP
      SPC 1 
      STA SKIP      SET TO SKIP INPUT ITEM
      JMP INPUT,I 
      SPC 1 
INPL2 STA ESIGN 
INPLS CPB ....4     IF POST=4 THIS IS ILLEGAL 
     JMP ERR5 
     LDA ....4
      SZB         IF POST>0 THEN SET IT TO 4
STORP STA POST
      JMP FLIP
      SPC 1 
INMIN CCA           SET MINUS IN EITHER SIGN OR 
      SZB             ESIGN 
      JMP INPL2 
      STA SIGN      IF POST=0 THEN SIG_-1 
      JMP FLIP
      SPC 1 
INPNT BRS           HANDLES DECIMAL POINT 
      SZB 
      JMP ERR5      MEANS POST WAS 2 OR MORE
      STB D         SET D TO ZERO 
      LDA ....2 
      JMP STORP 
      SPC 1 
INE   SZB,RSS      HANDLES 'E'
      JMP INBLN     IF POST=0 THEN COMMENTS 
      ADB MIN3
      SSB,RSS 
      JMP ERR5      POST WAS 3 OR 4 
      LDA ....3     SET IT TO 3 
      JMP STORP 
      SPC 1 
INSLS JSB FFCHK 
      CLA           SET CCNT=0 TO FORCE A NEW RECORD
      STA CCNT       TO BE READ NEXT TIME.
INBLN LDB POST
      LDA FCR       IF FREE-FIELD AND POST NEQ 0, 
      SZA,RSS        GO TO FINAL ELSE GO TO FLIP. 
      SZB,RSS       IS POST=0?
      JMP FLIP      IF SO, JUST GO ON.
      JMP FINAL 
      SPC 1 
INQUO JSB INCHR     READ CHARACTERS UNTIL ANOTHER 
      CPA QUOTE      QUOTE IS READ. 
      JMP INBLN          INBLN
      JMP INQUO 
      SPC 1 
INOCT STA POST
      SZB           IF POST WAS NON ZERO, TREAT AS A
      JMP INBLN+3      BLANK. 
      STB CFLAG     RESET CFLAG TO SAY NO COMMA.
      JSB FFCHK 
INOC2 JSB INCHR     GET NEXT CHARACTER. 
      JSB DIGIT     CHECK FOR DIGIT.
      JMP INOC1     NO. 
      LDB MANT      GET PREVIOUS OCTAL RESULT.
      BLF,RBR       SHIFT LEFT 3. 
      IOR B         MERGE WITH NEW DIGIT. 
      STA MANT
      JMP INOC2 
      SPC 1 
INOC1 LDB .36       SET EXPONENT TO SAY 15. 
      STB MANT+1
      CPA BLANK     IF TERMINATING CHARACTER IS 
      JMP INPUT,I    OTHER THAN A BLANK,
      JSB BACKB       BACK UP THE BUFFER POINTER
      CCB              AND COUNTER. 
      ADB CCNT
      STB CCNT
      JMP INPUT,I 
 HED CONTROL SECTION
********************************************************************
* THIS FINAL SET OF ROUTINES ARE THE ROUTINES ACTUALLY CALLED BY   *
* THE FORTRAN PROGRAM. FOR EACH REAL VARIABLE, INTEGER VARIABLE,   *
* REAL ARRAY, OR INTEGER ARRAY, THERE IS A SINGLE CALL TO EITHER   * .IO
* .IOR.,.IOI.,.RAR.,OR .IAR.. THERE IS INITIALLY A SINGLE CALL TO  *
* EITHER .DIO. OR .BIO..                                           *
********************************************************************
      SPC 1 
.IOR. NOP           USED TO INPUT/OUTPUT A REAL VAR-
*                                      IABLE. .IOR. IS CALLED FOR 
*                                       OUTPUT WITH THE NUMBER TO 
*                                       BE OUTPUT IN A & B. FOR IN- 
*                                       PUT IT RETURNS WITH THE IN- 
*                                       PUT VALUE IN A & B
      JSB BCHEK     CHECK FOR BINARY
      JMP BINRL 
      JSB IOCHK 
      RSS 
      JMP CORTN 
      STA MANT
      JSB .FLUN 
      STA EXP 
      STB MANT+1
CORTN JSB LST2F 
      JSB LODEM 
      ISZ SKIP
      JMP .IOR.,I   NO SKIP 
      ISZ .IOR.     SKIP AROUND THE 
      ISZ .IOR.       STORE 
      JMP .IOR.,I 
BINRL JSB BNARY 
      STA FCR 
      STB A 
      JSB BNARY 
      STA B 
      LDA FCR 
      JMP .IOR.,I 
      SPC 2 
.IOI. NOP           USED TO INPUT/OUTPUT AN INTEGER 
*                                   VARIABLE. .IOI. IS CALLED FOR 
*                                   OUTPUT WITH THE INTEGER IN A. 
*                                   FOR INPUT IT RETURNS WITH THE 
*                                   INTEGER IN A. 
      JSB BCHEK     CHECK FOR BINARY
      JMP BININ 
      IFZ 
      STA ISAVE 
      CLB           ENTER: B=0. 
      STB IFLAG 
      ISZ AOFLG 
      JMP GO.ON 
IOIIN STA MANT
      JSB LST2F 
      LDA MANT
      JMP .IOI.,I 
      SPC 1 
      XIF 
GO.ON JSB IOCHK 
      JSB FLOAT 
      JSB .IOR. 
      JSB IFIX
      CCB           ENTER: B=-1.
      IFZ 
      STB IFLAG 
      XIF 
      LDB SKIP
      SZB,RSS 
      ISZ .IOI. 
      JMP .IOI.,I 
      SPC 1 
BININ JSB BNARY 
      JMP .IOI.,I 
      SPC 2 
.RAR. NOP           CALLED FOR INPUT/OUTPUT OF A
      CMA,INA       REAL ARRAY. 
      STA ALNTH          A=ARRAY LENGTH (>0)
      STB ARRAY          B=ARRAY ADDRESS
RARLP DLD ARRAY,I 
      JSB .IOR. 
      STB .IAR. 
      JMP RAR1
RARL1 ISZ ARRAY     SKIP RETUR
      ISZ ARRAY 
      ISZ ALNTH 
      JMP RARLP 
      JMP .RAR.,I   RETURN
      SPC 1 
RAR1  JSB IOCHK 
      JMP RARL1     OUTPUT
      LDB .IAR. 
      DST ARRAY,I 
      JMP RARL1 
      SPC 2 
.IAR. NOP           CALLED FOR INPUT/OUTPUT OF AN 
      CMA,INA       INTEGER ARRAY.
      STA ALNTH          A=ARRAY LENGTH (>0)
      STB ARRAY          B=ARRAY ADDRESS
IARLP LDA ARRAY,I 
      JSB .IOI. 
      JMP IAR1
IAR2  ISZ ARRAY 
      ISZ ALNTH 
      JMP IARLP 
      JMP .IAR.,I 
      SPC 1 
IAR1  JSB IOCHK 
      JMP IAR2
      STA ARRAY,I 
      JMP IAR2
      SPC 2 
BCHEK NOP           RETURNS TO P+1 IF BINARY, ELSE 2
      STB TEMP2 
      LDB BFLAG 
      SZB,RSS 
      ISZ BCHEK 
      LDB TEMP2 
      JMP BCHEK,I 
      SPC 2 
BNARY NOP  HANDLES TRANSFER OF 1 WORD TO OR FROM THE
      STA TEMP1    BINARY BUFFER. 
      STB .DIO.     USED AS TEMPORARY 
      ISZ CCNT      TEST FOR END OF BUFFER. 
      JMP *+3       NO. 
      JSB DTA       CALL FOR BUFFER IN/OUT. 
      JMP *-3         AND TRY AGAIN.
      ISZ BCR       BUMP BUFFER POINTER.
      LDA TEMP1     RESTORE WORD TO BE OUTPUT.
      JSB IOCHK 
      STA BCR,I     OUTPUT
      LDA BCR,I     INPUT 
      LDB .DIO. 
      JMP BNARY,I 
      SPC 2 
*************************** 
.DIO. NOP *         THE INITIAL CALL TO THE I/O ROU-
*                         *         TINES FOR FORMATTED INPUT/
***************************         OUTPUT. 
      STA UNIT
      STB IO
      SZA           CHECK FOR UNIT=0. 
      JMP DIO1      NO-IO TRANSFER. 
      INA           INTERNAL CONVERSION.
      STA CCNT      SET CCNT=1. 
      CCA           GET BUFFER ADDRESS INTO BCR.
      ADA .DIO.,I 
      ADA .DIO.,I 
      STA BCR 
      ISZ .DIO. 
DIO1  CLA 
      STA BFLAG 
      STA SKIPL 
      IFZ 
      STA AOFLG 
      XIF 
      LDA ASCRY     LOAD: A=-134. 
      STA CLEN      SET FRMTR FOR 67 WORD PHYSICAL RECORD.
      SZB,RSS 
      JSB WAITO 
      LDA .DIO.,I   GET FORMAT ADDRESS
     RAL,CLE,SLA,ERA    TEST FOR INDIRECT (1 LEVEL) 
      LDA A,I       LOAD TRUE ADDRESS.
      RAL           CONVERT TO A CHARACTER
      CMA,INA,SZA       ADDRESS 
      CMA 
      STA FCR 
      ISZ .DIO.      GET THE END-OF LIST
      LDA .DIO.,I        ADDRESS
      STA ENDLS 
      LDA MIN3
      STA NEST
      CCA 
      STA CFLAG 
      IFZ 
      STA IFLAG 
      XIF 
      ISZ .DIO.       SET UP
      LDA .DIO.          THE RETURN 
      STA LST2F             ADDRESS 
      JSB IOCHK 
      JMP FORMT 
      JSB DTA       READ ALINE IF INPUT.
      LDA FCR 
      SZA             TEST FOR FREE-FIELD 
      JMP FORMT     FORMATTED I/O.
      JSB F2LST 
      JSB INPUT 
      JMP *-2 
      SPC 2 
*************************** 
.BIO. NOP *        THE INITIAL CALL TO THE I/O ROU- 
*                         *          TINES FOR NON-FORMATTED
***************************            INPUT/OUTPUT 
        STA UNIT
      STB IO
      LDA BINRY     LOAD: A=-120. 
      STA CLEN      SET FRMTR FOR 60 WORD PHYSICAL RECORD.
      CLA,INA 
      STA BFLAG 
      SZB,RSS 
      JSB WAITO 
      LDB IO
      SZB 
      JSB DTA 
      JMP .BIO.,I 
      SPC 2 
LST2F NOP 
      CLA 
      STA SKIP               INITIALIZE COUNTER 
      JMP F2LST,I 
      SPC 2 
F2LST NOP 
      LDA BCR 
      STA BCRS
      ISZ SKIPL 
      JMP LST2F,I 
      IFZ 
      ISZ IFLAG 
      ISZ AOFLG 
      XIF 
      JMP F2LST,I 
      IFZ 
      LDA ISAVE 
      JMP IOIIN 
      XIF 
      SPC 2 
.DTA. NOP 
      LDA UNIT      SET UP STATUS CONTROL 
      SZA,RSS       IF UNIT=0,
      JMP .DTA.,I     IGNORE CALL.
      IOR STCHK      WORD 
      STA STATS 
      JSB .IOC.     CALL IOC FOR STATUS 
STATS BSS 1 
      AND PAPER     TEST FOR PAPER TAPE 
      CPA .4000     UNIT-RECORD DEVICE TYPE?
      CLA           YES, ENTER: A=0.
      SZA 
      CLA,RSS       NOT PAPER TAPE. 
      LDA PBIT
      IOR ASC2B     INCLUDE THE "BINARY" MODE BIT.
      STA IOCHK     SAVE THE "BINARY" MODE BIT(S).
      LDA UNIT      LOAD THE UNIT-REFERENCE NUMBER. 
      IOR BASIC      SAY ASCII INPUT. 
      JSB BCHEK 
      IOR IOCHK     INCLUDE THE "BINARY" MODE BIT(S). 
      LDB UNIT      SET K-BIT IF
      CPB ....1      UNIT=1.
      IOR KBIT
      JSB IOCHK     NOW TEST FOR INPUT OR OUTPUT. 
      JMP DTAO
      SPC 1 
* INPUT SECTION * 
      SPC 1 
      STA ICNTR     SET IN INPUT CONTROL WORD.
      LDA STATS     ALSO SET INPUT
      STA STATI      STATUS WORD
      JSB IOCIN     PERFORM IOC CALL. 
      JMP .DTA.,I   RETURN
      SPC 1 
* OUTPUT SECTION *
      SPC 1 
DTAO  XOR IN2OT     SET CONTROL WORD TO SAY OUTPUT. 
      STA OCNTR     SET IN OUTPUT CONTROL WORD
      LDB STATS     SET OUTPUT STATUS.
      STB STATO         WORD. 
      LDB CCNT      GET NUMBER OF CHARACTERS/WORDS. 
      SZB           BINARY RECORD CONTINUATION? 
      CMB 
      JSB BCHEK     IF BINARY, DOUBLE 
      BLS              COUNT. 
      ADB CLEN      PRODUCES CORRECT COUNT IF ASCII.
      STB OUTBL     STORE AS # OF CHARS. OUTPUT.
      JSB BCHEK 
      JMP *+3 
DTAO1 JSB IOCOU     PERFORM IOC CALL
      JMP .DTA.,I   RETURN
      SPC 1 
      BRS           CONVERT CHARACTER COUNT TO WORDS. 
      CMB,INB       SET BINARY COUNT TO POSITIVE AND
      BLF,BLF       POSITION AS HIGH CHARACTER
      ALF,ALF       ROTATE P-BIT TO SIGN
      SSA           IF NOT ZERO, STORE AS 
      STB BUFO       FIRST CHARACTER IN BUFFER. 
      JMP DTAO1 
      SPC 2 
DTA   NOP           PERFORMS A COMPLETE I/O OPERA-
      JSB .DTA.       TION. 
      JSB IOCHK 
      JMP *+3 
      JSB WAITI     INPUT WAIT
      JMP DTA,I 
      SPC 1 
      JSB WAITO     OUTPUT WAIT 
      JMP DTA,I 
      SPC 2 
WAITI NOP           WAITS FOR INPUT 
      LDA UNIT      IGNORE
      SZA,RSS        CALL IF
      JMP WAITI,I     UNIT=0. 
WTI1  JSB .IOC.     CALL TO SEE IF INPUT DONE YET.
STATI OCT 40000 
      STA STATT     SAVE STATUS IF AN ERROR OCCURS. 
      RAL,SLA       DEVICE STILL BUSY?
      JMP WTI1      YES--KEEP WAITING.
      SSA           ERROR CONDITION?
      JMP WTIER     YES.
      ALF,ALF                EOF TO BIT 0 
      SLA,RSS                SET? 
      JMP *+4                NO, JUMP 
      LDB CLEN               KLUDGE TRANSMISSION LOG
      SSB                    -? 
      CMB,INB                YES, COMPLEMENT IT 
      ELB,CLE,ERB   GET TRANSMISSION RECORD.
      JSB BCHEK     WAS THE "READ" IN BINARY MODE?
      BRS           YES, CONVERT CHARACTERS TO WORDS. 
      CMB           STORE AS NEGATIVE IN
      STB CCNT        COUNTER.
      LDB .IBUF     GET BUFFER ADDRESS
      JSB BCHEK     BINARY ?
      JMP WTI3      YES 
      RBL           FOR ASCII SET BCR TO POINT TO 
WTI2  ADB MIN1       THE FIRST CHARACTER PRECEDING
WTI4  STB BCR         THE BUFFER. 
      JMP WAITI,I 
      SPC 1 
WTI3  LDA ICNTR 
      ALF,ALF 
      SSA,RSS       PAPER TAPE ?
      JMP WTI2      NO
      ISZ CCNT      YES 
      JMP WTI4
      SPC 1 
* INPUT ERROR * 
      SPC 1 
WTIER JSB EQERR     PRINT *EQR MESSAGE
      AND STATI     SET A TO UNIT AND 
      HLT 01B        HALT.
      JSB IOCIN     CALL INPUT AGAIN
      JMP WTI1
      SPC 2 
WAITO NOP           WAITS FOR OUTPUT TO BE COMPLETED
      LDA UNIT      IGNORE CALL IF
      SZA,RSS        UNIT=0.
      JMP WAITO,I 
      JSB .IOC.     SEE IF OUTPUT IS
STCHK OCT 40000       BUFFERED AND IGNORE 
      SZB               STATUS REQUEST IF IT IS.
      JMP WTO7
      LDA STATO 
      CPA STCHK 
      JMP WTO7      NO PREVIOUS OUTPUT DONE 
      JSB .IOC. 
STATO OCT 40000 
      STA STATT     SAVE FOR ERROR DISPLAY. 
      RAL,SLA       TEST BUSY BIT.
      JMP *-4       DEVICE STILL BUSY 
      SSA,RSS       ERROR CONDITION?
      JMP WTO7      NO. 
      JSB EQERR     PRINT *EQR MESSAGE
      AND STATO      AND HALT.
      HLT 00B 
      JSB IOCOU     GO RETRY THE OUTPUT REQUEST.
      JMP STATO-1   GO WAIT FOR I/O COMPLETION. 
      SPC 1 
WTO7  LDA STCHK 
      IOR UNIT
      STA *+2 
      JSB .IOC.     CALL ON STATUS
      BSS 1 
      AND PAPER 
      CLB 
      SZA 
      CPA .4000     IS DEVICE UNIT-RECORD TYPE? 
      LDB PBIT
      STB OCNTR     SET OUTPUT CONTROL TO SAY PAPER 
      LDA .OBUF     SET UP BUFFER ADDRESS AND 
      CCB            LENGTH.
      ADB CLEN
      JSB BCHEK     BINARY. 
      JMP WTO6
      RAL           ADJUST BUFFER ADDRESS FOR 
      ADA MIN1       CHARACTERS 
      STA BCR 
      STB CCNT
      JMP WAITO,I 
      SPC 1 
WTO6  BRS           ADJUST LENGTH FOR WORDS.
      ADA MIN1
      STA BCR 
      STB CCNT
      LDA OCNTR     GET OUTPUT CONTROL WORD 
      ALF,ALF 
      SSA,RSS       TEST FOR PAPER TAPE.
      JMP WAITO,I   NOT PAPER TAPE. 
      ISZ CCNT     IF PAPER TAPE, BUMP BUFFER 
      ISZ BCR        ADDRESS AND COUNTER. 
      JMP WAITO,I   RETURN
      SPC 2 
EQERR NOP 
      JSB .IOC.     PRINT 
      OCT 20002       *EQR
      JMP *-2           MESSAGE.
      DEF EQMES 
      OCT -4
      JSB ENDIO     GO WAIT FOR ALL I/O COMPLETION. 
      DEF *+1       RETURN ADDRESS DEFINITION.
      LDA .177      LOAD MASK FOR UNIT NUMBER.
      LDB STATT     LOAD ERROR WORD.
      JMP EQERR,I   RETURN
      SPC 1 
EQMES ASC 2,*EQR
      SPC 2 
IOCIN NOP           INPUT CALL TO IOC 
      JSB .IOC. 
ICNTR BSS 1 
      JMP *-2 
.IBUF DEF BUFI
CLEN  ABS -BUFLN-BUFLN
      JMP IOCIN,I 
      SPC 2 
IOCOU NOP           OUTPUT CALL TO IOC
      JSB .IOC. 
OCNTR BSS 1 
      JMP *-2 
.OBUF DEF BUFO
OUTBL BSS 1 
      JMP IOCOU,I 
      SPC 1 
* ERROR SECTION * 
      SPC 1 
ERR1  JSB ERROR 
....1 ABS 1 
ERR2  JSB ERROR 
....2 ABS 2 
ERR3  JSB ERROR 
....3 ABS 3 
ERR4  JSB ERROR 
....4 ABS 4 
ERR5  JSB ERROR 
      ABS 5 
      SPC 2 
ERROR NOP 
      JSB .IOC. 
      OCT 20002 
      JMP *-2 
      DEF ERMES 
      DEC -4
      JSB ENDIO     GO WAIT FOR ALL I/O COMPLETION. 
      DEF *+1       RETURN ADDRESS DEFINITION.
      LDA ERROR,I 
      HLT 00B 
      JMP ENDLS,I   RETURN TO END OF CALLING SEQ. 
      SPC 1 
ERMES ASC 2,*FMT    FORMAT ERROR MESSAGE. 
      SPC 1 
      END 

ASMB,R,B,L,T,C
      NAM CODE
      HED ***  FORTRAN/ALGOL "ENCODE" & "DECODE"  ***        (JRW)
      ENT CODE,ACODE
      SPC 2 
*         **********************************************************
*         *CALLING SEQUENCES:                                      *
*         *                                                        *
*         *FORTRAN:                                                *
*         *                                                        *
*         *      PROGRAM <NAME>                                    *
*         *      DIMENSION IBUFR(<IRCRD>)                          *
*         *      .                                                 *
*         *      .                                                 *
*         *      .                                                 *
*         *      CALL CODE                                         *
*         *      READ (IBUFR,<FMT>) <LIST>                         *
*         *<FMT> FORMAT(<SPECIFICATION(S)>)                        *
*         *      .                                                 *
*         *      .                                                 *
*         *      .                                                 *
*         *      CALL CODE                                         *
*         *      WRITE (IBUFR,<FMT>) <LIST>                        *
*         *      .                                                 *
*         *      .                                                 *
*         *      .                                                 *
*         *      END                                               *
*         *                                                        *
*         *GENERATED ASSEMBLY CODE:                                *
*         *                                                        *
*         * LOC.:            BEFORE:             AFTER:            *
*         *                                                        *
*         *("CODE,I"-1)      JSB CODE            CLA,RSS           *
*         *    +1            DEF *+1             DEF *+1           *
*         *    +2            LDA IBUFR(,I)       CLB(,INB)         *
*         *    +3            CLB(,INB)           JSB .DIO.         *
*         *    +4            JSB .DIO.           DEF IBUFR         *
*         *    +5            DEF <FMT>           DEF <FMT>         *
*         *    +6            DEF .END.           DEF .END.         *
*         **********************************************************
      SKP 
CODE  NOP           ENTRY POINT.
ACODE EQU CODE      ALTERNATE ENTRY POINT FOR ALGOL.
      LDB .CLA.     LOAD: "CLA,RSS" INSTRUCTION.
      CCA           ENTER: A=-1.
      ADA CODE      "A" = THE ADDRESS OF "JSB CODE".
A     EQU 00000B    DEFINE THE ADDRESS OF "A".
      STB A,I       STORE: "CLA,RSS" AT "JSB CODE". 
      LDB CODE,I    LOAD: ADDRESS OF "LDA IBUFR". 
      STA CODE      STORE THE RETURN ADDRESS. 
B     EQU 00001B    DEFINE THE ADDRESS OF "B".
      LDA B,I       LOAD: "LDA IBUFR(,I)".
      RAL,CLE,SLA,ALF INDIRECT INSTRUCTION? 
      JMP INDIR     YES, GO CONSTRUCT BUFFER ADDRESS. 
      JSB ORDEF     GO CONSTRUCT "DEF IBUFR". 
STORE STA ORDEF     STORE: "DEF IBUFR" TEMPORARILY. 
      STB CURAD     STORE: ADDRESS OF "LDA IBUFR".
TWICE ISZ CURAD     INCREMENT THE SOURCE ADDRESS. 
      LDA CURAD,I   LOAD: THE WORD TO BE TRANSMITTED. 
      STA B,I       STORE: IN "*-1".
      SEZ,CCE,INB,RSS TWO(2) WORDS MOVED UP?
      JMP TWICE     NO, CONTINUE. 
      LDA ORDEF     YES; LOAD: "DEF IBUFR". 
      STA B,I       STORE: AFTER THE "JSB .DIO.". 
      JMP CODE,I    RETURN. 
      SPC 1 
INDIR JSB ORDEF     GO CONSTRUCT "DEF IBUFR". 
DEF   LDA A,I       LOAD: "DEF IBUFR,I".
      RAL,CLE,SLA,ERA INDIRECT ADDRESS DEFINITION?
      JMP DEF       YES, GO LOAD THE NEXT LEVEL.
      JMP STORE     NO, GO STORE CALLING SEQUENCE.
      SPC 2 
ORDEF NOP           ENTRY POINT.
      CLE,ELA       SHIFT: PAGE INDICATOR TO "E". 
      LDA B,I       LOAD: "LDA IBUFR(,I)".
      AND B1777     ISOLATE THE PAGE WORD ADDRESS.
      SEZ,CLE,RSS   BASE PAGE INSTRUCTION REFERENCE?
      JMP ORDEF,I   YES, RETURN.
      STA CURAD     NO, STORE THE PAGE WORD ADDRESS.
      LDA B         LOAD: ADDRESS OF "LDA IBUFR(,I)". 
      AND B076.     SAVE THE 5 BIT PAGE NUMBER. 
      IOR CURAD     "A" = "DEF IBUFR".
      JMP ORDEF,I   RETURN. 
      SKP 
*     BEGIN "LOCAL STORAGE".
      SPC 1 
      ORB 
.CLA. CLA,RSS       FIRST WORD OF CALLING SEQUENCE. 
CURAD NOP           CURRENT ADDRESS COUNTER.
B1777 OCT 001777
B076. OCT 076000
      ORR 
      SPC 1 
*     END OF "LOCAL STORAGE". 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM MAGTP 
      HED ***  MAGNETIC TAPE FUNCTION REQUESTS  ***          (JRW)
      ENT IEOF,IERR,IEOT,IWRDS,LOCAL,ISOT,RWSTB 
      ENT GAP3,CLEAR,IUNIT,BFINP,BFOUT
      EXT .ENTR,.IOC. 
      SKP 
UNIT. NOP           UNIT-REFERENCE NUMBER PARAMETER.
IEOF  NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF UNIT. 
      LDA UNIT.,I   LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP IEOF,I    YES, RETURN.
      LDB =B030000  NO, LOAD DYNAMIC STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
      ALF,CLE,ALF   SHIFT THE "EOF" BIT TO 15.
      JMP IEOF,I    RETURN. 
      SPC 2 
.UNIT NOP           UNIT-REFERENCE NUMBER PARAMETER.
IERR  NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF .UNIT 
      LDA .UNIT,I   LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP IERR,I    YES, RETURN.
      LDB =B030000  NO, LOAD DYNAMIC STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
      AND =B000022  SAVE THE ERROR BITS ONLY. 
      CCE,SZA       WERE THERE ANY ERRORS?
      ELA,CLE,RAR   YES, SO MAKE "A" NEGATIVE.
      JMP IERR,I    NO, RETURN. 
      SPC 2 
U.5   NOP           UNIT-REFERENCE NUMBER PARAMETER.
IEOT  NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.5 
      LDA U.5,I     LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP IEOT,I    YES, RETURN.
      LDB =B030000  NO, LOAD DYNAMIC STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
      ALF,CLE,ALF   SHIFT THE "EOT" BIT TO 15.
      RAL,CLE,RAL   SHIFT THE "EOT" BIT TO 15.
      JMP IEOT,I    RETURN. 
      SPC 2 
UNITI NOP           UNIT-REFERENCE NUMBER PARAMETER.
IWRDS NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF UNITI 
      LDA UNITI,I   LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP IWRDS,I   YES, RETURN.
      LDB =B040000  NO, LOAD THE STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
A     EQU 00000B    DEFINES THE ADDRESS OF "A". 
      STB A         STORE THE LOG IN "A" FOR RETURN.
      ELA,CLE,ERA   REMOVE THE MODE FLAG. 
      JMP IWRDS,I   RETURN. 
      SPC 2 
UN.RF NOP           UNIT-REFERENCE NUMBER PARAMETER.
LOCAL NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF UN.RF 
      LDA UN.RF,I   LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP LOCAL,I   YES, RETURN.
      LDB =B030000  NO, LOAD DYNAMIC STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
      RAR,CLE       SHIFT THE "LOCAL" BIT TO 15.
      JMP LOCAL,I   RETURN. 
      SPC 2 
U.0   NOP           UNIT-REFERENCE NUMBER PARAMETER.
ISOT  NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.0 
      LDA U.0,I     LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CLE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP ISOT,I    YES, RETURN.
      LDB =B030000  NO, LOAD DYNAMIC STATUS REQUEST.
      JSB STAT.     GO GET THE UNIT STATUS. 
      ALF,ALF       SHIFT THE "SOT" BIT TO 15.
      RAL,CLE       SHIFT THE "SOT" BIT TO 15.
      JMP ISOT,I    RETURN. 
      SPC 2 
U.1   NOP           UNIT-REFERENCE NUMBER PARAMETER.
RWSTB NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.1 
      LDA U.1,I     LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CCE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP RWSTB,I   YES, RETURN.
      LDB =B030500  NO, LOAD REWIND/STANDBY REQUEST.
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP RWSTB,I   RETURN. 
      SPC 2 
U.2   NOP           UNIT-REFERENCE NUMBER PARAMETER.
GAP3  NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.2 
      LDA U.2,I     LOAD THE UNIT-REFERENCE NUMBER. 
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      CCE,SSA       NO; IS UNIT-REFERENCE NEGATIVE? 
      JMP GAP3,I    YES, RETURN.
      LDB =B030600  NO, LOAD THE 3" ERASE REQUEST.
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP GAP3,I    RETURN. 
      SPC 2 
U.3   NOP           UNIT-REFERENCE NUMBER PARAMETER.
CLEAR NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.3 
      LDA U.3,I     LOAD THE UNIT-REFERENCE NUMBER. 
      CLE,SSA       IS THE UNIT-REFERENCE NEGATIVE? 
      JMP CLEAR,I   YES, RETURN.
      CLB           NO, ENTER: B=0; CLEAR REQUEST.
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP CLEAR,I   RETURN. 
      SPC 2 
U.4   NOP           UNIT-REFERENCE NUMBER PARAMETER.
IUNIT NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH ONE(1) PARAMETER. 
      DEF U.4 
      LDA U.4,I     LOAD THE UNIT-REFERENCE NUMBER. 
      CLE,SSA       IS THE UNIT-REFERENCE NEGATIVE? 
      JMP IUNIT,I   YES, RETURN.
      LDB =B040000  NO, LOAD THE STATUS REQUEST.
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP IUNIT,I   RETURN. 
      SPC 2 
U.6   NOP           UNIT-REFERENCE NUMBER PARAMETER.
A.0   NOP           BUFFER ADDRESS PARAMETER. 
L.0   NOP           BUFFER LENGTH PARAMETER.
BFINP NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH THREE(3) PARAMETERS.
      DEF U.6 
      LDA U.6,I     LOAD THE UNIT-REFERENCE NUMBER. 
      LDB A.0       LOAD THE BUFFER ADDRESS.
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      SZB,RSS       NO; IS THE BUFFER ADDRESS ZERO? 
      JMP BFINP,I   YES, RETURN.
      STB B.ADD     NO, STORE THE BUFFER ADDRESS. 
      LDB L.0,I     LOAD THE BUFFER LENGTH PARAMETER. 
      STB B.LTH     STORE THE BUFFER LENGTH.
      LDB =B010100  LOAD THE BINARY READ REQUEST. 
      SSA           IS THE READ REQUEST FOR "BCD"?
      LDB =B010000  YES, LOAD THE "BCD" READ REQUEST. 
      CCE,SSA       ENTER: E=1; IS REQUEST NEGATIVE?
      CMA,INA       YES, COMPLEMENT UNIT-REFERENCE. 
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP BFINP,I   RETURN. 
      SPC 2 
U.7   NOP           UNIT-REFERENCE NUMBER PARAMETER.
A.1   NOP           BUFFER ADDRESS PARAMETER. 
L.1   NOP           BUFFER LENGTH PARAMETER.
BFOUT NOP           ENTRY POINT.
      JSB .ENTR     "CALL" WITH THREE(3) PARAMETERS.
      DEF U.7 
      LDA U.7,I     LOAD THE UNIT-REFERENCE NUMBER. 
      LDB A.1       LOAD THE BUFFER ADDRESS.
      SZA           IS THE UNIT-REFERENCE ZERO(0)?
      SZB,RSS       NO; IS THE BUFFER ADDRESS ZERO? 
      JMP BFOUT,I   YES, RETURN.
      STB B.ADD     NO, STORE THE BUFFER ADDRESS. 
      LDB L.1,I     LOAD THE BUFFER LENGTH PARAMETER. 
      STB B.LTH     STORE THE BUFFER LENGTH.
      LDB =B020100  LOAD THE BINARY WRITE REQUEST.
      SSA           IS THE WRITE REQUEST FOR "BCD"? 
      LDB =B020000  YES, LOAD BINARY WRITE REQUEST. 
      CCE,SSA       ENTER: E=1; IS REQUEST NEGATIVE?
      CMA,INA       YES, COMPLEMENT UNIT-REFERENCE. 
      JSB STAT.     GO EXECUTE THE REQUEST. 
      JMP BFOUT,I   RETURN. 
      SPC 2 
STAT. NOP           ENTRY POINT.
      AND =B000077  SAVE THE UNIT NUMBER ONLY.
B     EQU 00001B    DEFINES THE ADDRESS OF "B". 
      IOR B         INCLUDE THE OPERATION CODE. 
      STA REQST     SETUP THE REQUEST CODE. 
      CLA,SEZ       ENTER: A=0; REJECT ADDRESS? 
      LDA JMP.2     YES, LOAD THE "JMP" INSTRUCTION.
      STA REJCT     STORE THE INSTRUCTION.
.JSB. JSB .IOC.     STATUS REQUEST. 
REQST OCT 000000    REQUEST CODE. 
REJCT NOP           "NOP" OR "JMP *-2". 
B.ADD JMP STAT.,I   BUFFER ADDRESS OR RETURN. 
B.LTH NOP           BUFFER LENGTH.
      LDA JMP.S     LOAD THE RETURN JUMP INSTRUCTION. 
      STA B.ADD     RESET FOR NEXT STATUS "CALL". 
      JMP STAT.,I   RETURN. 
      SPC 3 
*         BEGIN "LOCAL STORAGE".
      SPC 1 
      ORB 
JMP.2 JMP .JSB.     REJECT ADDRESS INSTRUCTION. 
JMP.S JMP STAT.,I   RETURN JUMP INSTRUCTION.
      ORR 
      SPC 1 
*         END OF "LOCAL STORAGE". 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %ANH
      ENT %ANH
      EXT TANH
      SPC 3 
*     UTILITY ROUTINE CALL TO TANH
      SPC 2 
%ANH  NOP           ENTRY/EXIT
      ISZ %ANH
      LDB %ANH,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB TANH      CALL TO TANH ROUTINE
      ISZ %ANH
      JMP %ANH,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %XP 
      ENT %XP 
      EXT EXP 
      SPC 3 
*     UTILITY ROUTINE CALL TO EXP 
      SPC 2 
%XP   NOP           ENTRY/EXIT
      ISZ %XP 
      LDB %XP,I     PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB EXP       CALL EXP ROUTINE
      ISZ %XP 
      JMP %XP,I     RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %IN 
      ENT %IN 
      EXT SIN 
      SPC 3 
*     UTILITY ROUTINE CALL TO SIN 
      SPC 2 
%IN   NOP           ENTRY/EXIT
      ISZ %IN 
      LDB %IN,I     PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB SIN       CALL SIN ROUTINE
      ISZ %IN 
      JMP %IN,I    RETURN 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %OS 
      ENT %OS 
      EXT COS 
      SPC 3 
*     UTILITY ROUTINE CALL TO COS 
      SPC 2 
%OS   NOP           ENTRY/EXIT
      ISZ %OS 
      LDB %OS,I     PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB COS       CALL COS ROUTINE
      ISZ %OS 
      JMP %OS,I     RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %AN 
      ENT %AN 
      EXT TAN 
      SPC 3 
*     UTILITY ROUTINE CALL TO TAN 
      SPC 2 
%AN   NOP           ENTRY/EXIT
      ISZ %AN 
      LDB %AN,I     PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB TAN       CALL TO TAN ROUTINE 
      ISZ %AN 
      JMP %AN,I     RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %BS 
      ENT %BS 
      EXT ABS 
      SPC 3 
*     UTILITY ROUTINE CALL TO ABS 
      SPC 2 
%BS   NOP           ENTRY/EXIT
      ISZ %BS 
      LDB %BS,I     GET PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB ABS       CALL ABS ROUTINE
      ISZ %BS 
      JMP %BS,I     RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %LOG
      ENT %LOG
      EXT ALOG
      SPC 3 
*     UTILITY ROUTINE CALL TO ALOG
      SPC 2 
%LOG  NOP           ENTRY/EXIT
      ISZ %LOG
      LDB %LOG,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB ALOG      CALL ALOG ROUTINE 
      ISZ %LOG
      JMP %LOG,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %QRT
      ENT %QRT
      EXT SQRT
      SPC 3 
*     UTILITY ROUTINE CALL TO SQRT
      SPC 2 
%QRT  NOP           ENTRY/EXIT
      ISZ %QRT
      LDB %QRT,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB SQRT      CALL TO SQRT ROUTINE
      ISZ %QRT
      JMP %QRT,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %IGN
      ENT %IGN
      EXT SIGN,GETAD,ADRES
      SPC 3 
*     UTILITY ROUTINE CALL TO ISIGN 
      SPC 2 
%IGN  NOP           ENTRY/EXIT
      ISZ %IGN
      JSB GETAD     GET A PARAMETER ADDRESS 
      DEF %IGN,I
      LDA ADRES 
      STA %10 
      ISZ %IGN
      JSB GETAD     GET B PARAMETER ADDRESS 
      DEF %IGN,I
      LDA ADRES 
      STA %10+1 
      JSB SIGN      CALL SIGN ROUTINE 
%10   DEF * 
      DEF * 
      ISZ %IGN
      JMP %IGN,I   RETURN 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %LOAT 
      ENT %LOAT 
      EXT FLOAT 
      SPC 3 
*     UTILITY ROUTINE CALL TO FLOAT 
      SPC 2 
%LOAT NOP           ENTRY/EXIT
      ISZ %LOAT 
      LDB %LOAT,I   PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       LOAD PARAMETER INTO A REGISTER
      JSB FLOAT     CALL FLOAT ROUTINE
      ISZ %LOAT 
      JMP %LOAT,I   RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %FIX
      ENT %FIX
      EXT IFIX
      SPC 3 
*     UTILITY ROUTINE CALL TO IFIX
      SPC 2 
%FIX  NOP 
      ISZ %FIX
      LDB %FIX,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB IFIX      CALL TO IFIX SUBROUTINE 
      ISZ %FIX
      JMP %FIX,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %TAN
      ENT %TAN
      EXT ATAN
      SPC 3 
*     UTILITY ROUTINE CALL TO ATAN
      SPC 2 
%TAN  NOP           ENTRY/EXIT
      ISZ %TAN
      LDB %TAN,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD PARAMETER INTO A AND B REG 
      JSB ATAN      CALL TO ATAN ROUTINE
      ISZ %TAN
      JMP %TAN,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %ABS
      ENT %ABS
      EXT IABS
      SPC 3 
*     UTILITY ROUTINE CALL TO IABS
      SPC 2 
%ABS  NOP           ENTRY/EXIT
      ISZ %ABS
      LDB %ABS,I
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       LOAD PARAMETER INTO A REGISTER
      JSB IABS      CALL IABS ROUTINE 
      ISZ %ABS
      JMP %ABS,I    RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %SIGN 
      ENT %SIGN 
      EXT ISIGN,GETAD,ADRES 
      SPC 3 
*     UTILITY ROUTINE CALL TO ISIGN 
      SPC 2 
%SIGN NOP 
      ISZ %SIGN 
      JSB GETAD     GET PARAMETER A ADDRESS 
      DEF %SIGN,I 
      LDA ADRES 
      STA %10 
      ISZ %SIGN 
      JSB GETAD     GET PARAMETER B ADDRESS 
      DEF %SIGN,I 
      LDA ADRES 
      STA %10+1 
      JSB ISIGN     CALL TO ISIGN ROUTINE 
%10   DEF *              PARAMETER A
      DEF *              PARAMETER B
      ISZ %SIGN 
      JMP %SIGN,I  RETURN 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %AND
      EXT GETAD,ADRES 
      SPC 3 
*     UTILITY ROUTINE CALL %AND 
      SPC 2 
%AND  NOP           ENTRY/EXIT
      ISZ %AND
      JSB GETAD     GET PARAMETER A ADDRESS 
      DEF %AND,I
      LDA ADRES 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I       LOAD THE PARAMETER. 
      ISZ %AND
      JSB GETAD     GET PARAMETER B ADDRESS 
      DEF %AND,I
      LDB ADRES     LOAD THE MASK ADDRESS.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      AND B,I 
      ISZ %AND
      JMP %AND,I   RETURN 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %OR 
      ENT %OR 
      EXT GETAD,ADRES 
      SPC 3 
*     UTILITY ROUTINE CALL %OR
      SPC 2 
%OR   NOP 
      ISZ %OR 
      JSB GETAD     GET PARAMETER A ADDRESS 
      DEF %OR,I 
      LDA ADRES 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I 
      ISZ %OR 
      JSB GETAD     GET PARAMETER B ADDRESS 
      DEF %OR,I 
      LDB ADRES 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      IOR B,I 
      ISZ %OR 
      JMP %OR,I    RETURN 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %OT 
      ENT %OT 
      SPC 3 
*     UTILITY ROUTINE %OT 
      SPC 2 
%OT   NOP           ENTRY/EXIT
      ISZ %OT 
      LDB %OT,I     PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       LOAD PARAMETER INTO A REGISTER
      CMA           COMPLEMENT
      ISZ %OT 
      JMP %OT,I     RETURN
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM %SSW
      HED ***  CALL BY NAME TO ISSW  ***                     (JRW)
      ENT %SSW
      EXT ISSW
      SPC 3 
%SSW  NOP 
      ISZ %SSW
      LDB %SSW,I    PARAMETER ADDRESS 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       LOAD PARAMETER INTO A 
      JSB ISSW
      ISZ %SSW
      JMP %SSW,I    RETURN
      SPC 1 
      END 

ASMB,R,B,L,T,C
      NAM TANH
      ENT TANH
      EXT .PWR2,EXP,..FCM,ABS,.FLUN 
      SPC 3 
*      CALL.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB TANH (RESULT FLOATING) 
      SPC 1 
*      CALCULATE HYPERBOLIC TANGENT OF X. 
      SPC 2 
TANH  NOP 
      STA SGN      SAVE SIGN(X) 
      JSB ABS 
      STA X 
      STB X+1      X=ABS(X) 
      JSB .FLUN 
      ADA M5
      SSA,RSS      X>=16 ?
      JMP CASEA    YES
      ADA K7
      SSA,RSS      X>=.125 ?
      JMP CASEB    YES
      ADA K8
      SSA,RSS      X>=.00005 ?
      JMP CASEC    YES
      LDA X 
      LDB X+1      ABS(ANS)=X 
CKNEG STA X 
      LDA SGN 
      SSA          WAS X<0
      JMP COMP     YES
      LDA X 
      JMP TANH,I
      SPC 1 
COMP  LDA X 
      JSB ..FCM 
      JMP TANH,I   ANS=-ABS(ANS)
      SPC 1 
CASEA LDA K1
      LDB K1+1     ABS(ANS)=1 
      JMP CKNEG 
      SPC 1 
CASEB LDA X 
      LDB X+1 
      JSB .PWR2 
      DEC 1 
      JSB EXP 
      STA F 
      STB F+1      F=EXP(2*X) 
      FAD K1
      STA T 
      STB T+1      T=F+1
      LDA F 
      LDB F+1 
      FSB K1
       FDV T
      JMP CKNEG    ABS(ANS)=(F-1)/T 
      SPC 1 
CASEC LDA X 
      LDB X+1 
      FMP A 
      STA F 
      STB F+1      F=A*X
      FMP F 
      STA F2
      STB F2+1     F2=F**2
      FAD D 
      STA T 
      STB T+1      T=F2+D 
      LDA C 
      LDB C+1 
      FDV T 
      FAD B 
      FMP F2
      FAD A 
      STA T 
      STB T+1      T=A+F2*(B+C/T) 
      LDA F 
      LDB F+1 
      FDV T 
      JMP CKNEG    ABS(ANS)=F/T 
      SPC 2 
      ORB 
X     BSS 2 
SGN   OCT 0 
M5    DEC -5
K7    DEC 7 
K8    DEC 8 
T     BSS 2 
K1    DEC 1.
F     BSS 2 
A     DEC 5.7707801636
B     DEC .01732867951
C     DEC 14.1384114018 
D     DEC 349.6699888 
F2    BSS 2 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM TAN 
      ENT TAN 
      EXT .PWR2,..FCM,.IENT,.CHEB,FLOAT,.ERRR 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING,RADIANS)
*      JSB TAN  (RESULT FLOATING) 
      SPC 1 
*      CALCULATES  TAN(X) 
      SPC 2 
TAN   NOP 
      FMP FOPI
      STA X 
      STB X+1      X=4*X/PI 
      FAD K1
      JSB .PWR2 
      DEC -2
      JSB .IENT 
      JMP FAIL
      JSB FLOAT 
      JSB ..FCM 
      JSB .PWR2 
      DEC 2 
      FAD X 
      STA X 
      STB X+1      X=X-4*ENTIER((X+1)/4)
      FSB K1
      STA FLAG
      SSA          X<1 ?
      JMP ELSE1    YES
      LDA K2       NO 
      LDB K2+1
      FSB X        Y=2-X
BOTH1 STA Y 
      STB Y+1 
      FMP Y 
      FMP K2
      FSB K1
      JSB .CHEB 
      DEF COEFF 
      FMP Y 
      STA Y 
      STB Y+1      Y=Y*CHEBY(2*Y**2-1)
      LDA FLAG
      SSA          X<1
      JMP ELSE2    YES
      LDA K1       NO 
      LDB K1+1
      FDV Y 
      JMP TAN,I    ANS=1/Y
      SPC 1 
ELSE1 LDA X 
      LDB X+1 
      JMP BOTH1    Y=X
      SPC 1 
FAIL  JSB .ERRR 
      ASC 2,09OR
ELSE2 LDA Y 
      LDB Y+1 
      JMP TAN,I    ANS=Y
      SPC 2 
      ORB 
FOPI  DEC 1.273239545   4/PI
K1    DEC 1.
FLAG  OCT 0 
X     BSS 2 
Y     BSS 2 
K2    DEC 2.
COEFF DEC 1.4458E-8 
      DEC 2.013766E-7 
      DEC 2.804816E-6 
      DEC 3.906637E-5 
      DEC 5.4417038E-4
      DEC 7.586101578E-3
      DEC .10675392857
      DEC 1.7701474227
      OCT 0 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ATAN
      ENT ARCTA,ATAN
      EXT .CHEB 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB ATAN (RESULT FLOATING) 
      SPC 1 
*      CALCULATES ARCTAN(X).
*      RESULT IN RANGE -PI/2 TO PI/2. 
      SPC 2 
ATAN  NOP 
ARCTA EQU ATAN
      STA X 
      STB X+1 
      LDA 1 
      AND RMSK
      STA FLAG     FLAG=EXPO.FIELD (X)
      SZA 
      SLA          ABS(X)>1 ? 
      JMP ELSE1    NO 
      LDA K1
      LDB K1+1
      FDV X        U=1/X
BOTH1 STA U 
      STB U+1 
      FMP U 
      FMP K2
      FSB K1
      JSB .CHEB 
      DEF COEFF 
      FMP U 
      STA Y 
      STB Y+1      Y=U*CHEBY(2*U**2-1)
      LDA FLAG
      SZA 
      SLA          ABS(X)>1 ? 
      JMP ELSE2    NO 
      LDA X 
      SSA          X<0 ?
      JMP ELSE3    YES
      LDA PIBY2 
      LDB PIBY2+1 
      FSB Y 
      JMP ATAN,I   ANS=PI/2-Y 
      SPC 1 
ELSE1 LDA X 
      LDB X+1 
      JMP BOTH1    U=X
      SPC 1 
ELSE2 LDA Y 
      LDB Y+1 
      JMP ATAN,I   ANS=Y
      SPC 1 
ELSE3 LDA MP2 
      LDB MP2+1 
      FSB Y 
      JMP ATAN,I   ANS=-PI/2-Y
      SPC 2 
      ORB 
X     BSS 2 
RMSK  OCT 377 
FLAG  OCT 0 
K1    DEC 1.
U     BSS 2 
K2    DEC 2.
Y     BSS 2 
PIBY2 DEC 1.5707963268  PI/2
MP2   DEC -1.5707963268 -PI/2 
COEFF DEC -1.33034E-8 
      DEC 8.64888E-8
      DEC -56.99186E-8
      DEC 3.821037E-6 
      DEC -2.6215196E-5 
      DEC 1.8574297E-4
      DEC -1.381195004E-3 
      DEC .01113584206
      DEC -.1058929245
      DEC 1.762747174 
      OCT 0 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .RTOR 
      ENT .RTOR 
      EXT ALOG,EXP,.ERRR
      SPC 3 
*      CALL.. 
      SPC 1 
*      JSB .RTOR     (RESULT FLOATING)
*      DEF BASE      (FLOATING) 
*      DEF POWER     (FLOATING) 
      SPC 1 
*      CALCULATES  BASE**POWER. 
      SPC 2 
.RTOR NOP 
      LDA .RTOR,I 
      STA BASE
      ISZ .RTOR 
      LDB .RTOR,I 
      ISZ .RTOR 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      DLD B,I       LOAD THE POWER. 
      STA PWR 
      STB PWR+1 
      DLD BASE,I   PICK UP BASE 
      STA BASE
      STB BASE+1
      LDB PWR 
      SZA,RSS      BASE=0 ? 
      JMP BZER     YES
      SZB,RSS      POWER=0 ?
      JMP PZER     YES
      SSA          BASE<0 ? 
      JMP FAIL     YES
      LDB BASE+1
      JSB ALOG
      FMP PWR 
      JSB EXP 
      JMP .RTOR,I  ANS=EXP(POWER*ALOG(BASE))
      SPC 1 
BZER  SZB 
      SSB          POWER<=0 ? 
      JMP FAIL     YES
      CLB          NO 
      JMP .RTOR,I  ANS=0
      SPC 1 
FAIL  JSB .ERRR 
      ASC 1,04
      ASC 1,UN
PZER  LDA E1       ANS=1
      LDB E1+1
      JMP .RTOR,I 
      SPC 2 
      ORB 
BASE  BSS 2 
PWR   BSS 2 
E1    DEC 1.
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM EXP 
      ENT EXP 
      EXT .ERRR,.IENT,FLOAT,.PWR2 
      SPC 3 
*      CALL.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB EXP  (RESULT FLOATING) 
      SPC 1 
*      CALCULATES EXPONENTIAL OF X. 
      SPC 2 
EXP   NOP 
      FMP L2E 
      STA F 
      STB F+1      F=X*LOG2(E)
      JSB .IENT 
      JMP FAIL     ERROR IF EXPO(F) >=15
      STA INT      INT=ENTIER(F)
      JSB FLOAT 
      STA TMP 
      STB TMP+1    TMP=ENTIER(F)
      LDA INT 
      ADA M124
      SSA,RSS      F>=124 ? 
      JMP FAIL     YES, ERROR 
      ADA E244     F<-120 ? 
      SSA 
      JMP ZER      YES, ANS=0 
      LDA F 
      LDB F+1 
      FSB TMP 
      STA F 
      STB F+1      F=F-ENTIER(F)
      FMP F 
      STA F2
      STB F2+1     F2=F**2
      FAD A 
      STA TMP 
      STB TMP+1    TMP=F**2+A 
      LDA B 
      LDB B+1 
      FDV TMP 
      STA TMP 
      STB TMP+1    TMP=B/TMP
      LDA C 
      LDB C+1 
      FMP F2
      FAD D 
      FSB F 
      FSB TMP 
      STA TMP      TMP=-F+D+C*F**2-TMP
      STB TMP+1 
      LDA F 
      LDB F+1 
      FDV TMP 
      FAD HLF 
      ISZ INT      INT=INT+1
      NOP 
      JSB .PWR2 
INT   OCT 0 
      JMP EXP,I    ANS=(0.5+F/TMP)*2**INT 
      SPC 1 
FAIL  JSB .ERRR 
      ASC 2,07OF
ZER   CLA 
      CLB 
      JMP EXP,I    ANS=0
      SPC 2 
      ORB 
M124  DEC -124
E244  DEC 244 
A     DEC 87.417497202
B     DEC 617.9722695 
C     DEC .03465735903
D     DEC 9.9545957821
L2E   DEC 1.4426950409  LOG BASE 2 OF E 
F     BSS 2 
TMP   BSS 2 
F2    BSS 2 
HLF   DEC .5
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM SQRT
      ENT SQRT
      EXT .FLUN,.PWR2,.ERRR 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB SQRT (RESULT FLOATING) 
      SPC 2 
SQRT  NOP 
      SZA,RSS      X=0 ?
      JMP SQRT,I   YES, ANS=0 
      SSA          X<0 ?
      JMP FAIL     YES, ERROR 
      STA F 
      STB F+1      F=X
      JSB .FLUN 
      SLA,ARS      EXPO(X) ODD ?
      JMP ODD      YES
      ADA M1
      STA CHAR     CHAR=EXPO(X)/2-1 
      LDA F+1 
      AND LMSK
      STA F+1      F=MANT(F)
      LDA F 
      LDB F+1 
      FMP A2
      FAD B2       P=B2+A2*F
BOTH  STA P 
      STB P+1 
      LDA F 
      LDB F+1 
      FDV P 
      FAD P 
      JSB .PWR2 
M1    DEC -1
      STA P 
      STB P+1      P=(P+F/P)/2
      LDA F 
      LDB F+1 
      FDV P 
      FAD P 
      STA P 
      STB P+1 
      JSB .PWR2 
CHAR  OCT 0 
      JMP SQRT,I   ANS=(P+F/P)*2**CHAR
      SPC 1 
ODD   STA CHAR     CHAR=EXPO(X)/2 
      LDA F+1 
      IOR RMSK
      STA F+1      F=MANT(X)/2
      LDA F 
      LDB F+1 
      FMP A1
      FAD B1
      JMP BOTH     P=B1+A1*F
      SPC 1 
FAIL  JSB .ERRR 
      ASC 1,03
      ASC 1,UN
      CLA 
      CLB 
      JMP SQRT,I   ERROR, ANS=0 
      SPC 2 
      ORB 
A1    DEC .875
A2    DEC .578125 
B1    DEC .27863
B2    DEC .421875 
F     BSS 2 
LMSK  OCT 177400
P     BSS 2 
RMSK  OCT 377 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ALOG
      ENT LN,ALOG 
      EXT .FLUN,.MANT,FLOAT,.ERRR 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB ALOG (RESULT FLOATING) 
      SPC 1 
*      CALCULATES NATURAL LOG OF X. 
      SPC 2 
ALOG  NOP 
LN    EQU ALOG
      STA X 
      STB X+1 
      JSB .FLUN 
      JSB FLOAT 
      STA CHAR
      STB CHAR+1   CHAR=EXPO(X) 
      LDA X 
      LDB X+1 
      SZA 
      SSA          X<=0 ? 
      JMP FAIL     YES
      JSB .MANT 
      STA X 
      STB X+1      X=MANT(X)
      FAD R22 
      STA Z 
      STB Z+1      Z=X+SQRT(0.5)
      LDA X 
      LDB X+1 
      FSB R22 
      FDV Z 
      STA Z 
      STB Z+1      Z=(X-SQRT(0.5))/Z
      FMP Z 
      FSB C 
      STA X 
      STB X+1      X=Z**2-C 
      LDA MB
      LDB MB+1
      FDV X 
      FAD A 
      FMP Z 
      FAD MHLF
      FAD CHAR
      FMP LE2 
      JMP ALOG,I   ANS=LOG(2)*(CHAR-0.5+Z*(A-B/X))
      SPC 1 
FAIL  JSB .ERRR 
      ASC 1,02
      ASC 1,UN
      JMP ALOG,I
      SPC 2 
      ORB 
X     BSS 2 
CHAR  BSS 2 
R22   DEC .707106781  SQRT(0.5) 
LE2   DEC .6931471806 LOG BASE E OF 2 
Z     BSS 2 
A     DEC 1.2920070987
MB    DEC -2.6398577035 
C     DEC 1.6567626301
MHLF  DEC -.5 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T
      NAM WCSIO 
      EXT .IOC.,.ENTR 
      ENT WREAD,WWRIT 
* 
* WCS I/O UTILITY ROUTINE 
* 
*   CALLING SEQUENCE
* 
*        READ      WRITE
* 
*        JSB WREAD      JSB WWRIT 
*        DEF *+5        DEF *+4 
*        DEF UNIT       DEF UNIT
*        DEF BUFUR      DEF BUFUR 
*        DEF LONG        DEF LONG 
*        DEF ADRS 
* 
*   WHERE UNIT=DEVICE LOGICAL UNIT #
*   BUFUR=START ADDRESS OF CORE BUFUR 
*    LONG= THE NUMBER OF WORDS TO TRANSFER
*           (LONG>0 => # OF WCS WORDS (2 2100 WORDS)) 
*          LONG<0 => #OF 2100 WORDS 
*    ADRS = (READ ONLY) THE ADDRESS WHERE TO
*        START READ 
* 
AD1   DEF *+1       PARAMETER 
      BSS 4         TABLE  FOR READ.
WREAD NOP           RETURN ADDRESS
      JSB .ENTR     GET PARAMETERS
      LDA AD1       SET PARAMETER 
      STA ADR       TABLE ADDRESS 
      LDA .M10      SET CONTROL 
      STA CONWD     WORD FOR READ 
      LDA WREAD     SET RETURN
      STA WWRIT     IN WWRIT
      JMP *+11      GO PROCESS. 
AD2   DEF *+1       PARAMETER TABLE 
      BSS 3         FOR WRITE.
WWRIT NOP           RETURN ADDRESS
      JSB .ENTR     GET PARAMETERS
      LDA AD2       SET 
      STA ADR       ADDRESS 
      LDA .M20      SET CONTROL 
      STA CONWD     WORD FOR WRITE
      LDA ADR,I     PICK UP 
      LDA 0,I       UNIT #
      IOR CONWD     SET 
      STA CONWD     CONTROL WORD. 
      ISZ ADR       PICK UP 
      LDA ADR,I     BUFUR 
      STA BUFAD     ADDRESS.
      ISZ ADR       PICK
      LDA ADR,I     UP
      LDB 0,I       COUNT.
      SSB,RSS       IF NEGATIVE 
      JMP *+3 
      CMB,INB       MAKE
      BRS           POSITIVE
      LDA CONWD     ARE 
      AND .M10      WE
      SZA,RSS       READING?
      JMP *+9 
      LDA 1         YES PUT COUNT IN A
      AND M377      MASK OF LOWER 8 BITS
      ISZ ADR       PICK
      LDB ADR,I     UP
      LDB 1,I       START ADDRESS 
      ALF,ALF       SHIFT COUNT HIGH
      IOR 1         OR IN ADDRESS 
      LDB 0         PUT PARAMETER IN B-REG. 
      STB PRAMS     STORE 
      JSB .IOC.     CALL
CONWD NOP           .IOC. 
      JMP *-2       TO
BUFAD NOP           DO
PRAMS NOP           I/O 
      JMP WWRIT,I   RETURN
.M10  OCT 10000 
.M20  OCT 20000 
M377  OCT 377 
ADR   NOP 
      END 

ASMB,R,B,L,T,C
      NAM SICOS 
      ENT SIN,COS 
      EXT .ERRR,.CHEB,.IENT,.PWR2,FLOAT,..FCM 
      SPC 3 
*      CALL.. 
      SPC 1 
*     DLD X    (FLOATING,RADIANS) 
*      JSB SIN  (RESULT FLOATING) 
      SPC 1 
*      CALCULATE SINE(X). 
      SPC 2 
SIN   NOP 
      FMP TOPI
      STA X 
      STB X+1      X=2*X/PI 
      FAD K1
      JSB .PWR2 
      DEC -2
      JSB .IENT 
      JMP FAIL     ERROR IF EXPO(X) >=15
      JSB FLOAT 
      FMP M4
      FAD X 
      STA X 
      STB X+1      X=X-4*ENTIER((X+1)/4). 
      FSB K1
      SSA          X<1 ?
      JMP PAST     YES
      LDA K2
      LDB K2+1
      FSB X 
      STA X 
      STB X+1      X=2-X
PAST  LDA X 
      LDB X+1 
      FMP X 
      JSB .PWR2 
      DEC 1 
      FSB K1
      JSB .CHEB 
      DEF COEFF 
      FMP X 
      JMP SIN,I    ANS=X*CHEBY(2*X**2-1)
      SPC 1 
FAIL  JSB .ERRR 
      ASC 2,05OR
      JMP SIN,I 
      SPC 3 
*      CALL.. 
      SPC 1 
*     DLD X     (FLOATING,RADIANS)
*     JSB COS   (RESULT FLOATING) 
      SPC 1 
*      CALCULATES COSINE(X) = -SINE(X-PI/2).
      SPC 2 
COS   NOP 
      FAD MP2 
      JSB SIN 
      JSB ..FCM 
      JMP COS,I 
      SPC 2 
      ORB 
X     BSS 2 
TOPI  DEC .636619772  2/PI
K1    DEC 1.
K2    DEC 2.
M4    DEC -4. 
COEFF DEC 1.18496E-6
      DEC -1.365875E-4
      DEC 9.118016E-3 
      DEC -.2852615692
      DEC 2.5525579248
      OCT 0 
MP2   DEC -1.57079633  -PI/2
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM CHEBY 
      ENT .CHEB 
      SPC 3 
*      CALL.. 
      SPC 1 
*      DLD X         (FLOATING) 
*      JSB .CHEB     (RESULT FLOATING)
*      DEF C         (TABLE OF CHEBY. COEFF'S., FLOATING) 
      SPC 2 
.CHEB NOP 
      STA X2
      STB X2+1     X2=X 
      FAD X2
      STA X2
      STB X2+1     X2=2*X 
      LDA .CHEB,I 
      STA C        C POINTS TO COEFFICIENT TABLE
      DLD C,I       GET FIRST COEFF.
      STA D 
      STB D+1       D=C(N)
      CLA 
      STA B 
      STA B+1       B=0 
LOOP  ISZ C 
      ISZ C         N=N-1 
      LDA C,I 
      SZA,RSS       C(N)=0 ?
      JMP OUT       ZERO FLAGS END OF TABLE 
      LDA B         NO
      LDB B+1 
      STA A 
      STB A+1       A=B 
      LDA D 
      LDB D+1 
      STA B 
      STB B+1       B=D 
      FMP X2
      FSB A 
      FAD C,I 
      STA D 
      STB D+1       D=C(N)-A+B*X2 
      JMP LOOP
      SPC 1 
OUT   LDA D 
      LDB D+1 
      FSB A 
      FMP HLF 
      ISZ .CHEB 
      JMP .CHEB,I   ANS=(D-A)/2 
      SPC 2 
      ORB 
X2    BSS 2 
C     BSS 1 
D     BSS 2 
B     BSS 2 
A     BSS 2 
HLF   DEC .5
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM SIGN
      ENT SIGN
      EXT ..FCM 
      SPC 3 
*      CALL.. 
      SPC 1 
*      JSB SIGN (RESULT FLOATING) 
*      DEF A    (FLOATING)
*      DEF B    (FLOATING OR INTEGER) 
      SPC 1 
*      CALCULATES  SIGNUM(B)*ABS(A) . 
      SPC 2 
SIGN  NOP 
      LDA SIGN,I
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      DLD A,I       LOAD "A". 
      STB T 
      ISZ SIGN
      LDB SIGN,I
      LDB 1,I      PICK UP SIGN(B)
      ISZ SIGN
      SZA 
      SZB,RSS      A=0 OR B=0 ? 
      JMP CLEAR    YES
      SSB          B<0 ?
      JMP NEG      YES
      SSA          A<0 ?
      JMP COMP     YES
OK    LDB T 
      JMP SIGN,I   ANS=A
      SPC 1 
NEG   SSA           A < 0?
      JMP OK        YES.
COMP  LDB T 
      JSB ..FCM 
      JMP SIGN,I   ANS=-A 
      SPC 1 
CLEAR CLA 
      CLB 
      JMP SIGN,I   ANS = 0. 
      SPC 2 
      ORB 
T     OCT 0 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ABS 
      ENT ABS 
      EXT ..FCM 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB ABS
      SPC 1 
*      ABS RETURNS WITH ABS(X) IN A/B.
      SPC 2 
ABS   NOP 
      SSA,RSS      X>=0 ? 
      JMP ABS,I    YES, ANS=X 
      JSB ..FCM 
      JMP ABS,I    ANS=-X 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ..FCM     FLOATING COMPLEMENT 
      ENT ..FCM 
      EXT ..DLC 
      SPC 3 
..FCM NOP 
      STA A         STORE ARGUMENT
      STB A+1 
      JSB ..DLC     LOAD COMPLEMENTED 
      DEF A 
      JMP ..FCM,I 
      SPC 2 
      ORB 
A     BSS 2 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ..DLC     DOUBLE LOAD COMPLEMENT
      ENT ..DLC 
      SPC 3 
..DLC NOP 
      LDA ..DLC,I   GET ADDRESS OF ARGUMENT 
      ISZ ..DLC     BUMP RETURN ADDRESS 
      STA ARG 
      CLA           SUBTRACT
      CLB            FROM 
      FSB ARG,I       ZERO
      JMP ..DLC,I   RETURN
      SPC 2 
      ORB 
ARG   BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM FADSB 
      ENT .FAD,.FSB 
      EXT .FLUN,.PACK 
      SPC 3 
.FAD   NOP           ENTRY FOR FLOATING ADD.
      JSB UNPAK     GET ARGUMENTS UNPACKED
      JMP ADMUP     GO TO COMMON SECTION
      SPC 2 
.FSB   NOP           ENTRY FOR FSB. EXIT FOR FAD/FSB. 
      JSB UNPAK      GET ARGUMENTS UNPACKED.
      LDA A2
      CMA           DOUBLE LENGTH TWOS COMPLEMENT.
      CMB,INB,SZB   IF LOW PART NOT ZERO, THEN ALL
      JMP OK          DONE. 
      SSA,INA,RSS   OTHERWISE BUMP A. IF A WAS NEGA-
      SSA,RSS        TIVE, AND REMAINS SO,
      JMP OK
      RAR             THEN SHIFT IT DOWN &
      ISZ X2           BUMP THE EXPONENT. 
OK    STB B2
      STA A2
      SPC 1 
*                   COMMON SECTION
      SPC 1 
ADMUP ISZ .FSB       BUMP RETURN ADDRESS. 
      LDA X2        COMPUTE EXPONENT DIFFERENCE.
AGAIN CMA,INA 
      ADA X1
      SSA,RSS       IF ARG1 IS LARGER, GO TO ADD
      JMP ADDEM       SECTION.
      LDA A1        OTHERWISE, EXCHANGE THE ARGS. 
      LDB A2
      STA A2
      STB A1
      LDA B1
      LDB B2
      STA B2
      STB B1
      LDA X1
      LDB X2
      STB X1
      STA X2
      JMP AGAIN 
      SPC 1 
ADDEM ADA M25       IF SHIFT COUNT IS 25 OR MORE, 
      LDB B1
      SSA,RSS         THEN IGNORE SMALLER ARGUMENT. 
      JMP TAKIT 
      CMA,CLE       GET SHIFT COUNT AS NEGATIVE.
      ADA M25 
      STA X2         AND STORE IN X2. 
      LDA A2        LOAD SMALLER
      LDB B2          MANTISSA. 
LOOP  ISZ X2        ANY MORE SHIFTS?
      JMP SHIFT      YES--GO TO SHIFT SECTION.
      SPC 1 
* DOUBLE ADD SECTION *
      SPC 1 
      ADB B1        ADD IN LOW PART.
      CLO 
      SEZ           IF LOW PART ADD OVERFLOWED, THEN
      CLE,INA        BUMP HIGH PART.
      SOS           IF NO OVERFLOW, GO ADD
      JMP *+5        IN HIGH PART.
      ADA A1        OTHERWISE ADD IN HIGH PART HERE.
      SSA,RSS       IF A BECOMES +, THEN A1<0 AND 
      JMP DONE       WE HAVE MADE UP FOR THE OVFLOW.
      JMP *+4       IF A<0, GO HANDLE THE OVERFLOW. 
      ADA A1        ADD IN HIGH PART. 
      SOS           IF IT OVERFLOWED, 
      JMP DONE
      ERA            ROTATE DOWN. 
      ERB 
      ISZ X1          AND BUMP EXPONENT.
      JMP DONE
      RSS 
TAKIT LDA A1
DONE  JSB .PACK 
X1    BSS 1 
      JMP .FSB,I
      SPC 1 
SHIFT CLE,SLA,ARS   2 REGISTER ARITHMETIC SHIFT 
      CME 
      ERB,CLE 
      JMP LOOP
      SPC 2 
UNPAK NOP           UNPACKING SECTION 
      STA A1        SAVE HIGH PART OF ARG1
      SZA,RSS 
      CLB,INB 
      JSB .FLUN 
      STB B1        SAVE LOW PART OF ARG1 
      STA X1        SAVE EXP. OF ARG1 
      LDA UNPAK     GET ADDRESS OF CALLING ROUTINE
      ADA M2        A=FAD OR FSB. 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I       GET ADRESS OF ARGUMENT. 
      STA .FSB       STORE IN EXIT LOCATION.
      LDA A,I 
      DLD A,I       GET SECOND ARGUMENT 
      STA A2        SAVE HIGH PART
      SZA,RSS 
      CLB,INB 
      JSB .FLUN 
      STB B2        SAVE LOW PART 
      STA X2        SAVE EXP
      JMP UNPAK,I 
      SPC 2 
      ORB 
A1    BSS 1 
B1    BSS 1 
A2    BSS 1 
B2    BSS 1 
X2    BSS 1 
M25   DEC -25 
M2    DEC -2
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM PTAPE 
      HED ***  MAGNETIC TAPE POSITIONING ROUTINE  ***        (JRW)
      ENT PTAPE 
      EXT .IOC.,.ENTR 
      SPC 3 
*     CALLING SEQUENCE -
      SPC 1 
*         CALL PTAPE(UNIT, #FILES, #RECORDS)
      SPC 1 
*         UNIT - EQT ORDINAL FOR IOC CALL 
      SPC 1 
*         # FILES - > 0 FOR FORWARD 
*                   < 0 FOR REVERSE 
      SPC 1 
*         # RECORDS - > 0 FOR FORWARD 
*                     < 0 FOR REVERSE 
      SPC 1 
*                   (FILE MARK ENCOUNTERED DURING RECORD
*                    SPACING COUNTS AS ONE RECORD)
      SPC 1 
*     A BACKSPACE FILE LEAVES THE TAPE AT THE BEGINNING 
*      OF THE FILE. 
      SPC 1 
*     CROSSING OVER "SOT" OR "EOT" CAUSES IMMEDIATE RETURN TO USER. 
      SPC 2 
UNIT  NOP 
FILES DEF ZERO
RECS  DEF ZERO
PTAPE NOP           ** ENTRY POINT ** 
      JSB .ENTR     TRANSFER
      DEF UNIT        PARAMETERS
      LDA UNIT,I    ISOLATE EQT ORDINAL 
      SZA 
      SSA 
      JMP EXIT      ERROR; RETURN.
      AND B77       ISOLATE THE UNIT-REFERENCE #. 
      IOR =B010100  FORM: BINARY READ REQUEST.
      STA FSR       SET FORWARD SPACE COMMAND 
      XOR =B020300  FORM: BACKSPACE RECORD REQUEST. 
      STA BSR       SET BACKSPACE COMMAND 
      XOR =B000200
      STA STAT
      STA DSTAT     SET STATUS CALL 
      LDA RECS,I
      STA RECS      STORE THE RECORD COUNT. 
      LDB FILES,I   GET FILE COUNT
      JSB ABS       SET-UP TO SPACE FILES 
      JMP P.1       # FILES = 0, DO RECORDS 
SFILE JSB SPACE     GO SPACE ONE(1) FILE. 
      JMP SFILE     GO SKIP UNTIL "EOF" ENCOUNTERED.
      ISZ UNIT      HAVE ALL FILES BEEN SKIPPED?
      JMP SFILE     NO, CONTINUE. 
      LDA FILES,I   LOAD THE FILE COUNT REQUEST.
      SSA           FORWARD DIRECTION?
      ISZ RECS      NO, BACKWARD MOTION.
      RSS           PROCESS RECORDS.
      JMP EXIT      NO RECORDS, EXIT. 
P.1   LDB RECS      LOAD THE RECORD SKIP COUNT. 
      JSB ABS 
      JMP EXIT      NO RECORDS, EXIT
SRCRD JSB SPACE     GO SKIP ONE(1) RECORD.
B40   CLE           COUNT THE "EOF" AS ONE(1) RECORD. 
      ISZ UNIT      HAVE ALL RECORDS BEEN SKIPPED?
      JMP SRCRD     NO, CONTINUE. 
EXIT  LDA DZERO      RE-INITIALIZE THE PARAMETERS.
      STA FILES      STORE DEFINITION OF ZERO.
      STA RECS
      JMP PTAPE,I    RETURN.
      SPC 2 
SPACE NOP 
      LDA BSR       LOAD BACKSPACE RECORD COMMAND.
      CPA CMAND     IS CURRENT COMMAND BACKSPACE? 
      JMP BSP.M     YES, GO PROCESS BACKWARD MOTION.
WAIT  JSB .IOC.     CHECK TAPE STATUS 
STAT  OCT 030000     DYNAMIC STATUS REQUEST CODE. 
      SSA           IS THE MT UNIT BUSY?
      JMP WAIT      YES, GO WAIT FOR MT READY.
      AND B40       ISOLATE THE "EOT" STATUS BIT. 
      SZA 
      JMP EXIT      "EOT" EXIT, RETURN IMMEDIATELY. 
BSP.M JSB .IOC.     SPACE 
CMAND NOP 
      JMP BSP.M     REJECT ADDRESS. 
      RSS           SKIP (BUFFER ADDRESS DEFINITION). 
ZERO  OCT 000000    ZERO(0) BUFFER LENGTH REQUEST.
      LDA FSR       LOAD FORWARD SPACE COMMAND. 
      CPA CMAND     IS TAPE MOTION FORWARD? 
      LDA SPACE,I   LOAD RECORD RETURN INSTRUCTION. 
      CPA B40       IS THE MT STATUS NECESSARY? 
      JMP SPACE,I   NO, RETURN. 
SOT.F JSB .IOC.     GO GET THE MT UNIT STATUS.
DSTAT OCT 030000    DYNAMIC TAPE STATUS 
      RAL,SLA        END-OF-OPERATION?
      JMP SOT.F     NO, CONTINUE. 
      ALF,ALF        SHIFT "SOT" BIT TO 15. 
      SSA            "SOT" ENCOUNTERED? 
      JMP EXIT      SOT EXIT
B77   CLE,SLA,ALF   WAS AN "EOF" ENCOUNTERED? 
      ISZ SPACE 
      JMP SPACE,I 
      SPC 2 
ABS   NOP           SET-UP ROUTINE
      LDA FSR       FORWARD SPACE COMMAND 
      SSB           IF # IS < 0 
      LDA BSR       BACKSPACE COMMAND 
      STA CMAND 
      SSB,RSS       GET -ABS(#) FOR CNT 
      CMB,INB,SZB   IS THE SKIP COUNT ZERO(0)?
      ISZ ABS       NO, SKIP EXIT.
      STB UNIT      STORE THE NEGATIVE SKIP COUNT.
      JMP ABS,I 
      SPC 2 
      ORB 
FSR   NOP 
BSR   NOP 
DZERO DEF ZERO
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM INDEX 
      ENT .INDA,.INDR 
      EXT .IOC.,ENDIO 
      SPC 3 
*  .INDA AND .INDR ARE USED BY THE ALGOL COMPILER 
*  IN ORDER TO ACCESS ARRAY ELEMENTS.  .INDA PRODUCES 
*  THE ABSOLUTE ADDRESS OF AN ARRAY ELEMENT, WHEREAS
*.INDR PRODUCES THE VALUE STORED IN THAT LOCATION.
*  THE CALLING SEQUENCE TO THESE ROUTINES IS: 
      SPC 1 
*     JSB .INDA OR .INDR
*     DEF ARRAY TABLE 
*     ABS -NUMBER OF INDICES
*     DEF INDEX1
*     ..... 
*     DEF INDEX N 
      SPC 1 
*  THE ARRAY TABLE FOR A GIVEN ARRAY HAS THE FORM:
      SPC 1 
* TABLE ABS NUMBER OF INDICES (+=REAL, -=INTEGER) 
*       ABS SIZE OF 1ST DIM 
*     ABS -LOWER BOUND OF 1ST DIM 
*     ..... 
*     ABS SIZE OF LAST DIM
*     ABS -LOWER BOUND OF LAST DIM
      SPC 2 
.INDA NOP 
      LDA .INDA 
      JSB GETAD 
      JMP T,I 
      SPC 2 
.INDR NOP 
      LDA .INDR 
      JSB GETAD 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDB A 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I 
      INB 
      LDB B,I 
      JMP T,I 
      SPC 2 
* GETAD IS THE ROUTINE THAT DOES ALL THE WORK. THE
* COMPUTATION OF THE LOCATION IS DONE AS FOLLOWS: 
      SPC 1 
*         M_INDEX[1]-LB[1]; 
*         FOR I_2 STEP 1 UNTIL NUMBEROFINDICES DO 
*           M_SIZE[I]*M+INDEX[I]-LB[I]; 
*         IF REAL ARRAY THEN M_2*M. 
*         ADDRESS_M+BASE
      SPC 2 
GETAD NOP 
      STA T        SAVE POINTER TO INDICES. 
      LDA T,I      GET ADDRESS OF ARRAY TABLE 
      RAL,CLE,SLA,ERA    TEST FOR INDIRECT. 
      LDA A,I      RELOAD IF INDIRECT 
      STA TABLE    SAVE TABLE ADDRESS 
      LDA TABLE,I  BET # OF INDICES FROM TABLE
      STA MODE     SAVE IN MODE FOR LATER USE.
      ISZ T        BUMP T TO POINT AT ACTUAL COUNT. 
      SSA,RSS      SET COUNT IN CALLING SEQUENCE
      CMA,INA       NEGATIVE
      STA COUNT      AND SAVE IN COUNT
      CPA T,I      MAKE SURE COUNT AGREES 
      JMP CNTOK    THEY DO--WE CAN CONTINUE 
      SPC 1 
* ILLEGAL ARRAY REFERENCE*
      SPC 1 
ERROR ISZ T        FIXUP FOR CORRECT RETURN 
      ISZ COUNT REPOSITION FOR
      JMP ERROR      PROPER RETURN
      JSB .IOC.    PRINT ERROR MESSAGE
      OCT 20002 
      JMP *-2 
      DEF FLAG
      DEC -6
      JSB ENDIO     WAIT FOR ALL I/O COMPLETION.
      DEF *+1       RETURN ADDRESS DEFINITION.
      LDA T     DISPLAY LOCATION OF EVIL
      HLT 00B 
      CLA 
      CLB 
BACK ISZ T
      JMP GETAD,I 
      SPC 1 
FLAG  ASC 3,INDEX?
      SPC 1 
CNTOK ISZ TABLE    POINT TABLE TO FIRST SIZE
      CLA          CLEAR M INITIALLY. 
LOOP  STA M 
      LDA TABLE,I  GET DIMENSION SIZE 
      CMA,INA      AS NEGATIVE
      STA SIZE
      ISZ TABLE    POINT AT LOWER BOUND 
      LDA TABLE,I  GET LOWER BOUND
      ISZ T        ADD IN 
      LDB T,I      INDEX
      ADA B,I 
      SSA          TEST FOR LEGAL 
      JMP ERROR+1  ERROR INDEX TOO LOW
      STA B        SAVE IN B
      ADA M        ADD TO INDEX 
      ADB SIZE
      SSB,RSS 
      JMP ERROR+1  ERROR-INDEX TOO HIGH 
      ISZ COUNT    TEST FOR DONE
      JMP MULT     NO--GO DO A MULTIPLY 
      LDB MODE     TEST MODE
      SSB,RSS      IF + (REAL)
      ALS          DOUBLE M 
      ISZ TABLE 
      ADA TABLE,I  ADD IN BASE ADDRESS
      JMP BACK
      SPC 1 
MULT  ISZ TABLE 
      MPY TABLE,I 
      JMP LOOP
      SPC 2 
      ORB 
T     BSS 1 
TABLE BSS 1 
MODE  BSS 1 
COUNT BSS 1 
M     EQU .INDA 
SIZE  EQU .INDR 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
     NAM .RTOI
      ENT .RTOI 
      EXT .ERRR 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      JSB .RTOI     (RESULT FLOATING)
*      DEF BASE      (FLOATING) 
*      DEF POWER     (INTEGER)
      SPC 1 
*      CALCULATES BASE**POWER 
      SPC 2 
.RTOI NOP 
      LDA .RTOI,I 
      STA BASE
      DLD BASE,I   PICK UP BASE 
      STA BASE
      STB BASE+1
      ISZ .RTOI 
      LDB .RTOI,I 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I       LOAD THE POWER. 
      ISZ .RTOI 
      SZA,RSS      BASE=0 ? 
      JMP BZER     YES
      SZB,RSS      POWER=0 ?
      JMP PZER     YES
      LDA E1
      STA F 
      LDA E1+1
      STA F+1      F=1.0
      STB SGN      SAVE SIGN OF POWER 
      SSB 
      CMB,INB      USE ABS(POWER) 
      STB PWR 
LOOP  LDB PWR 
      SLB,BRS      POWER=POWER/2
      JMP MUL      LOW ORDER BIT WAS ONE
      STB PWR 
TEST  SZB          TEST FOR POWER=0 
      JMP SQR      NO 
      LDA SGN 
      SSA          WAS POWER<0 ?
      JMP INVS     YES, ANS=1/F 
      LDA F        NO, ANS=F
      LDB F+1 
      JMP .RTOI,I 
      SPC 1 
INVS  LDA E1
      LDB E1+1
      FDV F 
      JMP .RTOI,I 
BZER  SZB 
      SSB          POWER <=0 ?
CALL  JMP ERR      YES, ERROR 
      CLB          NO, ANS=0
      JMP .RTOI,I 
      SPC 1 
PZER  LDA E1       ANS=1
      LDB E1+1
      JMP .RTOI,I 
      SPC 1 
MUL   STB PWR 
      LDA BASE
      LDB BASE+1
      FMP F 
      STA F 
      STB F+1      F=F*BASE 
      LDB PWR 
      JMP TEST
SQR   LDA BASE
      LDB BASE+1
      FMP BASE
      STA BASE
      STB BASE+1   BASE=BASE**2 
      JMP LOOP
      SPC 1 
ERR   JSB .ERRR 
      ASC 1,06
      ASC 1,UN
      CLA 
      JMP CALL+1   ERROR, RETURN WITH ANS=0 
      SPC 2 
      ORB 
E1    DEC 1.
BASE  BSS 2 
PWR   BSS 1 
F     BSS 2 
SGN   BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .ITOI 
      ENT .ITOI 
      EXT .ERRR 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      JSB .ITOI     (RESULT INTEGER) 
*      DEF BASE      (INTEGER)
*      DEF POWER     (INTEGER)
      SPC 1 
*      CALCULATES  BASE**POWER. 
      SPC 2 
.ITOI NOP 
      LDA .ITOI,I 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I       LOAD THE BASE.
      STA BASE
      ISZ .ITOI 
      LDB .ITOI,I 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I       LOAD THE POWER. 
      STB PWR 
      ISZ .ITOI 
      SZA,RSS      BASE=0 ? 
      JMP BZER     YES
      SZB,RSS      POWER=0 ?
      JMP PZER     YES
      CPA E1       BASE=1 ? 
      JMP .ITOI,I  YES, ANS=1 
      CPA EM1      BASE=-1 ?
      RSS           YES, SKIP.
      JMP L2
      LDA B 
      AND E1
      ALS 
      CMA,INA 
      INA 
      JMP .ITOI,I  ANS=1-2*(LOW BIT OF POWER) 
      SPC 1 
L2    SSB          BASE<0 ? 
      JMP ZER      YES
      CLA,INA 
      STA F        F=1
LOOP  LDB PWR 
      SLB,BRS      POWER=POWER/2
      JMP MUL      LOW ORDER BIT WAS ONE
      STB PWR 
TEST  SZB          POWER=0 ?
      JMP SQR      NO 
      LDA F 
      JMP .ITOI,I  ANS=F
      SPC 1 
BZER  SZB 
      SSB          POWER<=0 ? 
      RSS           YES.
      JMP ZER 
      JSB .ERRR 
      ASC 1,08
      ASC 1,UN
ZER   CLA 
      JMP .ITOI,I  ANS=0
      SPC 1 
PZER  CLA,INA 
      JMP .ITOI,I  ANS=1
      SPC 1 
MUL   STB PWR 
      LDA BASE
      MPY F 
      STA F        F=F*BASE 
      JSB OFLO     TEST FOR OVERFLOW. 
      LDB PWR 
      JMP TEST
      SPC 1 
SQR   LDA BASE
      MPY BASE
      STA BASE     BASE=BASE**2 
      JSB OFLO     TEST FOR OVERFLOW
      JMP LOOP
      SPC 2 
OFLO  NOP          B SHOULD EXTEND SIGN OF A
      SSA          A<0 ?
      INB          YES, B SHOULD BE -1
      SZB,RSS      B=0 ?
      JMP OFLO,I   YES
      JSB .ERRR 
      ASC 1,08
      ASC 1,OF
      JMP ZER 
      SPC 2 
      ORB 
E1    DEC 1 
EM1   DEC -1
BASE  BSS 1 
PWR   BSS 1 
F     BSS 1 
      ORR 
      SPC 1 
      END 

ASMB,R,B,L,T,C
      NAM .PRAM 
      ENT .PRAM 
      SPC 3 
*         ******************************************************
*         * .PRAM - PROCESS AND SET PARAMETER VALUES AND/OR    *
*         *        ADDRESSES IN THE PROCEDURE PARAMETER LINKG. *
*         *                                                    *
*         *   LINKAGE:                                         *
*         *        JSB .PRAM                                   *
*         *        (CODE WORDS)                                *
*         *        1ST PARAMETER ADDRESS OR VALUE(REAL=2WORDS) *
*         *        2ND PARAMETER ADDRESS OR VALUE(REAL=2WORDS) *
*         *        :       :         :          :              *
*         *        LAST PARAMETER ADDRESS OR VALUE             *
*         *                                                    *
*         *        CODE WORDS:                                 *
*         *                                                    *
*         *        1ST: UPPER 6 BITS CONTAINS NO. OF PARAMTRS. *
*         *             LOWER 10 BITS CONTAIN FLAGS FOR EACH OF*
*         *             1ST 5 PARAMETERS IN PAIRS OF BITS.     *
*         *              UPPER=1, PARAMETER IS BY VALUE.       *
*         *              LOWER=1, PARAMETER VALUE IS REAL.     *
*         *                                                    *
*         *             IF UPPER BIT=0, THE LINKAGE CONTAINS   *
*         *              THE PARAMETER ADDRESS(IGNORE LOWER).  *
*         *                                                    *
*         *             IF UPPER BIT=1,THE LINKAGE CONTAINS    *
*         *              THE PARAMETER VALUE.                  *
*         *                                                    *
*         *             IF BOTH BITS=1, THE VALUE IS REAL AND  *
*         *              THE VALUE WILL NEED 2 WORDS IN THE    *
*         *              LINKAGE.                              *
*         *                                                    *
*         *        SUBSEQUENT CODE WORDS:                      *
*         *             CONTAIN 8 PAIRS OF BITS FOR 8 PARAMETRS*
*         *                                                    *
*         *        MAXIMUM OF 7 CODE WORDS(52 PARAMETERS).     *
*         ******************************************************
      SPC 2 
.PRAM NOP          ENTRY TO .PRAM HERE
      LDA *-1 PICK UP ENTRY ADDRESS + 1 
      STA ADDRA    SET LOC'N OF 1ST CODE WORD 
      INA 
      STA ADDRL    SET LOC'N OF 1ST PARAMETER ADDRESS 
*                                  OR VALUE(TO BE BUMPED ACCORDING
*                                  TO NO. OF PARAMETERS, +1 FOR 5 
*                                  PARAMETERS, 1 MORE FOR EACH SUB- 
*                                  SEQUENT MULTIPLE OF 8.). 
      ADA M3       GET ADDRESSOF PARAM, COUNT 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDB A,I      GET PROCEDURE'S RETURN 
      ADB BIT15      ADDRESS AND MAKE IT
      STB A,I           INDIRECT. 
      ELB,CLE,ERB  NOW REMOVE THE INDIRECT BIT. 
      INB 
      STB ADDRP    SET PICKUP LOC'N OF ACTUAL PAR-
*                                  AMETER ADDRESSES(IN .PROC LINKG) 
      SPC 1 
*         * GET NUMBER OF PARAMETERS FROM 1ST CODE WORD. *
      SPC 1 
      LDA ADDRA,I  GET 1ST CODE WORD FROM LINKAGE 
      ALF,RAL 
      RAL          ROTATE PARAM COUNT TO LOWER 6 BITS 
      AND M77      NOW A REG. = PARAMETER COUNT 
      SPC 1 
      SZA,RSS      ARE THERE ANY PARAMETERS?
      JMP ADDRL,I  NO, EXIT THE .PRAM ROUTINE HERE..
      SPC 1 
      STA CNTR     SAVE PARAMETER COUNT 
      ADA M6       START SKIP OF ADDRL PAST ALL CODE
      SSA            WORDS..  IS IT PAST THEM?
      JMP PRM10    YES, GO TO PARAMETER MOVE/SETUP
      SPC 1 
      ISZ ADDRL    NO, BUMP ADDRL BY 1
      ADA M8       REDUCE A BY 8(1 SET OF CODE WORDS) 
      JMP *-4      GO BACK TO TEST AGAIN..
      SPC 2 
*         * PLACE  INITIAL CODE WORD INTO A REG. AND POSITION IT *
*         * INITIALIZE CODE COUNTER(CODES) AND PARAMETER COUN-   *
*         *  TER(CNTR).                                          *
      SPC 1 
PRM10 LDA ADDRA,I  GET INITIAL CODE WORD
      ALF,RAL      ROTATE CODE PAIRS TO INITIAL PON 
      LDB M5
      STB CODES    SET CODE COUNTER FOR 5 PAIRS 
      LDB CNTR     GET PARAMETER COUNTER
      CMB,INB 
      STB CNTR     COMPLEMENT IT FOR COUNTING 
      SPC 2 
*         * PROCESS PARAMETER ADDRESS OR VALUE ACCORDING TO CODE WRD
      SPC 1 
PRM15 LDB ADDRP,I  PICK UP PARAMETER ADDRESS
      RBL,CLE,SLB,ERB  IF IT'S DIRET, SKIP NEXT INSTR.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I      IF IT'S INDIRECT GET THE DIRECT
      SPC 1 
*         *      PARAMETER ADDRESS NOW IN B REG.  * 
      SPC 1 
      RAL,RAL      REPOSITION CODE PAIR 
      SPC 1 
      SLA,RSS      IS CURRENT PARAMETER A VALUE?
      JMP PRM25    NO, IT'S AN ADDRESS... 
      SPC 1 
      STB T        ADDRESS OF VALUE TO T
      LDB T,I      GET THE VALUE..
      SPC 1 
      SSA,RSS      IS THE VALUE REAL? 
      JMP PRM25    NO, IT'S AN INTEGER
      SPC 1 
      STB ADDRL,I  STORE 1ST PART OF REAL VLUE
      ISZ ADDRL    BUMP LINKAGE ADDRESS 
      ISZ T        BUMP ADDRESS OF VALUE
      LDB T,I      GET 2ND PART OF RAEL VALUE.
      SPC 2 
PRM25 STB ADDRL,I  STORE IT IN THE LINKAGE
      ISZ ADDRL BUMP .PRAM LINKAGE ADDRESS
      ISZ ADDRP    BUMP PARAM LOC'N IN PROCED LINK. 
      SPC 1 
      ISZ CNTR     IS FINAL PARAMETER PROCESSED?
      RSS          NO, SKIP TO CONTINUE 
      JMP ADDRL,I  YES,  EXIT FROM .PRAM HERE.... 
      SPC 2 
      ISZ CODES    LAST PAIR IN CODE WORD OUT?
      JMP PRM15     NO, GO BACK AND CONTINUE..
      SPC 1 
      LDA M8       YES, GET -8 FOR RESETTING
      STA CODES    RESET CODES FOR 8 PAIRS
      ISZ ADDRA    BUMP CODE WORD POINTER 
      LDA ADDRA,I  GET CURRENT CODE WORD
      RAR          POSITION IT FOR PROCESSING 
      JMP PRM15    GO BACK AND CONTINUE  CHECKING.. 
      SPC 2 
*         *   DATA AND TEMPORARY AREA  *
      SPC 1 
      ORB 
ADDRA NOP          LOC'N OF CODE WORD IN .PRAM LINK.
ADDRL NOP          LOC'N OF PARAM ADDR IN .PRAM LINK
ADDRP NOP          LOC'N OF ACTUAL PARAMETER ADDR.
CODES NOP          CODE COUNTER FOR CODE PAIRS IN 
*                                  CODE WORD... 
CNTR  NOP          PARAMETER COUNTER(# OF PROC.PARAMS.) 
T     NOP          TEMPORARY FOR VALUE LOCATIONS
      SPC 1 
BIT15 OCT 100000
M3    DEC -3
M5    DEC -5
M6    DEC -6
M8    DEC -8
M77   OCT 77
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM FDV 
      ENT .FDV
      EXT .FLUN,.PACK 
      SPC 3 
* ENTER WITH DIVIDEND IN A&B--SEE FDV WRITEUP FOR ALGORITHM.
      SPC 2 
.FDV   NOP
      STA A         SAVE HIGH PART OF DIVIDEND. 
      JSB .FLUN     UNPACK LOW PART 
      STA EXPON     SAVE EXPON. 
      STB B         SAVE LOW PART OF DIVIDEND MANT. 
      LDA .FDV,I     GET ADDRESS OF DIVISOR.
      ISZ .FDV       BUMP RETURN ADDRESS. 
      DLD 0,I       GET DIVISOR.
      SZA,RSS       TEST FOR DIVIDE BY ZERO 
      JMP DVZRO 
      STA C         SAVE HIGH PART OF DIVISOR.
      JSB .FLUN     UNPACK LOW PART.
      STB D         SAVE LOW PART OF DIVISOR MANT.
      CMA,INA       COMPUTE EXPONENT DIFFERENCE 
      INA             PLUS 1
      ADA EXPON 
      STA EXPON         & STORE.
      LDA B         GET DOUBLE LENGTH DIVIDEND
      LDB A           IN REGISTERS. 
      CLE,SLB,BRS   ARITHMETIC
      CME             RIGHT SHIFT 
      ERA               TWICE TO
      CLE,SLB,BRS         PREVENT 
      CME                   DIVISION
      ERA                     OVERFLOW. 
      DIV C         PERFORM FIRST DIVISION. 
      STA Q         SAVE FIRST QUOTIENT.
      BRS           DIVIDE REMAINDER BY 2 TO PRE- 
      CLA             VENT DIVISION OVERFLOW. 
      DIV C         PERFORM SECOND DIVISION.
      STA Q1        SAVE LOW PART OF QUOTIENT.
      LDB D         NOW COMPUTE D/C.
      CLA,CLE 
      ERB,BRS       SCALE TO PREVENT OVERFLOW.
      BRS 
      DIV C         OBTAIN Q2.
      CMA,INA       COMPUTE -Q*Q2.
      MPY Q 
      BLS,CLE,ELB   SHIFT 2 & GET SIGN TO E.
      LDA Q1        TEST SIGN OF Q1.
      SSA          IF NEGATIVE, SET A 
      CCA,RSS       TO -1 AS EXTENSION OF Q1. 
      CLA           OTHERWISE SET TO 0 AS POS. EXTENSION. 
      CMA,SEZ      IF E IS SET ALSO, SUBTRACT 1 MORE
      INA           AS EXTENSION OF PRODUCT.
      CMA,CLE        CLEAR E FOR FOLLOWING TEST.
      ADB Q1
      SEZ           IF ADD OVERFLOWS, 
      INA           CARRY INTO A. 
      CLE,ELB       NOW LONG SHIFT TO POSITION
      ELA              FOR FINAL ADDITION.
      ADA Q 
NORM  JSB .PACK       PACK RESULT 
EXPON BSS 1 
      JMP .FDV,I     RETURN 
      SPC 1 
DVZRO LDA INF1
      STA EXPON 
      JMP NORM
      SPC 2 
      ORB 
A     BSS 1 
B     BSS 1 
C     BSS 1 
D     BSS 1 
Q     EQU A 
Q1    EQU B 
INF1  OCT 70000 
     ORR
      SPC 1 
* MEM.REQ.=66 
* TIME= 1230-1470 MUSEC.
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM FMP 
      ENT .FMP
      EXT .FLUN,.PACK 
      SPC 3 
* ENTER WITH MULTIPLICAND IN A&B--SEE FMP WRITEUP 
* FOR ALGORITHM.
      SPC 2 
.FMP   NOP
      STA A1        SAVE HIGH PART OF MULTIPLICAND. 
      JSB .FLUN     UNPACK LOW PART.
      STA EXPON     SAVE EXPONENT.
      RBR           POSITION LOW PART AND SAVE
      STB B1
      LDA .FMP,I     GET ADDRESS OF MULTIPLIER. 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      DLD A,I       GET MULTIPLIER. 
      STA A2        SAVE HIGH PART
      JSB .FLUN     UNPACK LOW PART 
      ADA EXPON     ADD TO MULTIPLIER EXPONENT
      INA              AND ADD 1. 
      STA EXPON     PUT BACK. 
      RBR           POSITION LOW PART.
      STB A         PUT IN A REGISTER 
      MPY A1        COMPUTE FIRST CROSS PRODUCT.
      STA B2        SAVE RESULT 
      LDA B1          AND COMPUTE 
      STB B1            SECOND CROSS
      MPY A2              PRODUCT.
      ADB B1        ADD THE 2 CROSS PRODUCTS. 
      CLE 
      ADA B2
      SEZ           TEST FOR CARRY IN LOW PART. 
      INB 
      STB B2        SAVE HIGH PART OF RESULT. 
      LDA A1        COMPUTE HIGH PART OF
      MPY A2          PRODUCT.
      CLE,ERA       POSITION LOW PART.
      ADA B2        ADD IN CROSS TERMS. 
      CLE,ELA       REPOSITION
      SEZ,RSS       TEST FOR OVERFLOWS: IF E=1, ADD 
      JMP *+4        1 TO B IF OVERFLOW OCCURRED, -1
      SOC            IF NOT.
      INB,RSS 
      ADB M1
      STA A1        EXCHANGE REGISTERS
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B 
      LDB A1
      JSB .PACK     NORMALIZE AND PACK
EXPON BSS 1 
      ISZ .FMP
      JMP .FMP,I     RETURN 
      SPC 2 
      ORB 
A1    BSS 1 
A2    BSS 1 
B1    BSS 1 
B2    BSS 1 
M1    DEC -1
      ORR 
      SPC 1 
* MEM.REQ.=53 
* TIME= 640-750 MUSEC.
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .MAP.     COMPUTES ADDRESS OF ARRAY ELEMNT
      ENT .MAP. 
      SPC 3 
.MAP. NOP 
      LDA .MAP.,I   GET BASE ADDRESS OF ARRAY.
      RAL,CLE,SLA,ERA       REMOVE INDIRECT BIT 
      LDA 0,I 
      STA A 
      ISZ .MAP. 
      CCA 
      LDB .MAP.,I       GET FIRST DIM.-1
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      ADA B,I 
      STA I 
      ISZ .MAP. 
      CCA 
      LDB .MAP.,I 
      ADA B,I 
      STA J 
      ISZ .MAP. 
      LDA .MAP.,I   GET DIM1
      SSA           GET ABSOLUTE VALUE. 
      CMA,INA 
      MPY J 
      ADA I 
      LDB .MAP.,I   IF DIMENSION IS 
      SSB,RSS        POSITIVE, DOUBLE FOR A 
      ALS             REAL ARRAY
      ADA A         ADD BASE ADDRESS. 
      ISZ .MAP. 
      JMP .MAP.,I   RETURN
      SPC 2 
      ORB 
A     BSS 1 
I     BSS 1 
J     BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .IENT 
      ENT .IENT 
      EXT IFIX,.FLUN,FLOAT
      SPC 3 
*     CALL..
      SPC 1 
*     DLD X    (FLOATING) 
*     JSB .IENT     (RESULT INTEGER)
*     JMP ERROR     (EXIT IF EXPO(X)>14)
      SPC 1 
*     CALCULATES GREATEST INTEGER NOT 
*     EXCEEDING X.
      SPC 2 
.IENT NOP 
      STA X 
      STB X+1 
      JSB .FLUN 
      ADA M15 
      SSA,RSS      EXPO(X)>14 ? 
      JMP .IENT,I   X TOO LARGE TO FIX
      ISZ .IENT    NO 
      LDA X 
      LDB X+1 
      JSB IFIX
      STA ANS      ANS =FIX(X)
      JSB FLOAT 
      CPA X        IS X "INTEGER" ? 
      JMP TESTB    MAYBE
SUB   LDA ANS       X NOT "INTEGER" 
      LDB X 
      SSB      IF X<0, THEN 
      ADA M1        ANS=FIX(X)-1
      JMP .IENT,I 
      SPC 1 
TESTB LDA ANS 
      CPB X+1      IS X "INTEGER" ? 
      JMP .IENT,I   X "INTEGER",USE FIX(X)
      JMP SUB+1     NO
      SPC 2 
      ORB 
M15   DEC -15 
M1    DEC -1
X     BSS 2 
ANS   BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM FLOAT 
      ENT FLOAT 
      EXT .PACK 
      SPC 3 
* CALL WITH INTEGER IN A. 
* RETURN WITH FLOATING POINT EQUIVALENT IN A & B. 
      SPC 2 
FLOAT NOP 
      CLB           SET UP AS FLOATING POINT UNNOR- 
      JSB .PACK 
      DEC 15
      JMP FLOAT,I   RETURN
      SPC 1 
* MEM.REQ.=10 
* TIME=59-180 CYCLES
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .PACK 
      ENT .PACK 
      SPC 3 
* ENTER WITH A SIGNED 31 BIT MANTISSA IN A&B. 
* EXIT WITH A FLOATING POINT, NORMALIZED, NUMBER IN A&B.
      SPC 1 
*   CALL:      JSB .PACK
*            X BSS 1   (CONTAINS EXPONENT)
*              <RETURN POINT>  X MAY BE CHANGED 
      SPC 2 
.PACK NOP     ENTRY POINT 
      STA A     SAVE A REGISTER.
      CLA 
      STA EXPON   SET EXPON TO ZERO.
      LDA A 
      SZA,RSS    IF A AND B ARE BOTH ZERO 
      SZB           RETURN IMMEDIATELY. 
      JMP NORML    ELSE GO TO NORMALIZING SECTION.
BACK  CLO        CLEAR OVERFLOW FOR GOOD RETURN.
      ISZ .PACK     BUMP RETURN ADDRESS PAST X. 
      JMP .PACK,I  RETURN 
      SPC 1 
* NORMALIZING SECTION * 
      SPC 1 
SHIFT ISZ EXPON   COUNTS # OF LEFT SHIFTS.
NORML CLE,ELB     ROTATE A&B LEFT INTO E. 
      ELA 
      SEZ,SSA,RSS TEST THE ORIGINAL 2 HIGH BITS.
      JMP SHIFT   BOTH WERE 0--# WAS +UNNORMALIZED. 
      SEZ,SSA 
      JMP SHIFT   BOTH WERE 1--# WAS -    " 
      ERA         UNDO THE SHIFT, PRODUCING A 
      ERB,CLE      NORMALIZED MANTISSA. 
      SPC 1 
* ROUNDING SECTION *
      SPC 1 
      ADB .177      ADD IN SUFFICIENT ROUND FOR NEG-
      SSA,RSS        ATIVE NUMBERS. 
      INB           IF POSITIVE, 1 MORE IS NECESSARY. 
      CLO           CLEAR TO TEST FOR A-REG. OVFLOW.
      SEZ           TEST FOR OVERFLOW OUT OF B. 
      CLE,INA           IF SO, BUMP A REGISTER. 
      SOS           IF THE BUMP CAUSES OVERFLOW,, 
      RAL            SKIP THIS SHIFT (A=100000,B=0).
      SSA,SLA,RSS   TEST FOR TOP 2 BITS=1.
      JMP *+3 
      SPC 1 
* THIS LAST TEST IS NECESSARY TO OBTAIN THE CORRECT RESULT
* WHEN THE UNROUNDED MANTISSA WAS 101...1 AND A ROUND OCCURRED, 
* PRODUCING 110...0, WHICH IS UNNORMALIZED. THIS IS THE RESULT
* WE HAVE IF WE GET HERE. 
      SPC 1 
      ISZ EXPON BECAUSE WE ARE GOING TO SHIFT LEFT. 
      ARS,SLA,ALS PRODUCES A=10...0 AND SKIPS.
      RAR           UNDOES THE RAL ABOVE. 
      SPC 1 
* AT THIS POINT, A&B ARE NORMALIZED&ROUNDED, AND THE
* TRUE EXPONENT IS .PACK,I-EXPON(+1 IF OVFF=1). 
      SPC 1 
      STA A         SAVE A REGISTER.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B         REMOVE LOW ORDER 8 BITS OF B. 
      AND MASKH 
      STA B 
      LDA EXPON     COMPUTE TRUE EXPONENT AS DESCRIBED
      CMA,INA 
      ADA .PACK,I 
      SOC         ADD 1 MORE IF OVERFLOW OCCURRED 
      INA 
      ADA P200      TEST FOR EXPONENT UNDERFLOW.
      SSA 
      JMP XUNDR 
      ADA M400      TEST FOR EXPONENT OVERFLOW
      SSA,RSS 
      JMP XOVER 
      ADA P200      RESTORE ORIGINAL EXPONENT.
      RAL            POSITION SIGN TO LSB.
      AND MASKL     MASK TO 8 BITS. 
      ADB 0         PACK INTO B.
      LDA A        RESTORE HIGH PART
      JMP BACK
      SPC 1 
* OVERFLOW UNDERFLOW SECTION *
      SPC 1 
XUNDR CLA           RETURN ZERO FOR UNDERFLOW.
      CLB 
      JMP SETOV 
      SPC 1 
XOVER LDA INF1      RETURN +INFINITY FOR OVERFLOW 
      LDB INF2
SETOV STO           SET OVERFLOW FLAG FOR OVERFLOW
      JMP BACK+1       OR UNDERFLOW.
      SPC 2 
      ORB 
EXPON BSS 1 
A     BSS 1 
.177  OCT 177 
P200  OCT 200 
M400  OCT -400
MASKL OCT 377 
MASKH EQU M400       (177400) 
INF1  OCT 77777 
INF2  OCT 177776
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM LEADR 
      HED ***  PAPER TAPE LEADER/TRAILER GENERATOR  ***      (JRW)
      ENT LEADR 
      EXT .IOC.,.ENTR 
      SPC 3 
*     CALLING SEQUENCE: 
*        CALL LEADR(UNIT, # OF INCHES)
      SPC 2 
UNIT  NOP 
INCH  NOP 
LEADR NOP           ENTRY POINT 
      JSB .ENTR     TRANSFER PARAMETERS 
      DEF UNIT
      LDA INCH,I    GET THE # OF INCHES 
      CMA,INA,SZA,RSS 
      JMP LEADR,I   EXIT IF = 0 
      STA CNT 
      LDA UNIT,I    FORM IOC FUNCTION CALL
      SZA 
      SSA 
      JMP LEADR,I   ERROR; RETURN.
      AND B77 
      IOR BWRIT 
      STA *+2 
L.1   JSB .IOC.     CALL TO OUTPUT ONE INCH 
      OCT 20104     IOC FUNCTION CODE 
      JMP *-2       RETRY IF REJECTED 
      DEF BUF 
      DEC 3         ONE INCH BUFFER 
      ISZ CNT       DONE? 
      JMP L.1       NO, WRITE ANOTHER INCH
      JMP LEADR,I   YES, EXIT 
      SPC 2 
BUF   REP 3 
      NOP 
      SPC 1 
      ORB 
CNT   NOP 
B77   OCT 000077
BWRIT OCT 020100
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .ENTR     SETS PARAMETER
      ENT .ENTR       ADDRESSES.
      SPC 3 
*     CALLING SEQUENCE: 
*              SUBR NOP 
*                   JSB .ENTR 
*                   DEF *-2-M (M=# OF FORMAL PARAMETERS)
      SPC 1 
*              CALL JSB SUBR
*                   DEF *+1+N (N=# OF ACTUAL PARAMETERS)
*              ARG1 
*               ... 
*              ARGN 
      SPC 2 
.ENTR NOP 
      LDB .ENTR,I   B=SUBR-M=FIRST F.P. ADDRESS.
      STB DEST
      CMB,CCE       B=M-SUBR-1
      ADB .ENTR     B=M+1 
      STB MPLS1 
      ADB DEST      B=SUBR+1
      ADB MIN1      B=SUBR
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       A=CALL+1=FIRST A.P. ADDRESS-1 
      STA SORCE 
      RAL,ERA       A=CALL+1,I
      STA 1,I       SETS INDIRECT BIT IN RETURN ADR.
      RAL,CLE,ERA   A=CALL+1
      CMA,INA       A=-CALL-1 
      ADA SORCE,I   A=N+1 
      STA B         B=N+1 
      CMA,INA       A=-N-1
      ADA MPLS1     A=M-N 
      SSA 
      LDB MPLS1     B=MIN(M,N)+1
      ISZ .ENTR     BUMP RETURN ADDRESS.
      CMB,INB       B=-MIN(M,N)-1 
LOOP  INB,SZB,RSS   ANY MORE PARAMETERS?
      JMP .ENTR,I   NO--RETURN. 
      ISZ SORCE     ADVANCE TO POINT TO NEXT F.P. 
      LDA SORCE     GET FORMAL PARAMETER ADDRESS. 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
INDIR LDA A,I 
      RAL,CLE,SLA,ERA TEST IBIT AND CLEAR 
      JMP INDIR     INDIRECT
      STA DEST,I    STORE AS ACTUAL PARAMETER 
      ISZ DEST      MOVE A.P. POINTER.
      JMP LOOP
      SPC 2 
      ORB 
MIN1  DEC -1
DEST  BSS 1 
SORCE BSS 1 
MPLS1 BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ENTIE 
      ENT ENTIE,.RND
      SPC 3 
* THE ENTIER AND ROUND ROUTINES ARE USED FOR CONVERTING 
* FLOATING POINT NUMBERS TO INTEGERS.  THEY ARE DEFINED AS
*  FOLLOWS: 
      SPC 1 
*     ENTIER(X) = MAX (N ! N<= X) 
*     .RND(X) = ENTIER (X+.5) 
      SPC 1 
*     IF THE RESULT OVERFLOWS, 77777 OR 100000 IS RETURNED. 
      SPC 2 
ENTIE NOP 
      STA T        SAVE HIGH PART OF REAL # 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      STB A        MOVE LOW PART TO A.
      AND .377     ISOLATE EXPONENT 
      SLA,RAR       EXTEND
      IOR XSEXP    EXPONENT.
      ADA MIN16    COMPUTE -SHIFT-1 
      SSA,RSS      IF NOT NEGATIVE, THE 
      JMP OVER      CONVERSION OVERFLOWS. 
      ELB          FORCE E TO EQUAL THE FIRST BIT 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      STA B        SHIFTED OUT. 
      LDA T        GET FRACTION BACK IN A.
      ISZ B        TEST FOR END OF COUNT (ISZ IS
      RSS          USED TO PRESERVE E REGISTER) 
      JMP ENTIE,I  RETURN---ALL DONE
      CLE,SLA,ARS  RIGHT SHIFT& 
      CME            RESET E REGISTER.
      JMP *-5 
      SPC 1 
OVER  LDA MAX      RETURN LARGEST INTEGER 
      LDB T           WITH CORRECT SIGN 
      CLE,SSB      FOR OVERFLOW 
      CMA 
      JMP ENTIE,I 
      SPC 3 
.RND  NOP 
      JSB ENTIE    DO ENTIE FIRST 
      SEZ    IF E IS SET, WE ROUND BY 
      INA          ADDING ONE TO THE ENTIER RESULT. 
      JMP .RND,I
      SPC 2 
      ORB 
T     BSS 1        TEMP STORAGE 
.377  OCT 377      USED TO MASK OFF EXPONENT
XSEXP OCT 77600    USED TO FILL IN NEGABITS FOR - EXPS
MIN16 DEC -16 
MAX   OCT 77777 
      ORR 
      SPC 1 
      END 

ASMB,R,B,L,T,C
      NAM MPY 
      ENT .MPY
      SPC 3 
* ENTER WITH MULTIPLICAND IN A. 
      SPC 1 
*     CALL:    MPY M
      SPC 1 
* RETURN WITH A*M IN A&B, B=HIGH PART, A=LOW PART.
      SPC 2 
.MPY   NOP
      STB B         SAVE THE "B" REGISTER.
      CLB,INB       ENTER: B=1. 
      CMB           SET SIGN TO -2,ASSUMING 
      STB SIGN        POSITIVE. 
      ERB           SHIFT "E" INTO SIGN BIT OF "B". 
      STB E         STORE -1 OR 077777B.
      LDB .MPY,I     GET ADDRESS OF MULTIPLIER. 
      STB ADRES     STORE THE ADDRESS.
      LDB B         RESTORE THE "B" REGISTER. 
      LDB ADRES,I   GET MULTIPLIER (CAN BE A REG.)
      CLE,SSA       IS A NEGATIVE ? 
      CMA,CME,INA   YES--MAKE POSITIVE&COMPLEMENT E.
      SSB           SAME TEST FOR B.
      CMB,CME,INB 
      SEZ           IF RESULT IS NEGATIVE,
      ISZ SIGN       BUMP SIGN TO -1. 
      ISZ .MPY       BUMP RETURN ADDRESS. 
      STB B         SAVE MULTIPLIER 
      CLB           INITIALIZE PRODUCT TO ZERO. 
      CLE,SLA       SHIFT,TEST&ADD SEQUENCE.
      ADB B 
      ERB            1
      ERA,CLE,SLA 
      ADB B 
      ERB            2
      ERA,CLE,SLA 
      ADB B 
      ERB            3
      ERA,CLE,SLA 
      ADB B 
      ERB            4
      ERA,CLE,SLA 
      ADB B 
      ERB            5
      ERA,CLE,SLA 
      ADB B 
      ERB            6
      ERA,CLE,SLA 
      ADB B 
      ERB            7
      ERA,CLE,SLA 
      ADB B 
      ERB            8
      ERA,CLE,SLA 
      ADB B 
      ERB            9
      ERA,CLE,SLA 
      ADB B 
      ERB           10
      ERA,CLE,SLA 
      ADB B 
      ERB           11
      ERA,CLE,SLA 
      ADB B 
      ERB           12
      ERA,CLE,SLA 
      ADB B 
      ERB           13
      ERA,CLE,SLA 
      ADB B 
      ERB           14
      ERA,CLE,SLA 
      ADB B 
      ERB           15
      ERA,CLE,SLA 
      ADB B 
      ERB           16
      ERA 
      ISZ SIGN      TEST FOR RESULT NEGATIVE. 
      JMP *+4       NO. 
      CMB           DOUBLE LENGTH COMPLEMENT. 
      CMA,INA,SZA,RSS 
      INB 
      CLO 
      CCE           ENTER: E=1. 
      ISZ E         WAS THE "E" REGISTER SET ON?
      CLE           NO, ENTER: E=0. 
      JMP .MPY,I
      SPC 2 
      ORB 
ADRES NOP           MULTIPLIER ADDRESS. 
SIGN  BSS 1 
B     BSS 1 
E     BSS 1         "E" REGISTER FLAG WORD. 
      ORR 
      SPC 1 
* MEM.REQ.=72 
* TIME= 58-97 CYCLES (DEPENDS ON # OF 1 BITS IN ABS(MULTIPLICAND))
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM DIV 
      ENT .DIV
      SPC 3 
* ENTER WITH DOUBLE LENGTH DIVIDEND IN B&A. 
* RETURN WITH INTEGER QUOTIENT IN A & B REMAINDER IN B
      SPC 2 
.DIV   NOP
      STB TEMP      SAVE HIGH DIVIDEND
      CLB,INB       ENTER: B=1. 
      CMB           ENTER: B=-2.
      STB SIGN      INITIALIZE
      STB RSIGN       SIGNS.
      ERB           SHIFT "E" INTO SIGN BIT OF "B". 
      STB E         STORE: -1 OR 077777B. 
      LDB .DIV,I     GET ADDRESS OF DIVISOR.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I       GET DIVISOR.
      ISZ .DIV       BUMP RETURN ADDRESS. 
      CCE,SZB,RSS   ZERO(0) DIVISOR?
      JMP OVFLO 
      CLE,SSB       SET B TO ABS(B) AND E TO SIGN 
      CMB,CME,INB    (B)
      STB PLUSD     STORE POSITIVE DIVISOR
      CMB,INB 
      STB MIND      SAVE NEGATIVE DIVISOR.
      LDB M16       INITIALIZE
      STB COUNT       COUNTER.
      LDB TEMP
      SSB,RSS       TEST DIVIDEND SIGN. 
      JMP DIV1      DIVIDEND POSITIVE.
      ISZ RSIGN      SET RSIGN TO SAY NEGATIVE REM. 
      CMB,CME       COMPLEMENT THE DOUBLE LENGTH
      SZA             DIVIDEND & THE
      CMA,INA,RSS       E BIT 
      INB 
DIV1  SEZ           TEST QUOTIENT SIGN. IF NEGATIVE,
      ISZ SIGN       SET SIGN TO SAY NEG.QUOTIENT.
      ADB MIND    OVERFLOW? 
      CCE,SSB,RSS 
      JMP OVFLO 
      ADB PLUSD   NO--RESTORE DIVIDEND
LOOP  CLE,ELA       SHIFT 
      ELB 
      ADB MIND      TEST
      SSB,RSS 
      INA,RSS       DIVIDE O.K. 
      ADB PLUSD     NO DIVIDE 
      ISZ COUNT     ANY MORE ?
      JMP LOOP      YES 
      CMA,CCE,INA,SZA SET QUOTIENT TO NEGATIVE, 
      SSA             AND MAKE
      RSS              SURE THERE IS NO OVERFLOW. 
      JMP OVFLO 
      CLO 
      ISZ SIGN      IF POSITIVE,
      CMA,INA         TWO'S COMPLEMENT. 
      ISZ RSIGN      TEST FOR CORRECT QUOTIENT
      JMP OK           SIGN.
      CMB,INB,RSS 
OVFLO STO 
OK    ISZ E         WAS THE "E" REGISTER SET ON?
      CLE           NO, ENTER: E=0. 
      JMP .DIV,I
      SPC 2 
      ORB 
TEMP  BSS 1 
PLUSD BSS 1 
MIND  BSS 1 
M16   DEC -16 
COUNT BSS 1 
SIGN  BSS 1 
RSIGN BSS 1 
E     BSS 1         "E" REGISTER FLAG WORD. 
      ORR 
      SPC 1 
* MEM.REQ.=49 
* TIME=170-196 CYCLES 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM DLDST 
      ENT .DLD,.DST 
      EXT GETAD,ADRES 
      SPC 3 
.DLD  NOP           ENTRY POINT.
      JSB SAVEE     GO SAVE THE "E" REGISTER. 
      JSB GETAD     GET ADDRESS 
      DEF .DLD,I
      LDA .DLD      LOAD THE RETURN ADDRESS.
      STA .DST      STORE THE RETURN ADDRESS. 
      LDB ADRES     LOAD THE SOURCE ADDRESS.
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B,I       LOAD THE "A" REGISTER.
      CCE,INB       POINT TO "B" REGISTER ADDRESS.
      LDB B,I       LOAD THE "B" REGISTER.
      JMP R.E       GO RESTORE "E" AND RETURN.
      SPC 2 
.DST  NOP           ENTRY POINT.
      JSB SAVEE     GO SAVE THE "E" REGISTER. 
      JSB GETAD     GET ADDRESS.
      DEF .DST,I
      STA .DLD      SAVE THE "A" REGISTER.
      LDA ADRES     LOAD THE DESTINATION ADDRESS. 
      STA ADDRS     STORE THE "A" REGISTER ADDRESS. 
      CCE,INA       POINT TO "B" REGISTER ADDRESS.
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      STB A,I       STORE THE "B" REGISTER. 
      LDA .DLD      LOAD THE "A" REGISTER CONTENTS. 
      STA ADDRS,I   STORE THE "A" REGISTER. 
R.E   ISZ E         WAS THE "E" REGISTER SET ON?
      CLE           NO, ENTER: E=0. 
      ISZ .DST       BUMP RETURN ADDRESS. 
      JMP .DST,I
      SPC 2 
SAVEE NOP           ENTRY POINT.
      STA ADDRS     SAVE THE "A" REGISTER.
      CLA,SEZ       ENTER: A=0; IS "E" SET ON?
      CCA           YES, ENTER: A=-1. 
      STA E         STORE THE "E" REGISTER FLAG WORD. 
      LDA ADDRS     RESTORE THE "A" REGISTER. 
      JMP SAVEE,I   RETURN. 
      SPC 2 
      ORB 
ADDRS BSS 1         "A" REGISTER DESTINATION ADDRESS. 
E     BSS 1         "E" REGISTER FLAG WORD. 
      ORR 
      SPC 1 
* MEM.REQ.=30 
* TIME=39+9/INDIRECT LEVEL (CYCLES) 
      SPC 1 
      END 

ASMB,R,B,L,T,C
      NAM GETAD 
      ENT GETAD,ADRES 
      SPC 3 
GETAD NOP 
      STA TEMP      SAVE A
      LDA GETAD,I 
LOOP  STA ADRES 
      LDA TEMP      RESTORE A 
      LDA ADRES,I 
      RAL,CLE,SLA,ERA 
      JMP LOOP      INDIRECT ADDRESS. DO AGAIN
      STA ADRES 
      LDA TEMP      RESTORE A 
      ISZ GETAD     BUMP RETURN ADDRESS 
      JMP GETAD,I 
      SPC 2 
      ORB 
ADRES BSS 1 
TEMP  BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM IFIX
      ENT IFIX
      EXT .FLUN 
      SPC 3 
* CALL WITH FLOATING POINT NUMBER IN A&B. RETURN WITH 
* INTEGER EQUIVALENT IN A. IF OVERFLOW, SET OVFF AND
* RETURN 77777. 
      SPC 2 
IFIX  NOP 
      STA A         SAVE MANTISSA.
      JSB .FLUN     UNPACK TO GET EXP IN A. 
      CLO 
      SSA           IF EXPONENT NEGATIVE, GO TO 
      JMP UNFLO       RETURN ZERO.
      ADA M16       COMPUTE SHIFT COUNT.
      SSA,RSS       IF EXP 16 OR MORE,
      JMP OVFLO       OVERFLOW. 
      CLE,SZB       SET E TO 0 IFF B=0. 
      CME 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      STA B         SAVE   SHIFT  COUNT IN B. 
      LDA A 
LOOP  ISZ B         ANY MORE SHIFTS?
      JMP SHIFT    YES
      SEZ,SSA     IF NUMBER <0 & FRAC. NOT 0
      INA       BUMP RESULT 
      JMP IFIX,I
      SPC 1 
SHIFT SLA,ARS       SHIFT RIGHT & TEST BIT LOST.
      CCE           IF 1,SET E TO SAY FRACTION NOT 0
      JMP LOOP
      SPC 1 
UNFLO CLA 
      JMP IFIX,I
      SPC 1 
OVFLO LDA INFIN 
      STO           SET THE OVERFLOW REGISTER ON. 
      JMP IFIX,I
      SPC 2 
      ORB 
A     BSS 1 
M16   DEC -16 
INFIN OCT 77777 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ERR0
      HED ***  FTN OBJECT CODE COMPATIBILITY: ERR0  ***      (JRW)
      ENT ERR0
      SPC 3 
ERR0  NOP           ENTRY POINT.
      JMP ERR0,I    RETURN. 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM EXEC
      HED ***  FTN OBJECT CODE COMPATIBILITY: EXEC  ***      (JRW)
      ENT EXEC
      EXT .STOP 
      SPC 3 
EXEC  NOP           ENTRY POINT.
      LDA D6        LOAD: A=6.
      JSB .STOP     STOP 6
      SPC 2 
      ORB 
D6    DEC 6 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .PAUS 
      ENT .PAUS 
      EXT .IOC.,ENDIO 
      SPC 3 
.PAUS NOP 
      STA N         SAVE N
      JSB .IOC.     PRINT 
      OCT 20002 
      JMP *-2         PAUSE 
      DEF PAUSE 
      OCT -5          MESSAGE 
      JSB ENDIO 
      DEF *+1 
      LDA N         HALT WITH N IN
      HLT 00B           A REGISTER. 
      JMP .PAUS,I 
      SPC 1 
PAUSE ASC 3,PAUSE 
      SPC 2 
      ORB 
N     BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .STOP 
      ENT .STOP 
      EXT .IOC.,ENDIO,HALT
      SPC 3 
.STOP NOP 
      STA .STOP         SAVE N
      JSB .IOC.         PRINT 
      OCT 20002 
      JMP *-2             STOP
      DEF STOP
      OCT -4                MESSAGE 
      JSB ENDIO 
      DEF *+1 
      LDB .STOP 
      JMP HALT
      SPC 1 
STOP  ASC 2,STOP
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ISIGN 
      ENT ISIGN 
      SPC 3 
*      CALL.. 
      SPC 1 
*      JSB ISIGN     (RESULT INTEGER) 
*      DEF A         (INTEGER)
*      DEF B         (INTEGER OR FLOATING)
      SPC 1 
*      CALCULATES  SIGNUM(B)*ABS(A).
      SPC 2 
ISIGN NOP 
      LDA ISIGN,I 
      ISZ ISIGN 
      LDB ISIGN,I 
      ISZ ISIGN 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I      PICK UP A
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I      PICK UP B
      SZA 
      SZB,RSS      A=0 OR B=0 ? 
      JMP CLEAR    YES
      SSB          B<0 ?
      JMP NEG      YES
      SSA,RSS      A<0 ?
      JMP ISIGN,I  ANS=A
COMP  CLO 
      CMA,INA      A=-A 
      SOS          DID A=100000B ?
      JMP ISIGN,I  NO, ANS=A
      CMA 
      JMP ISIGN,I  ANS=77777B 
      SPC 1 
NEG   SSA          A<0 ?
      JMP ISIGN,I  YES, ANS=A 
      JMP COMP
      SPC 1 
CLEAR CLA 
      JMP ISIGN,I  ANS=0
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .ERRR 
      SPC 2 
* .ERRR - EXECUTION TIME ERROR ROUTINE
*          FOR THE MATH LIBRARY.
      SPC 1 
* PURPOSE: TO WRITE ON THE TELETYPE OUTPUT DEVICE 
*        AN ERROR CODE SUPPLIED BY THE
*        CALLING ROUTINE. AFTER THE ERROR 
*        MESSAGE OUTPUT IS INITIATED, CONTROL 
*        IS RETURNED TO THE CALLING ROUTINE.
      SPC 1 
* CALLING SEQUENCE: 
      SPC 1 
*         (P)      JSB  .ERRR 
*         (P+1)    ASC  1,XX
*         (P+2)    ASC  1,YY
*        (P+3)    -RETURN- A,B DESTROYED
      SPC 1 
*      WHERE: XX = 2 DIGIT CODE INDENTIFYING CALLING ROUTINE
*             YY = 2 LETTER MNEMONIC IDENTIFYING ERROR. 
      SPC 1 
*      THE FORMAT OF THE OUTPUT MESSAGE IS: 
      SPC 1 
*         XX  YY  (FOLLOWED BY RETURN/LINE-FEED)
      SPC 2 
      ENT .ERRR 
      EXT .IOC.,ENDIO 
      SPC 2 
.ERRR NOP 
      LDA .ERRR,I  GET - XX - CODE WORD,
      STA MSG1     SET IN MESSAGE BUFFER
      ISZ .ERRR    INDEX TO P+2 OF CALL.
      LDA .ERRR,I  GET - YY - WORD AND SET
      STA MSG3     IN WORD 4 OF BUFFER
.E1   JSB .IOC.    ISSUE CALL TO .IOC. TO 
      OCT 020006    WRITE A FOUR(4) WORD
      JMP .E1        BUFFER, ASCII MODE,
      DEF MSG          TELETYPE.
      DEC 5 
      JSB .IOC.     GO GET THE SYSTEM STATUS. 
      OCT 040000    SYSTEM STATUS REQUEST.
      SZB           IS THE SYSTEM BUFFERED? 
      JMP BUFFR     YES, DO NOT WAIT FOR COMPLETION.
WAIT  JSB .IOC. 
      OCT 040006
      STA STATT     SAVE THE DEVICE STATUS. 
      RAL,SLA       IS THE DEVICE BUSY? 
      JMP WAIT
      SSA,RSS       NO; IS THE DEVICE DOWN? 
      JMP BUFFR     NO, CONTINUE. 
      JSB .IOC.     YES, GO PRINT "*EQR" MESSAGE. 
      OCT 020002    WRITE REQUEST.
      JMP *-2       REJECT. 
      DEF EQMES     OUTPUT BUFFER ADDRESS DEFINITION. 
      OCT -4        BUFFER LENGTH.
      JSB ENDIO     WAIT FOR ALL I/O COMPLETION.
      DEF *+1       RETURN ADDRESS DEFINITION.
      LDA D6        LOAD THE DEVICE NUMBER. 
      LDB STATT     LOAD THE DEVICE STATUS. 
      HLT 06B       ALLOW OPERATOR TO READY DEVICE. 
      JMP .E1       GO RETRY THE ERROR MESSAGE. 
      SPC 1 
EQMES ASC 2,*EQR
      SPC 1 
BUFFR ISZ .ERRR    ADJUST RETURN TO P+3 AND 
      JMP .ERRR,I   - EXIT -
      SPC 1 
MSG   ASC 2,  E-      MESSAGE BUFFER
MSG1  ASC 2,00
MSG3  ASC 1,
      SPC 2 
      ORB 
STATT NOP           DEVICE STATUS WORD. 
D6    DEC 6 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM PWR2
      ENT .PWR2 
      EXT .FLUN 
      SPC 3 
*      CALLING SEQUENCE.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB .PWR2 (RESULT FLOATING)
*      DEC N    (INTEGER) 
      SPC 1 
*      PWR2 RETURNS WITH X*2**N IN A/B. 
*      NO CHECK IS MADE FOR EXPONENT
*      OVERFLOW OR UNDERFLOW. 
      SPC 2 
.PWR2 NOP 
      SZA,RSS      X=0 ?
      JMP RET      YES, ANS=0 
      STA T 
      STB T+1 
      JSB .FLUN 
      ADA .PWR2,I 
      RAL 
      AND RMSK     (NEW EXPO)=(OLD EXPO)+N
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      STA B 
      LDA T+1 
      AND LMSK
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      ADB A        KEEP OLD MANTISSA
      LDA T 
RET   ISZ .PWR2 
      JMP .PWR2,I 
      SPC 2 
      ORB 
T     BSS 2 
RMSK  OCT 377 
LMSK  OCT 177400
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .GOTO     COMPUTED GO TO
      ENT .GOTO 
      SPC 3 
.GOTO NOP 
      CCA           ENTER: A=-1.
      ADA .GOTO,I   GET MAXIMUM RETURN ADDRESS. 
      ISZ .GOTO 
      LDB .GOTO,I   GET SWITCH
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDB B,I        INDEX. 
      CMB,INB       TEST FOR LEQ 0
      CMB,SSB,INB   SKIP IF IT WAS OK 
      CLB,INB       SET TO 1 IF IT WASN'T 
      ADB .GOTO     GET DESTINATION ADDRESS 
      STB DEST
      CMB,INB       TEST FOR GEQ MAX ADDRESS
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      ADB A 
      SSB,RSS       IF B IS POSITIVE OR 0,
      LDA DEST       USE DEST 
      LDA A,I       NOW GET ADDRESS OF LABEL
      JMP A,I       PERFORM JUMP
      SPC 2 
      ORB 
DEST  BSS 1 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .SWCH 
      ENT .SWCH 
      SPC 3 
*         ************************************* 
*         * .SWCH - EXECUTE A SWITCH TEST AND * 
*         *         JUMP AS INDICATED.        * 
*         *                                   * 
*         *    A = VALUE OF SWITCH (1 TO NO.  * 
*         *        OF LABELS IN DECLARATION). * 
*         *                                   * 
*         *    IF A = 0 OR GRTR THAN NO. OF   * 
*         *       LABELS IN SWITCH CONTROL RE-* 
*         *       TURNS TO NEXT STATEMENT IN  * 
*         *       THE OBJECT PROGRAM          * 
*         ************************************* 
      SPC 2 
.SWCH NOP      =1ST LOC IN LINKAGE(LABEL COUNT) 
      SSA,RSS      SKIP IF COUNT IS NEGATIVE
      SZA,RSS       A = 0?
      JMP SWCHX     YES - BAD COUNT - RETURN
      LDB .SWCH,I   GET LABEL COUNT 
      CMB          MAKE LABELCOUNT+1 NEGATIVE 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      ADB A         B _ A+B 
      ADA .SWCH     POINT A REG. AT DESIRED LABEL 
      SSB          IS 'A' GREATER THAN LABEL COUNT? 
      JMP *+3       NO - JUMP TO DESIGNATED ADDRESS 
SWCHX LDA .SWCH    COMPUTE ADDRESS FOR ABNORMAL EXIT
      ADA MIN2     FROM SWITCH ROUTINE
      LDA A,I 
      JMP A,I      RETURN TO THAT ADDRESS 
      SPC 2 
      ORB 
MIN2  DEC -2
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .FLUN 
      ENT .FLUN 
      SPC 3 
* ENTER WITH B=LOW PART OF A FLOATING POINT NUMBER. 
* RETURN WITH A=EXPONENT,B=LOW MANTISSA.
      SPC 2 
.FLUN NOP 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B         MOVE ARGUMENT TO A
      AND MASKL         GET EXPONENT BITS 
      CMB               SUBTRACT
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      ADB A                FROM 
      CMB                      B
      SLA,RAR       POSITION & TEST SIGN. IF MINUS
      IOR XSEXP      PUT IN EXTRA BITS. 
      JMP .FLUN,I   RETURN
      SPC 2 
      ORB 
MASKL OCT 377 
XSEXP OCT 77600 
      ORR 
      SPC 1 
* MEM.REQ.=13 
*TIME=18 CYCLES.
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM MANT
      ENT .MANT 
      SPC 3 
*      CALL.. 
      SPC 1 
*      DLD X    (FLOATING)
*      JSB .MANT (RESULT FLOATING)
      SPC 1 
*      EXTRACTS MANTISSA(X).  -1< MANT(X) < +1 .
      SPC 2 
.MANT NOP 
      STA TEMP
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B 
      AND LMSK
      STA B 
      LDA TEMP
      JMP .MANT,I 
      SPC 2 
      ORB 
LMSK  OCT 177400
TEMP  OCT 0 
      ORR 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM IAND      AND ROUTINE 
      ENT IAND
      SPC 3 
IAND  NOP 
      LDA IAND,I    GET ADDRESS OF FIRST ARGUMENT 
      ISZ IAND
      LDB IAND,I    GET ADDRESS OF SECOND 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      AND B,I 
      ISZ IAND
      JMP IAND,I
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM IOR       OR ROUTINE
      ENT IOR 
      SPC 3 
IOR   NOP 
      LDA IOR,I 
      ISZ IOR 
      LDB IOR,I 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      LDA A,I 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      IOR B,I 
      ISZ IOR 
      JMP IOR,I 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM IABS
      ENT IABS
      SPC 3 
*      CALL.. 
      SPC 1 
*      LDA I    (INTEGER) 
*      JSB IABS (RESULT INTEGER)
      SPC 1 
*      CALCULATES ABS(I). 
      SPC 2 
IABS  NOP 
      SSA,RSS      A<0 ?
      JMP IABS,I   NO, ANS=A
      CMA,INA      A=-A 
      SSA          DID A=100000B ?
      CMA          YES, A=77777B
      JMP IABS,I   ANS=A
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM OVF       TEST FOR OVERFLOW 
      ENT OVF 
      SPC 3 
OVF   NOP 
      CLA           SET A TO 0 ASSUMING NO OVERFLOW 
      SOC C         IF THERE IS OVERFLOW, 
      CCA            SET THE SIGN BIT.
      JMP OVF,I 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ISSW
      ENT ISSW
      SPC 3 
*     RETURNS WITH THE SETTING OF THE SWITCH REGISTER IN A
*      ROTATED TO PUT THE IMAGE OF THE SWITCH TO BE TESTED
*      INTO THE SIGN POSITION - A(15) 
      SPC 2 
ISSW  NOP           FUNCTION SENSE SWITCH 
      CMA            CALL BY VALUE
SSW   EQU 01B       SENSE SWITCH REGISTER ADDRESS.
      LIB SSW        N = SWITCH # 
      RBR 
      INA,SZA 
      JMP *-2 
B     EQU 00001B    "B" REGISTER ADDRESS DEFINITION.
      LDA B 
      JMP ISSW,I
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM ENDIO 
      ENT ENDIO 
      EXT .IOC. 
      SPC 3 
*     THIS ROUTINE WAITS FOR ALL I/O TO FINISH
      SPC 2 
ENDIO NOP 
      JSB .IOC. 
      OCT 40000 
      SSA 
      JMP *-3 
      LDA ENDIO,I 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      JMP A,I 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM .TAPE 
      HED ***  FORTRAN MAGNETIC TAPE CALLING SEQUENCE  ***   (JRW)
      ENT .TAPE 
      EXT .IOC. 
      SPC 3 
*     THIS ROUTINE IS USED TO INITIATE TAPE OPERATIONS
*     FOR FORTRAN COMPILED PROGRAMS.
      SPC 2 
.TAPE NOP 
      STA *+2      ENTER WITH IOC REQUEST CODE IN A 
      JSB .IOC.    CALL FOR TAPE OPERATION
      NOP 
      JMP *-2      TRY AGAIN ON REJECT
      JMP .TAPE,I 
      SPC 1 
      END 
ASMB,R,B,L,T,C
      NAM CLRIO 
      HED ***  SYSTEM I/O CLEAR ROUTINE  ***                 (JRW)
      ENT CLRIO 
      EXT .IOC. 
      SPC 3 
*     THIS ROUTINE ISSUES A SYSTEM CLEAR REQUEST TO .IOC. 
      SPC 2 
CLRIO NOP 
      JSB .IOC. 
      NOP          CLEAR FUNCTIION CODE 
      LDA CLRIO,I 
A     EQU 00000B    "A" REGISTER ADDRESS DEFINITION.
      JMP A,I 
      SPC 1 
      END 
